This file describes changes to the nptl/ subdirectory prior to 2014-03-03.
Later nptl/ changes go into the top-level ChangeLog file, not here.



2014-02-28  Roland McGrath  <roland@hack.frob.com>

	* Makefile (generated-dirs): Use += rather than =.

2014-02-26  Joseph Myers  <joseph@codesourcery.com>

	* Makefile: Include Makeconfig immediately after defining subdir.

2014-02-21  Joseph Myers  <joseph@codesourcery.com>

	* Makefile ($(objpfx)tst-stack3-mem): Use $(evaluate-test).
	($(objpfx)tst-tls6.out): Likewise.
	($(objpfx)tst-cleanup0.out): Likewise.
	($(objpfx)tst-cleanup0-cmp.out): Likewise.
	($(objpfx)tst-cancel-wrappers.out): Likewise.
	($(objpfx)tst-oddstacklimit.out): Likewise.

2014-02-14  Joseph Myers  <joseph@codesourcery.com>

	* Makefile ($(objpfx)tst-cleanup0.out): Do not run cmp.
	[$(run-built-tests) = yes] (tests): Depend on
	$(objpfx)tst-cleanup0-cmp.out.
	($(objpfx)tst-cleanup0-cmp.out): New rule.

2014-02-10  Ondřej Bílka  <neleai@seznam.cz>

	* allocatestack.c (queue_stack, allocate_stack,
	__deallocate_stack, __reclaim_stacks): Use glibc_likely instead
	__builtin_expect.
	* cancellation.c (__pthread_enable_asynccancel,
	__pthread_disable_asynccancel): Likewise.
	* cleanup_defer.c (__pthread_register_cancel_defer,
	__pthread_unregister_cancel_restore): Likewise.
	* cleanup_defer_compat.c (_pthread_cleanup_push_defer,
	_pthread_cleanup_pop_restore): Likewise.
	* cond-perf.c (main): Likewise.
	* nptl-init.c (sigcancel_handler, sighandler_setxid): Likewise.
	* perf.c (get_clockfreq): Likewise.
	* pthread_barrier_destroy.c (pthread_barrier_destroy): Likewise.
	* pthread_barrier_init.c (pthread_barrier_init): Likewise.
	* pthread_cond_timedwait.c (__pthread_cond_timedwait): Likewise.
	* pthread_cond_wait.c (__pthread_cond_wait): Likewise.
	* pthread_create.c (__free_tcb, start_thread, __pthread_create_2_1):
	Likewise.
	* pthread_getattr_np.c (pthread_getattr_np): Likewise.
	* pthread_getspecific.c (__pthread_getspecific): Likewise.
	* pthread_join.c (pthread_join): Likewise.
	* pthread_key_delete.c (pthread_key_delete): Likewise.
	* pthread_mutex_init.c (__pthread_mutex_init): Likewise.
	* pthread_mutex_lock.c (__pthread_mutex_lock,
	__pthread_mutex_lock_full): Likewise.
	* pthread_mutex_timedlock.c (pthread_mutex_timedlock): Likewise.
	* pthread_mutex_trylock.c (__pthread_mutex_trylock): Likewise.
	* pthread_mutex_unlock.c (__pthread_mutex_unlock_usercnt): Likewise.
	* pthread_rwlock_rdlock.c (__pthread_rwlock_rdlock): Likewise.
	* pthread_rwlock_timedrdlock.c (pthread_rwlock_timedrdlock): Likewise.
	* pthread_rwlock_timedwrlock.c (pthread_rwlock_timedwrlock): Likewise.
	* pthread_rwlock_tryrdlock.c (__pthread_rwlock_tryrdlock): Likewise.
	* pthread_setcancelstate.c (__pthread_setcancelstate): Likewise.
	* pthread_setcanceltype.c (__pthread_setcanceltype): Likewise.
	* pthread_setschedprio.c (pthread_setschedprio): Likewise.
	* pthread_setspecific.c (__pthread_setspecific): Likewise.
	* sem_init.c (__new_sem_init): Likewise.
	* sem_open.c (__where_is_shmfs): Likewise.
	* sigaction.c: Likewise.
	* sockperf.c (get_clockfreq): Likewise.
	* sysdeps/pthread/createthread.c (do_clone, create_thread): Likewise.
	* sysdeps/pthread/setxid.h: Likewise.
	* sysdeps/pthread/timer_create.c (timer_create): Likewise.
	* sysdeps/pthread/unwind-forcedunwind.c (pthread_cancel_init,
	__unwind_freeres, _Unwind_Resume, __gcc_personality_v0,
	_Unwind_ForcedUnwind): Likewise.
	* sysdeps/unix/sysv/linux/getpid.c (__getpid): Likewise.
	* sysdeps/unix/sysv/linux/lowlevelrobustlock.c
	(__lll_robust_lock_wait, __lll_robust_timedlock_wait): Likewise.
	* sysdeps/unix/sysv/linux/mq_notify.c (mq_notify): Likewise.
	* sysdeps/unix/sysv/linux/powerpc/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/pthread_kill.c (__pthread_kill): Likewise.
	* sysdeps/unix/sysv/linux/pthread_setaffinity.c
	(__pthread_setaffinity_new): Likewise.
	* sysdeps/unix/sysv/linux/pthread_sigqueue.c (pthread_sigqueue):
	Likewise.
	* sysdeps/unix/sysv/linux/pt-raise.c (raise): Likewise.
	* sysdeps/unix/sysv/linux/raise.c (raise): Likewise.
	* sysdeps/unix/sysv/linux/s390/lowlevellock.h (__lll_robust_trylock,
	__lll_robust_lock, __lll_cond_lock, __lll_robust_timedlock): Likewise.
	* sysdeps/unix/sysv/linux/sparc/lowlevellock.h (__lll_lock,
	__lll_cond_lock, __lll_timedlock, __lll_robust_timedlock): Likewise.
	* sysdeps/unix/sysv/linux/sparc/pthread_barrier_destroy.c
	(pthread_barrier_destroy): Likewise.
	* sysdeps/unix/sysv/linux/sparc/pthread_barrier_init.c
	(pthread_barrier_init): Likewise.
	* sysdeps/unix/sysv/linux/sparc/sem_init.c (__new_sem_init): Likewise.
	* sysdeps/unix/sysv/linux/x86_64/timer_create.c (__timer_create_old):
	Likewise.
	* unwind.c (unwind_stop): Likewise.

2014-02-08  Mike Frysinger  <vapier@gentoo.org>

	* sem_open.c (__where_is_shmfs): Compare f.f_type to RAMFS_MAGIC too.

2014-02-05  Carlos O'Donell  <carlos@redhat.com>

	* sysdeps/unix/sysv/linux/tst-setgetname.c (do_test): Skip the
	test if !__ASSUME_PROC_PID_TASK_COMM and get_self_comm returns
	ENOENT.

2014-01-23  Stefan Liebler  <stli@linux.vnet.ibm.com>

	* tst-tls7.c: Adjust testcase timeout

2014-01-18  H.J. Lu  <hongjiu.lu@intel.com>

	[BZ #14782]
	* tst-cancel-wrappers.sh: Remove system.

2014-01-11  Paul Pluzhnikov  <ppluzhnikov@google.com>

	* tst-tls7.c (action): New function.
	(do_test): Call it.
	* tst-tls7mod.c (action): Move sem_post to caller.

2011-12-12  Adhemerval Zanella  <azanella@linux.vnet.ibm.com>

	* sysdeps/powerpc/tls.h (struct tcbhead_t): Add DSO and TAR fields.
	* nptl/sysdeps/powerpc/tcb-offsets.sym: Likewise.

2013-12-09  Carlos O'Donell  <carlos@redhat.com>

	* sysdeps/unix/sysv/linux/tst-setgetname.c: New file.
	* sysdeps/unix/sysv/linux/Makefile (tests): Add tst-setgetname.

2013-12-09  Andreas Schwab  <schwab@suse.de>

	[BZ #15843]
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_timedwait.S
	(__pthread_cond_timedwait): Remove wrong cfi_adjust_cfa_offset
	before __condvar_tw_cleanup2 label.

2013-12-04  Ulrich Weigand  <Ulrich.Weigand@de.ibm.com>

	* sysdeps/unix/sysv/linux/powerpc/powerpc64/sysdep-cancel.h
	(CANCEL_FRAMESIZE, CANCEL_PARM_SAVE): New macros to save parameters
	into our own stack frame instead of the caller's.
	(PSEUDO): Use them.  Use symbolic stack frame offsets.
	(DOCARGS_1, UNDOCARGS_1): Use CANCEL_PARM_SAVE.
	(DOCARGS_2, UNDOCARGS_2): Likewise.
	(DOCARGS_3, UNDOCARGS_3): Likewise.
	(DOCARGS_4, UNDOCARGS_4): Likewise.
	(DOCARGS_5, UNDOCARGS_5): Likewise.
	(DOCARGS_6, UNDOCARGS_6): Likewise.

2013-11-26  Ondřej Bílka  <neleai@seznam.cz>

	* sysdeps/i386/tls.h: Use __glibc_reserved instead __unused.
	* sysdeps/x86_64/tls.h: Likewise.

2013-11-25  Paul Pluzhnikov  <ppluzhnikov@google.com>

	[BZ #11214]
	* Makefile (tst-getpid2-ENV): New variable.

2013-11-20  Paul Pluzhnikov  <ppluzhnikov@google.com>

	* Makefile (tst-cleanup2, tst-cleanupx2): Add -fno-builtin

2013-10-30  Mike Frysinger  <vapier@gentoo.org>

	* sysdeps/pthread/configure.in: Moved to ...
	* sysdeps/pthread/configure.ac: ... here.
	* sysdeps/x86_64/configure.in: Moved to ...
	* sysdeps/x86_64/configure.ac: ... here.
	* sysdeps/pthread/configure: Regenerated.
	* sysdeps/x86_64/configure: Likewise.

2013-10-04  Maciej W. Rozycki  <macro@codesourcery.com>

	* tst-mutex8.c (check_type) [ENABLE_PI]: Handle ENOTSUP failure
	from pthread_mutex_init.

2013-10-01  Siddhesh Poyarekar  <siddhesh@redhat.com>

	[BZ #15988]
	* pthread_cond_broadcast.c (__pthread_cond_broadcast)
	[lll_futex_cmp_requeue_pi && __ASSUME_REQUEUE_PI]: Use
	USE_REQUEUE_PI.
	* pthread_cond_signal.c (__pthread_cond_signal)
	[lll_futex_cmd_requeue_pi && __ASSUME_REQUEUE_PI]: Likewise.

2013-09-27  Siddhesh Poyarekar  <siddhesh@redhat.com>

	* sysdeps/pthread/bits/libc-lock.h [_LIBC && (!NOT_IN_libc ||
	IS_IN_libpthread)] (__libc_lock_fini_recursive): Use the mutex
	member of the argument.
	(__libc_lock_trylock_recursive): Likewise.
	(__libc_lock_unlock_recursive): Likewise.

2013-09-04  Joseph Myers  <joseph@codesourcery.com>

	* sysdeps/unix/sysv/linux/x86_64/cancellation.S
	[SHARED && DO_VERSIONING && !NO_HIDDEN]: Change conditional to
	[SHARED && !NO_HIDDEN].

2013-09-03  Siddhesh Poyarekar  <siddhesh@redhat.com>

	[BZ #15921]
	* tst-cleanup2.c (do_test): New volatile variable RET to
	return success.

2013-08-30   Ondřej Bílka  <neleai@seznam.cz>

	* sysdeps/pthread/pthread.h: Fix typos.
	* sysdeps/unix/sysv/linux/internaltypes.h: Likewise.
	* tst-cancel4.c: Likewise.

2013-08-21   Ondřej Bílka  <neleai@seznam.cz>

	* pthread_getschedparam.c: Fix typos.
	* sysdeps/unix/sysv/linux/register-atfork.c: Likewise.

2013-07-23  David S. Miller  <davem@davemloft.net>

	* tst-cancel4.c (WRITE_BUFFER_SIZE): Adjust comment.

2013-07-22  David S. Miller  <davem@davemloft.net>

	* tst-cancel4.c (WRITE_BUFFER_SIZE): Increase to 16384.

2013-07-19  Dominik Vogt  <vogt@de.ibm.com>

	* pthread_mutex_lock.c: Fix whitespace.
	* pthread_mutex_trylock.c: Likewise.
	* sysdeps/unix/sysv/linux/x86/bits/pthreadtypes.h: Likewise.
	* sysdeps/unix/sysv/linux/x86/elision-conf.c: Likewise.
	* sysdeps/unix/sysv/linux/x86/elision-conf.h: Likewise.
	* sysdeps/unix/sysv/linux/x86/elision-lock.c: Likewise.
	* sysdeps/unix/sysv/linux/x86/elision-timed.c: Likewise.
	* sysdeps/unix/sysv/linux/x86/elision-trylock.c: Likewise.
	* sysdeps/unix/sysv/linux/x86/force-elision.h: Likewise.
	* sysdeps/unix/sysv/linux/x86/hle.h: Likewise.
	* sysdeps/unix/sysv/linux/x86/pthread_mutex_cond_lock.c: Likewise.
	* sysdeps/unix/sysv/linux/x86/pthread_mutex_lock.c: Likewise.
	* sysdeps/unix/sysv/linux/x86/pthread_mutex_timedlock.c: Likewise.
	* sysdeps/unix/sysv/linux/x86/pthread_mutex_trylock.c: Likewise.

	* sysdeps/unix/sysv/linux/x86/elision-conf.c:
	Remove __rwlock_rtm_enabled and __rwlock_rtm_read_retries.
	(elision_init): Don't set __rwlock_rtm_enabled.
	* sysdeps/unix/sysv/linux/x86/elision-conf.h:
	Remove __rwlock_rtm_enabled.

2013-07-03  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/x86/init-arch.c: New file.
	* sysdeps/unix/sysv/linux/x86/init-arch.h: Likewise.

2013-07-02  Andi Kleen <ak@linux.intel.com>

	* sysdeps/unix/sysv/linux/x86/elision-conf.c (elision_init):
	  Check ENABLE_LOCK_ELISION.

2013-07-02  Andi Kleen  <ak@linux.intel.com>

	* pthread_mutexattr_settype.c (__pthread_mutexattr_settype):
	  Disable elision for PTHREAD_MUTEX_DEFAULT.

2013-07-02  Andi Kleen  <ak@linux.intel.com>
	    Hongjiu Lu  <hongjiu.lu@intel.com>

	* pthread_mutex_lock.c
	(__pthread_mutex_lock): Add lock elision support.
	* pthread_mutex_timedlock.c (pthread_mutex_timedlock): Likewise.
	* pthread_mutex_trylock.c (__pthread_mutex_trylock): Likewise.
	* pthread_mutex_unlock.c (__pthread_mutex_unlock_usercnt): Likewise.
	* sysdeps/unix/sysv/linux/pthread_mutex_cond_lock.c: Likewise.
	* sysdeps/unix/sysv/linux/x86/bits/pthreadtypes.h: Likewise.
	* sysdeps/unix/sysv/linux/x86/Makefile: New file.
	* sysdeps/unix/sysv/linux/x86/force-elision.h: New file
	* sysdeps/unix/sysv/linux/x86/pthread_mutex_cond_lock.c: Likewise.
	* sysdeps/unix/sysv/linux/x86/pthread_mutex_lock.c: Likewise.
	* sysdeps/unix/sysv/linux/x86/pthread_mutex_timedlock.c: Likewise.
	* sysdeps/unix/sysv/linux/x86/pthread_mutex_trylock.c: Likewise.
	* sysdeps/unix/sysv/linux/x86/pthread_mutex_unlock.c: Likewise.

2013-07-02  Andi Kleen  <ak@linux.intel.com>

	* tst-mutex5.c: Include config.h.
	  (do_test): Add checks for ENABLE_LOCK_ELISION.
	* tst-mutex8.c: Include config.h
	  (tf): Add checks for ENABLE_LOCK_ELISION.
	  (check_type): Likewise.

2013-07-02  Andi Kleen  <ak@linux.intel.com>

	* pthreadP.h: Add elision types.
	  (PTHREAD_MUTEX_TYPE_ELISION): Add.
	* sysdeps/pthread/pthread.h: Add elision initializers.
	  (PTHREAD_MUTEX_ELISION_NP, PTHREAD_MUTEX_NO_ELISION_NP,
	   PTHREAD_MUTEX_PSHARED_NP): Add new flags.
	  (__PTHREAD_SPINS): Add.

2013-07-02  Andi Kleen  <ak@linux.intel.com>
	    Hongjiu Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/i386/lowlevellock.h (__lll_timedwait_tid,
	  lll_timedlock_elision, __lll_lock_elision, __lll_unlock_elision,
	  __lll_trylock_elision, lll_lock_elision, lll_unlock_elision,
	  lll_trylock_elision): Add.
	* sysdeps/unix/sysv/linux/x86/Makefile: Imply x86.
	* sysdeps/unix/sysv/linux/x86/elision-conf.c: New file.
	* sysdeps/unix/sysv/linux/x86/elision-conf.h: New file.
	* sysdeps/unix/sysv/linux/x86/elision-lock.c: New file.
	* sysdeps/unix/sysv/linux/x86/elision-timed.c: New file.
	* sysdeps/unix/sysv/linux/x86/elision-trylock.c: New file.
	* sysdeps/unix/sysv/linux/x86/elision-unlock.c: New file.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h (__lll_timedwait_tid,
	  lll_timedlock_elision, __lll_lock_elision, __lll_unlock_elision,
	  __lll_trylock_elision, lll_lock_elision, lll_unlock_elision,
	  lll_trylock_elision): Add.
	* nptl/sysdeps/unix/sysv/linux/x86/hle.h: New file.
	* elision-conf.h: New file.

2013-06-24  Vladimir Nikulichev  <v.nikulichev@gmail.com>

	[BZ #12310]
	* pthread_exit.c: Add reference to pthread_create.

2013-06-22  Joseph Myers  <joseph@codesourcery.com>

	* pthread_getattr_default_np.c: Include <string.h>.

2013-06-15  Siddhesh Poyarekar  <siddhesh@redhat.com>

	* Versions (libpthread): Add GLIBC_2.18.
	(GLIBC_2.18): Add pthread_setattr_default_np and
	pthread_getattr_default_np.
	* allocatestack.c (allocate_stack): Synchronize read from
	__default_pthread_attr.
	(__reclaim_stacks): Initialize __default_pthread_attr_lock.
	* nptl-init.c (__pthread_initialize_minimal_internal):
	Synchronize write to __default_pthread_attr.
	* pthreadP.h (__default_pthread_attr_lock): Declare.
	* pthread_attr_getstacksize (__pthread_attr_getstacksize):
	Synchronize read from __default_pthread_attr.
	* pthread_create.c (__pthread_create_2_1): Make a local copy of
	__default_pthread_attr.  Check value of flags in IATTR even if
	input ATTR is NULL.
	* pthread_getattr_default_np.c: New file.
	* pthread_setattr_default_np.c: New file.
	* sysdeps/pthread/pthread.h [__USE_GNU]
	(pthread_getattr_default_np, pthread_setattr_default_np):
	Declare.
	* tst-default-attr.c: New test case.
	* Makefile (libpthread-routines): Add
	pthread_setattr_default_np and pthread_getattr_default_np.
	(tests): Add tst-default-attr.
	* vars.c (__default_pthread_attr_lock): Declare and initialize.

2013-06-13  Siddhesh Poyarekar  <siddhesh@redhat.com>
	    Carlos O'Donell  <carlos@redhat.com>

	[BZ #15618]
	* tst-pthread-attr-affinity: New test case.
	* Makefile (tests): Add it.
	* sysdeps/unix/sysv/linux/pthread_attr_getaffinity.c
	(__pthread_attr_getaffinity_new): Copy minimum of source and
	destination sizes to avoid a buffer overrun.

2013-06-10  Carlos O'Donell  <carlos@redhat.com>

	* sysdeps/unix/sysv/linux/i386/lowlevellock.h
	(lll_futex_wake): Return syscall error.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h
	(lll_futex_wake): Return syscall error.

2013-08-06   Ondřej Bílka  <neleai@seznam.cz>

	* sysdeps/pthread/allocalim.h: (__libc_use_alloca): Fix warning.

2013-06-06   Ondřej Bílka  <neleai@seznam.cz>

	* tst-cond22.c: Fix leading whitespaces.
	* tst-umask1.c: Likewise.

2013-06-06  Joseph Myers  <joseph@codesourcery.com>

	* sysdeps/unix/sysv/linux/i386/i486/pthread_barrier_wait.S: Remove
	trailing whitespace.
	* sysdeps/unix/sysv/linux/powerpc/pt-longjmp.c: Likewise.
	* sysdeps/unix/sysv/linux/sh/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_barrier_wait.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_cond_broadcast.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_cond_signal.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_cond_timedwait.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_cond_wait.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_once.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_rdlock.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_unlock.S: Likewise.
	* sysdeps/unix/sysv/linux/sparc/lowlevellock.h: Likewise.
	* tst-mutexpp10.c: Likewise.
	* tst-stackguard1.c: Likewise.

2013-05-31  Joseph Myers  <joseph@codesourcery.com>

	* Makefile ($(objpfx)libpthread.so): Remove dependencies on libc
	and ld.so.

2013-05-16  Ryan S. Arnold  <rsa@linux.vnet.ibm.com>

	* pthread_create.c: Add missing #include <stdint.h> due to uint64_t or
	uint32_t usage.
	* sysdeps/pthread/createthread.c: Likewise.

2013-05-14  Andreas Jaeger  <aj@suse.de>

	[BZ #10686]
	* sysdeps/x86_64/tls.h (struct tcbhead_t): Add __private_ss field.
	* sysdeps/i386/tls.h (struct tcbhead_t): Likewise.

2013-05-09  Andi Kleen  <ak@linux.intel.com>

	* tst-mutex8.c (do_test): Check for ENABLE_PI.

2013-04-22  Siddhesh Poyarekar  <siddhesh@redhat.com>

	* pthreadP.h (check_sched_policy_attr): New inline function.
	(check_sched_priority_attr): Likewise.
	(check_stacksize_attr): Likewise.
	(__kernel_cpumask_size, __determine_cpumask_size): Declare
	extern.
	(check_cpuset_attr): New inline function.
	* pthread_attr_setschedparam (__pthread_attr_setschedparam):
	Use check_sched_priority_attr.
	* pthread_attr_setschedpolicy.c
	(__pthread_attr_setschedpolicy): Use check_sched_policy_attr.
	* pthread_attr_setstack.c (__pthread_attr_setstack): Use
	check_stacksize_attr.
	* pthread_attr_setstacksize.c (__pthread_attr_setstacksize):
	Likewise.
	* sysdeps/unix/sysv/linux/pthread_attr_setaffinity.c
	(__pthread_attr_setaffinity_new): Use check_cpuset_attr.

2013-04-11  Andreas Schwab  <schwab@suse.de>

	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_timedwait.S
	(__pthread_cond_timedwait): If possible use FUTEX_WAIT_BITSET to
	directly use absolute timeout.

2013-04-07  Carlos O'Donell  <carlos@redhat.com>

	* sysdeps/unix/sysv/linux/sem_post.c: Include atomic.h.

2013-04-04  Siddhesh Poyarekar  <siddhesh@redhat.com>

	[BZ #15337]
	* sysdeps/unix/sysv/linux/x86_64/cancellation.S
	[IS_IN_libpthread]
	[SHARED && defined DO_VERSIONING && !defined NO_HIDDEN]: Mark
	__pthread_unwind hidden.

2013-03-28  Roland McGrath  <roland@hack.frob.com>

	* pthread_create.c (start_thread) [!SHARED]:
	Call __call_tls_dtors only if it's not NULL.

2013-03-19  Siddhesh Poyarekar  <siddhesh@redhat.com>

	* allocatestack.c (allocate_stack): Use __default_pthread_attr
	instead of __default_stacksize.
	* nptl-init.c (__pthread_initialize_minimal_internal):
	Likewise.  Initialize guardsize.
	* pthreadP.h (__default_pthread_attr): Declare.
	* pthread_attr_getstacksize.c (__pthread_attr_getstacksize):
	Use __default_pthread_attr instead of __default_stacksize.
	* pthread_create.c (default_attr): Remove.
	(__pthread_create_2_1): Use __default_pthread_attr instead of
	default_attr.
	* vars.c (__default_stacksize): Remove.
	(__default_pthread_attr): New static variable to store
	default thread attributes.

2013-03-18  Siddhesh Poyarekar  <siddhesh@redhat.com>

	* pthread_barrier_init.c (default_attr): Rename to
	default_barrierattr.
	(pthread_barrier_init): Adjust for the rename.
	* pthread_mutex_init.c (default_attr): Rename to
	default_mutexattr.
	(__pthread_mutex_init): Adjust for the rename.
	* pthread_rwlock_init.c (default_attr): Rebane to
	default_rwlockattr.
	(__pthread_rwlock_init): Adjust for the rename.

2013-03-12  Carlos O'Donell  <carlos@redhat.com>

	* sysdeps/unix/sysv/linux/lowlevellock.c: Include <atomic.h>.

2013-03-04  Roland McGrath  <roland@hack.frob.com>

	* sysdeps/unix/sysv/linux/i386/i686/dl-sysdep.h:
	Change multiple inclusion guard to _LINUX_I686_DL_SYSDEP_H.
	Use #include_next.
	(HAVE_DL_DISCOVER_OSVERSION): Remove definition, now redundant.
	(RTLD_PRIVATE_ERRNO): Likewise.
	(NEED_DL_SYSINFO, DL_SYSINFO_DEFAULT, DL_SYSINFO_IMPLEMENTATION):
	Move macros and associated declaration to ...
	* sysdeps/unix/sysv/linux/i386/dl-sysdep.h: ... here.
	Change multiple include guard to _LINUX_I386_DL_SYSDEP_H.
	Use #include_next.

2013-03-01  Carlos O'Donell  <carlos@redhat.com>

	* Makefile (tests): Revert last change.
	(tst-pthread-stack-env-ENV): Likewise.
	* nptl-init.c (set_default_stacksize): Likewise.
	(__pthread_initialize_minimal_internal): Likewise.
	* tst-pthread-stack-env.c: Likewise.

2013-03-01  Siddhesh Poyarekar  <siddhesh@redhat.com>

	* tst-oddstacklimit.c: Include stdlib.h.

	* Makefile (tests): Add tst-pthread-stack-env.
	(tst-pthread-stack-env-ENV): Set environment for test.
	* nptl-init.c (set_default_stacksize): New function.
	(__pthread_initialize_minimal_internal): Accept ARGC, ARGV and
	ENVP.  Initialize __ENVIRON and set __DEFAULT_STACKSIZE.
	* tst-pthread-stack-env.c: New test case.

2013-02-21  David S. Miller  <davem@davemloft.net>

	* sysdeps/unix/sysv/linux/sparc/lowlevellock.h
	(FUTEX_WAIT_REQUEUE_PI): Define.
	(FUTEX_CMP_REQUEUE_PI): Likewise.
	(lll_futex_wait_requeue_pi): Likewise.
	(lll_futex_timed_wait_requeue_pi): Likewise.
	(lll_futex_cmp_requeue_pi): Likewise.

2013-02-21  Carlos O'Donell  <carlos@redhat.com>

	* sysdeps/unix/sysv/linux/fork.c: Fix comment typo.

2013-02-18  Siddhesh Poyarekar  <siddhesh@redhat.com>

	* sysdeps/pthread/tst-timer.c: Include stdlib.h for declaration
	of exit.
	* tst-barrier4.c: Likewise.
	* tst-robust7.c: Likewise.

	[BZ #14920]
	* pthreadP.h (USE_REQUEUE_PI): New macro to check if mutex is
	PI-aware.
	* pthread_cond_broadcast.c (__pthread_cond_broadcast): Use
	PI-aware futex operations if available and mutex is PI-aware.
	* pthread_cond_signal.c (__pthread_cond_signal): Likewise.
	* nptl/pthread_cond_timedwait.c (__pthread_cond_timedwait):
	Likewise.
	* pthread_cond_wait.c (__condvar_cleanup): Adjust lock if
	cancellation occurred just after futex returned successfully
	from a PI operation with the mutex held.
	(__pthread_cond_wait): Use PI-aware futex operations if
	available and mutex is PI-aware.
	* sysdeps/unix/sysv/linux/powerpc/lowlevellock.h
	(FUTEX_WAIT_REQUEUE_PI): Define.
	(FUTEX_CMP_REQUEUE_PI): Likewise.
	(lll_futex_wait_requeue_pi): Likewise.
	(lll_futex_timed_wait_requeue_pi): Likewise.
	(lll_futex_cmp_requeue_pi): Likewise.
	* nptl/sysdeps/unix/sysv/linux/s390/lowlevellock.h
	(FUTEX_WAIT_REQUEUE_PI): Define.
	(FUTEX_CMP_REQUEUE_PI): Likewise.
	(lll_futex_wait_requeue_pi): Likewise.
	(lll_futex_timed_wait_requeue_pi): Likewise.
	(lll_futex_cmp_requeue_pi): Likewise.
	* sysdeps/unix/sysv/linux/kernel-features.h: Define
	__ASSUME_REQUEUE_PI for Linux version higher than 2.6.31.

2013-02-04  Andreas Schwab  <schwab@suse.de>

	[BZ #14142]
	* tst-cancel14.c: Include <sys/time.h>.
	* tst-cancel15.c: Likewise.
	* tst-mutex9.c: Include <stdint.h>, <stdlib.h> and <sys/time.h>.
	* tst-stackguard1.c: Include <tls.h>

2013-01-16  Andreas Schwab  <schwab@suse.de>

	[BZ #14327]
	* sem_open.c (sem_open): Use __mktemp instead of mktemp.

2013-01-11  Carlos O'Donell  <codonell@redhat.com>

	* allocatestack.c (allocate_stack): Add comment. Remove assert
	on attr.

2013-01-11  H.J. Lu  <hongjiu.lu@intel.com>

	* Makefile (tst-cancel7-ARGS: Replace $(host-built-program-cmd)
	with $(host-test-program-cmd).
	(tst-exec4-ARGS): Likewise.
	(tst-stackguard1-ARGS): Likewise.
	($(objpfx)tst-tls6.out): Don't pass $(elf-objpfx) to tst-tls6.sh.
	Replace $(rtld-installed-name) with $(test-via-rtld-prefix).
	* tst-tls6.sh (elf_objpfx): Removed.
	(rtld_installed_name): Renamed to ...
	(test_via_rtld_prefix): This.
	(tst_tls5): Prepend ${test_via_rtld_prefix}.

2013-01-02  Joseph Myers  <joseph@codesourcery.com>

	* All files with FSF copyright notices: Update copyright dates
	using scripts/update-copyrights.

2013-01-01  Joseph Myers  <joseph@codesourcery.com>

	* sysdeps/unix/sysv/linux/x86_64/lowlevelrobustlock.S: Reformat
	copyright notice.

2012-12-28  Andi Kleen  <ak@linux.intel.com>

	* pthread_rwlock_tryrdlock.c (__pthread_rwlock_tryrdlock): Convert
	to prototype.
	* pthread_rwlock_trywrlock.c (__pthread_rwlock_trywrlock):
	Likewise.

2012-12-27  David S. Miller  <davem@davemloft.net>

	* sysdeps/unix/sysv/linux/sparc/lowlevellock.h
	(lll_futex_timed_wait_bitset): New macro.

2012-12-27  Siddhesh Poyarekar  <siddhesh@redhat.com>

	* sysdeps/unix/sysv/linux/s390/lowlevellock.h (SYS_futex):
	Remove definition.
	(lll_futex_timed_wait): Replace assembly code with
	INTERNAL_SYSCALL.
	(lll_futex_timed_wait_bitset): Likewise.
	(lll_futex_wake): Likewise.
	(lll_futex_requeue): Likewise.
	(lll_futex_wake_unlock): Likewise.

2012-12-08  Siddhesh Poyarekar  <siddhesh@redhat.com>

	* sysdeps/unix/sysv/linux/s390/jmp-unwind.c (_longjmp_unwind):
	Declare LOCAL_VAR as char.

2012-12-04  Joseph Myers  <joseph@codesourcery.com>

	* sysdeps/unix/sysv/linux/powerpc/sem_post.c (__old_sem_post):
	Cast result of atomic_increment_val to (void) instead of storing
	in otherwise-unused variable.

2012-12-03  Allan McRae  <allan@archlinux.org>

	* Makefile (LDFLAGS-tst-cond24, LDFLAGS-tst-cond25): Remove.

2012-11-26  H.J. Lu  <hongjiu.lu@intel.com>

	* unwind.c (__pthread_unwind): Pass address of unwind_cleanup
	to THREAD_SETMEM.
	* sysdeps/i386/tls.h: Include <libc-internal.h>.
	(THREAD_SETMEM): Use cast_to_integer before casting to uint64_t.
	(THREAD_SETMEM_NC): Likewise.
	* sysdeps/x86_64/tls.h: Include <libc-internal.h>.
	(THREAD_SETMEM): Use cast_to_integer before casting to uint64_t.
	(THREAD_SETMEM_NC): Likewise.

2012-11-21  Joseph Myers  <joseph@codesourcery.com>

	* sysdeps/unix/sysv/linux/sem_post.c (__old_sem_post): Cast result
	of atomic_increment_val to (void) instead of storing in
	otherwise-unused variable.

	* pthread_cond_timedwait.c (__pthread_cond_timedwait)
	[__NR_clock_gettime]: Cast result of INTERNAL_VSYSCALL to void
	instead of storing in otherwise-unused variable.

2012-11-14  Marcus Shawcroft  <marcus.shawcroft@linaro.org>

	* Makefile (CFLAGS-open.c, CFLAGS-open64.c, CFLAGS-pause.c)
	  (CFLAGS-recv.c, CFLAGS-send.c): Define.

2012-11-06  Chris Metcalf  <cmetcalf@tilera.com>

	* tst-sem14.c (TIMEOUT): Set timeout to 10 seconds.
	* tst-cond24.c (TIMEOUT): Increase from 10 to 20 seconds.

2012-11-05  Siddhesh Poyarekar  <siddhesh@redhat.com>

	* pthread_cond_timedwait.c (__pthread_cond_timedwait): Time out
	if absolute timeout is negative.
	[__ASSUME_FUTEX_CLOCK_REALTIME &&
	lll_futex_timed_wait_bitset]: Use lll_futex_timed_wait_bitset.
	* pthread_rwlock_timedrdlock.c (pthread_rwlock_timedrdlock):
	Likewise.
	* pthread_rwlock_timedwrlock.c (pthread_rwlock_timedwrlock):
	Likewise.
	* sysdeps/unix/sysv/linux/lowlevelrobustlock.c
	(__lll_robust_timedlock_wait): Likewise.
	* sysdeps/unix/sysv/linux/powerpc/lowlevellock.h
	(lll_futex_timed_wait_bitset): New macro.
	* sysdeps/unix/sysv/linux/s390/lowlevellock.h
	(lll_futex_timed_wait_bitset): Likewise.

2012-11-03  David S. Miller  <davem@davemloft.net>

	* sysdeps/unix/sysv/linux/sparc/lowlevellock.h (BUSY_WAIT_NOP):
	Add missing spaces.
	(__cpu_relax): Likewise.

2012-11-02  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/x86_64/tls.h: Don't include <xmmintrin.h>.
	(__128bits): New struct typedef.
	(tcbhead_t): Replace __m128 with __128bits.

2012-10-30  Aurelien Jarno  <aurelien@aurel32.net>
	    Joseph Myers  <joseph@codesourcery.com>

	* Makefile (tst-cancel7-ARGS): Use exec in --command argument.

2012-10-28  David S. Miller  <davem@davemloft.net>

	* sysdeps/unix/sysv/linux/sparc/lowlevellock.h (BUSY_WAIT_NOP):
	Define when we have v9 instructions available.
	* sysdeps/unix/sysv/linux/sparc/sparc64/cpu_relax.S: New file.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sparcv9/cpu_relax.S: New
	file.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sparcv9/Makefile: New
	file.
	* sysdeps/unix/sysv/linux/sparc/sparc64/Makefile: Add cpu_relax
	to libpthread-routines.

2012-10-25  Roland McGrath  <roland@hack.frob.com>

	* tst-cond-except.c (TEST_FUNCTION): New macro.

2012-10-25  Joseph Myers  <joseph@codesourcery.com>

	* Makefile ($(objpfx)tst-tls6.out): Use $(BASH) not $(SHELL) to
	run tst-tls6.sh.
	* tst-tls6.sh: Use /bin/bash not /bin/sh.

2012-10-25  Roland McGrath  <roland@hack.frob.com>

	* tst-basic2.c (do_test): Return RESULT, not always zero.

	* tst-cond25.c: Include <stdint.h>
	(waiter): Add casts to uintptr_t between casting integer<->pointer.
	(timed_waiter): Likewise.
	(do_test_wait): Likewise.
	* tst-cond-except.c (thr): Likewise.
	(do_test): Use prototype definition.

2012-10-24  Joseph Myers  <joseph@codesourcery.com>
	    Jim Blandy  <jimb@codesourcery.com>

	* Makefile ($(objpfx)tst-tls6.out): Pass $(test-wrapper-env) to
	tst-tls6.sh.
	* tst-tls6.sh (test_wrapper_env): New variable.  Use it to run
	programs with LD_PRELOAD set.

2012-10-24  Roland McGrath  <roland@hack.frob.com>

	* Makefile ($(objpfx)tst-cond11, $(objpfx)tst-cond19): Targets removed.
	($(objpfx)tst-sem5, $(objpfx)tst-cancel18): Likewise.
	((objpfx)tst-cancelx18, $(objpfx)tst-clock2): Likewise.
	($(objpfx)tst-rwlock14): Likewise.

2012-10-24  Joseph Myers  <joseph@codesourcery.com>

	* Makefile (tests): Remove tst-oddstacklimit.
	(test-srcs): New variable.
	(tst-oddstacklimit-ENV): Remove.
	[$(run-built-tests) = yes] (tests): Depend on
	$(objpfx)tst-oddstacklimit.out.
	[$(run-built-tests) = yes] ($(objpfx)tst-oddstacklimit.out): New
	target.
	* tst-oddstacklimit.c: Do not include "tst-basic1.c".  Use
	setrlimit before executing tst-basic1 test passed to --command.

2012-10-23  Joseph Myers  <joseph@codesourcery.com>

	* Makefile [$(cross-compiling) = no]: Change condition to
	[$(run-built-tests) = yes].

2012-10-23  Jim Blandy  <jimb@codesourcery.com>
	    Joseph Myers  <joseph@codesourcery.com>

	* Makefile (tst-cancel7-ARGS): Use $(host-built-program-cmd).
	(tst-exec4-ARGS): Likewise.
	(tst-stackguard1-ARGS): Likewise.

2012-10-21  Jim Blandy  <jimb@codesourcery.com>
	    Joseph Myers  <joseph@codesourcery.com>

	* Makefile ($(objpfx)tst-cancel-wrappers.out): Pass $(NM) to
	tst-cancel-wrappers.sh.
	* tst-cancel-wrappers.sh: Use nm program given as first argument,
	not hardcoded "nm".

2012-10-17  Siddhesh Poyarekar  <siddhesh@redhat.com>

	* tst-cond25.c (do_test_wait): Don't check for return value from
	pthread_cancel.

2012-10-16  Siddhesh Poyarekar  <siddhesh@redhat.com>

	[BZ #14652]
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_timedwait.S
	(__condvar_tw_cleanup):  Adjust the mutex data structure if it
	was locked by FUTEX_WAIT_REQUEUE_PI.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_wait
	(__condvar_w_cleanup): Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S
	(__condvar_cleanup2): Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S
	(__condvar_cleanup1): Likewise.

2012-10-10  Carlos O'Donell  <carlos@systemhalted.org>

	* sysdeps/pthread/pthread.h [!(defined __GNUC__ &&
	defined __EXCEPTIONS) && defined __USE_GNU]
	(pthread_cleanup_push_defer_np): Fix formatting.

2012-10-10  Siddhesh Poyarekar  <siddhesh@redhat.com>

	[BZ #14652]
	* Makefile (tests): New test case tst-cond25.
	(LDFLAGS-tst-cond25): Link tst-cond25 against librt.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_timedwait.S
	(__condvar_tw_cleanup): Lock mutex only if we don't already
	own it.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_wait.S
	(__condvar_w_cleanup): Likewise.
	* sysdeps/unix/sysv/linux/pthread-pi-defines.sym: Add TID_MASK.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S
	(__condvar_cleanup2): Lock mutex only if we don't already
	own it.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S
	(__condvar_cleanup1): Likewise.
	* tst-cond25.c: New test case.

2012-10-09  Roland McGrath  <roland@hack.frob.com>

	* sysdeps/pthread/configure: Regenerated.
	* sysdeps/x86_64/configure: Regenerated.

2012-10-05  David S. Miller  <davem@davemloft.net>

	[BZ #14568]
	* sysdeps/sparc/tls.h (DB_THREAD_SELF_INCLUDE): Delete.
	(DB_THREAD_SELF): Use constants for the register offsets.  Correct
	the case of a 64-bit debugger with a 32-bit inferior.

2012-10-05  H.J. Lu  <hongjiu.lu@intel.com>

	[BZ #14557]
	* Makefile (tests-static): Add tst-cancel24-static,
	tst-cond8-static tst-mutex8-static, tst-mutexpi8-static,
	tst-sem11-static and tst-sem12-static.
	(tests): Likewise.
	(LDLIBS-tst-cancel24-static): New macro.
	* tst-cancel24-static.cc: New file.
	* tst-cond8-static.c: Likewise.
	* tst-mutex8-static.c: Likewise.
	* tst-mutexpi8-static.c: Likewise.
	* tst-sem11-static.c: Likewise.
	* tst-sem12-static.c: Likewise.

2012-10-05  Siddhesh Poyarekar  <siddhesh@redhat.com>

	[BZ #14417]
	* Makefile (tests): New test case tst-cond24.
	(LDFLAGS-tst-cond24): Link tst-cond24 against librt.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_timedwait.S
	(__pthread_cond_timedwait): Unlock mutex before going back to
	wait in PI case.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_wait.S
	(__pthread_cond_wait): Likewise.  Revert handling of EAGAIN
	return from futex_wait.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S
	(__pthread_cond_timedwait): Unlock mutex before going back to
	wait in PI case.  Set requeue_pi flag only if wait returned 0.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S
	(__pthread_cond_wait): Likewise.  Revert handling of EAGAIN
	return from futex_wait.
	* tst-cond24.c: New test case.

2012-10-04  Roland McGrath  <roland@hack.frob.com>

	* pthread_create.c (start_thread): Use __madvise, not madvise.

2012-10-02  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/i386/tls.h: Update copyright years.

2012-10-02  Siddhesh Poyarekar  <siddhesh@redhat.com>

	* pthread_create.c (start_thread): Fix clone flag name in
	comment to CLONE_CHILD_CLEARTID.
	* sysdeps/unix/sysv/linux/i386/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/sh/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h: Likewise.

2012-10-01  Siddhesh Poyarekar  <siddhesh@redhat.com>

	[BZ #14477]
	* Makefile (tests): Add tst-cond-except.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_timedwait.S
	(__pthread_cond_timedwait): Mark instructions where %ebx is
	incremented in PI case.
	(.gcc_except_table): Add entry to jump to __condvar_tw_cleanup2
	for the marked PI case instructions.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_wait.S
	(__pthread_cond_wait): Mark instructions where %ebx is
	incremented in PI case.
	(.gcc_except_table): Add entry to jump to __condvar_w_cleanup2
	for the marked PI case instructions.
	* tst-cond-except.c: New test case.

2012-09-24  Dmitry V. Levin  <ldv@altlinux.org>

	* tst-tls6.sh: Add "set -e".
	* Makefile: Do not specify -e option when running testsuite
	shell scripts.

	* tst-tls6.sh: Add copyright header.

2012-09-24  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/x86_64/tls.h (THREAD_SETMEM): Add "()" when casting
	to uint64_t for 64-bit store.
	(THREAD_SETMEM_NC): Likewise.

2012-09-19  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/i386/tls.h (THREAD_SETMEM): Cast to uint64_t for
	64-bit store.
	(THREAD_SETMEM_NC): Likewise.

2012-09-14  Jeff Law  <law@redhat.com>

	[BZ #14583]
	* sysdeps/pthread/pthread.h: Fix prototype of __sigsetjmp.

2012-09-13  H.J. Lu  <hongjiu.lu@intel.com>

	[BZ #14576]
	* sysdeps/pthread/bits/libc-lockP.h (__rtld_lock_init_recursive):
	Removed.

2012-09-07  H.J. Lu  <hongjiu.lu@intel.com>

	* Makefile (LDFLAGS-tst-cancel24): Renamed to ...
	(LDLIBS-tst-cancel24): This.

2012-09-06  H.J. Lu  <hongjiu.lu@intel.com>

	[BZ #14545]
	* Makefile (tests-static): Add tst-cancel21-static.
	(tests): Likewise.
	* tst-cancel21-static.c: New file.

2012-09-01  Joseph Myers  <joseph@codesourcery.com>

	* sysdeps/unix/sysv/linux/pthread_getcpuclockid.c
	[!__ASSUME_POSIX_CPU_TIMERS]: Remove conditional code.
	[__NR_clock_getres]: Make code unconditional.
	(pthread_getcpuclockid): Remove code left unreachable by removal
	of conditionals.

2012-08-31  Joseph Myers  <joseph@codesourcery.com>

	[BZ #14532]
	* sysdeps/unix/sysv/linux/sem_post.c (__new_sem_post): Use
	atomic_compare_and_exchange_bool_rel.
	* tst-sem14.c: New file.
	* Makefile (tests): Add tst-sem14.

2012-08-15  Roland McGrath  <roland@hack.frob.com>

	* Makefile (CFLAGS-flockfile.c): Use $(libio-mtsafe) instead
	of -D_IO_MTSAFE_IO.
	(CFLAGS-ftrylockfile.c, CFLAGS-funlockfile.c): Likewise.
	* sysdeps/unix/sysv/linux/Makefile (CFLAGS-fork.c): Likewise.

2012-08-16  Joseph Myers  <joseph@codesourcery.com>

	* pthread_cond_timedwait.c (__pthread_cond_timedwait)
	[!__ASSUME_POSIX_TIMERS]: Remove conditional code.
	* pthread_condattr_setclock.c (pthread_condattr_setclock)
	[!__ASSUME_POSIX_TIMERS]: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_timedwait.S
	(__pthread_cond_timedwait) [!__ASSUME_POSIX_TIMERS]: Likewise.
	* sysdeps/unix/sysv/linux/pthread_getcpuclockid.c
	[!__ASSUME_POSIX_TIMERS]: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_cond_timedwait.S
	(__pthread_cond_timedwait) [!__ASSUME_POSIX_TIMERS]: Likewise.
	* sysdeps/unix/sysv/linux/timer_create.c [__NR_timer_create]: Make
	code unconditional.
	[!__NR-timer_create]: Remove conditional code.
	(timer_create) [!__ASSUME_POSIX_TIMERS]: Likewise.
	* sysdeps/unix/sysv/linux/timer_delete.c [__NR_timer_delete]: Make
	code unconditional.
	[!__NR_timer_delete]: Remove conditional code.
	(timer_delete) [!__ASSUME_POSIX_TIMERS]: Likewise.
	* sysdeps/unix/sysv/linux/timer_getoverr.c
	[__NR_timer_getoverrun]: Make code unconditional.
	[!__NR_timer_getoverrun]: Remove conditional code.
	(timer_getoverrun) [!__ASSUME_POSIX_TIMERS]: Likewise.
	* sysdeps/unix/sysv/linux/timer_gettime.c [__NR_timer_gettime]:
	Make code unconditional.
	[!__NR_timer_gettime]: Remove conditional code.
	(timer_gettime) [!__ASSUME_POSIX_TIMERS]: Likewise.
	* sysdeps/unix/sysv/linux/timer_routines.c [__NR_timer_create]:
	Make code unconditional.
	[!__ASSUME_POSIX_TIMERS]: Remove conditional code.
	* sysdeps/unix/sysv/linux/timer_settime.c [__NR_timer_settime]:
	Make code unconditional.
	[!__NR_timer_settime]: Remove conditional code.
	(timer_settime) [!__ASSUME_POSIX_TIMERS]: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S
	(__pthread_cond_timedwait) [!__ASSUME_POSIX_TIMERS]: Remove
	conditional code.

2012-08-15  Tom de Vries  <vries@codesourcery.com>
	    Maxim Kuvyrkov  <maxim@codesourcery.com>

	* sysdeps/pthread/bits/libc-lockP.h (__libc_lock_lock)
	(__libc_lock_trylock): Allow pre-existing definitions.

2012-08-15  Maxim Kuvyrkov  <maxim@codesourcery.com>

	* pthread_spin_lock.c: New file.
	* pthread_spin_trylock.c: New file.

2012-08-08  Joseph Myers  <joseph@codesourcery.com>

	* allocatestack.c (setxid_signal_thread) [__ASSUME_TGKILL]: Make
	code unconditional.
	(setxid_signal_thread) [!__ASSUME_TGKILL]: Remove conditional code.
	* pthread_cancel.c (pthread_cancel) [__ASSUME_TGKILL]: Make code
	unconditional.
	(pthread_cancel) [!__ASSUME_TGKILL]: Remove conditional code.
	* sysdeps/pthread/createthread.c (do_clone) [__ASSUME_TGKILL]:
	Make code unconditional.
	(do_clone) [!__ASSUME_TGKILL]: Remove conditional code.
	* sysdeps/unix/sysv/linux/pt-raise.c (raise) [__ASSUME_TGKILL ||
	__NR_tgkill]: Make code unconditional.
	(raise) [__ASSUME_TGKILL]: Likewise.
	(raise) [!__ASSUME_TGKILL]: Remove conditional code.
	* sysdeps/unix/sysv/linux/pthread_kill.c (__pthread_kill)
	[__ASSUME_TGKILL]: Make code unconditional.
	(__pthread_kill) [!__ASSUME_TGKILL]: Remove conditional code.
	* sysdeps/unix/sysv/linux/raise.c (raise) [__ASSUME_TGKILL ||
	__NR_tgkill]: Make code unconditional.
	(raise) [__ASSUME_TGKILL]: Likewise.
	(raise) [!__ASSUME_TGKILL]: Remove conditional code.

2012-08-07  Joseph Myers  <joseph@codesourcery.com>

	* sysdeps/pthread/createthread.c (create_thread)
	[!__ASSUME_NO_CLONE_DETACHED]: Remove conditional code.

2012-08-03  Joseph Myers  <joseph@codesourcery.com>

	* nptl-init.c (sigcancel_handler) [__ASSUME_CORRECT_SI_PID]: Make
	code unconditional.
	(sighandler_setxid) [__ASSUME_CORRECT_SI_PID]: Likewise.

2012-07-28  Siddhesh Poyarekar  <siddhesh@redhat.com>

	* tst-pthread-getattr.c (MAX_STACK_SIZE): New macro.
	(pagesize): New static variable.
	(allocate_and_test): Return MEM.  Rename parameter to TARGET.
	(check_stack_top): New local variables MEM and PAGEMASK.  Cap
	stack size to MAX_STACK_SIZE.  Call allocate_and_test for
	halfway up the stack top page.  Verify that the top page was
	written into.
	(do_test): Get pagesize using sysconf.

2012-07-25  Andreas Schwab  <schwab@linux-m68k.org>

	* sysdeps/unix/sysv/linux/i386/pt-vfork.S: Remove pseudo_end
	label.
	* sysdeps/unix/sysv/linux/i386/sysdep-cancel.h (PSEUDO): Likewise.
	* sysdeps/unix/sysv/linux/x86_64/sysdep-cancel.h (PSEUDO):
	Likewise.

2012-07-25  Siddhesh Poyarekar  <siddhesh@redhat.com>

	* tst-pthread-getattr.c: Revert last change.

2012-07-20  Siddhesh Poyarekar  <siddhesh@redhat.com>

	* tst-pthread-getattr.c (MAX_STACK_SIZE): New max cap for stack
	size.
	(_MIN): New macro.
	(allocate_and_test): Return STACKADDR.  Access STACKADDR instead
	of MEM to test.
	(check_stack_top): Read valued written into STACKADDR in
	allocate_and_test.  Cap stack size to MAX_STACK_SIZE.

2012-07-19  Siddhesh Poyarekar  <siddhesh@redhat.com>

	* nptl-init.c (sighandler_setxid): Fix the comment that
	describes it.

2012-06-23  Thomas Schwinge  <thomas@codesourcery.com>

	* sysdeps/unix/sysv/linux/sh/lowlevelrobustlock.S
	(__lll_robust_timedlock_wait): Simplify CFI directives.

2012-06-20  Siddhesh Poyarekar  <siddhesh@redhat.com>

	[BZ #12416]
	* Makefile (tests): Add test case.
	* pthread_getattr_np.c (pthread_getattr_np): Deduct pages below
	the __libc_stack_end page from stacksize.  Truncate stacksize to
	make it page aligned when it is computed from RLIMIT_STACK.
	* tst-pthread-getattr.c: New test case. Verify that stackaddr is
	accessible.

2012-06-07  Carlos Sánchez de La Lama  <csanchezdll@gmail.com>

	[BZ #14205]
	* sysdeps/sparc/sparc32/pthread_spin_lock.S: Do not use v9
	branches.

2012-06-04  Siddhesh Poyarekar  <siddhesh@redhat.com>
	    Jakub Jelinek  <jakub@redhat.com>

	[BZ #14188]
	* sysdeps/pthread/pthread.h
	[!(defined __GNUC__ && defined __EXCEPTIONS)]
	(pthread_cleanup_push, pthread_cleanup_push_defer_np): Use
	__libc_unlikely instead of __builtin_expect.

2012-05-30  H.J. Lu  <hongjiu.lu@intel.com>

	[BZ #14117]
	* sysdeps/unix/sysv/linux/i386/bits/pthreadtypes.h: Removed.
	* sysdeps/unix/sysv/linux/i386/bits/semaphore.h: Likewise.
	* sysdeps/unix/sysv/linux/i386/Implies: New file.
	* sysdeps/unix/sysv/linux/x86_64/Implies: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/bits/pthreadtypes.h: Renamed
	to ...
	* sysdeps/unix/sysv/linux/x86/bits/pthreadtypes.h: This.
	* sysdeps/unix/sysv/linux/x86_64/bits/semaphore.h: Renamed
	to ...
	* sysdeps/unix/sysv/linux/x86/bits/semaphore.h: This.

2012-05-30  Andreas Schwab  <schwab@linux-m68k.org>

	[BZ #14132]
	* nptl-init.c (pthread_functions): Remove use of INTUSE and
	_internal aliases.
	(__pthread_initialize_minimal_internal): Likewise.
	* sem_open.c: Likewise.
	* sem_unlink.c: Likewise.
	* pthreadP.h: Replace _internal aliases by hidden_proto
	declarations.
	* pthread_getspecific.c: Replace _internal alias by hidden_def.
	* pthread_key_create.c: Likewise.
	* pthread_mutex_destroy.c: Likewise.
	* pthread_mutex_init.c: Likewise.
	* pthread_mutex_lock.c: Likewise.
	* pthread_mutex_unlock.c: Likewise.
	* pthread_once.c: Likewise.
	* pthread_rwlock_rdlock.c: Likewise.
	* pthread_rwlock_unlock.c: Likewise.
	* pthread_rwlock_wrlock.c: Likewise.
	* pthread_setspecific.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_rdlock.S:
	Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_unlock.S:
	Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_wrlock.S:
	Likewise.
	* sysdeps/unix/sysv/linux/i386/pthread_once.S: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/pthread_once.c: Likewise.
	* sysdeps/unix/sysv/linux/s390/pthread_once.c: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_once.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_rdlock.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_unlock.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_wrlock.S: Likewise.
	* sysdeps/unix/sysv/linux/sparc/pthread_once.c: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_once.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_rdlock.S:
	Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_unlock.S:
	Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_wrlock.S:
	Likewise.

2012-05-27  Chung-Lin Tang  <cltang@codesourcery.com>

	* sysdeps/unix/sysv/linux/sh/sysdep-cancel.h (PSEUDO, LOAD_ARGS_1)
	(LOAD_ARGS_2 ,LOAD_ARGS_3 ,LOAD_ARGS_4): Add CFI restores.

	* sysdeps/unix/sysv/linux/sh/lowlevellock.S (__lll_lock_wait_private)
	(__lll_lock_wait, __lll_timedlock_wait, __lll_timedwait_tid): Add CFI
	directives.
	* sysdeps/unix/sysv/linux/sh/lowlevelrobustlock.S
	(__lll_robust_lock_wait, __lll_robust_timedlock_wait): Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_barrier_wait.S
	(pthread_barrier_wait): Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_cond_broadcast.S
	(__pthread_cond_broadcast): Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_cond_signal.S
	(__pthread_cond_signal): Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_cond_timedwait.S
	(__pthread_cond_timedwait): Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_cond_wait.S (__pthread_cond_wait):
	Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_rdlock.S
	(__pthread_rwlock_rdlock): Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_timedrdlock.S
	(pthread_rwlock_timedrdlock): Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_timedwrlock.S
	(pthread_rwlock_timedwrlock): Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_unlock.S
	(__pthread_rwlock_unlock): Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_wrlock.S
	(__pthread_rwlock_wrlock): Likewise.
	* sysdeps/unix/sysv/linux/sh/sem_post.S (__new_sem_post): Likewise.
	* sysdeps/unix/sysv/linux/sh/sem_timedwait.S (sem_timedwait): Likewise.
	* sysdeps/unix/sysv/linux/sh/sem_trywait.S (__new_sem_trywait):
	Likewise.
	* sysdeps/unix/sysv/linux/sh/sem_wait.S (__new_sem_wait): Likewise.

2012-05-26  Siddhesh Poyarekar  <siddhesh@redhat.com>

	[BZ #12416]
	* nptl/pthread_getattr_np.c (pthread_getattr_np): Use
	__libc_stack_end rounded to the end of containing page as the
	real stack end.

2012-05-25  Rayson Ho  <rho@redhat.com>

	* sysdeps/unix/sysv/linux/i386/lowlevellock.h: Low-level SystemTap
	probes for i386.
	* sysdeps/unix/sysv/linux/i386/i486/lowlevellock.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/lowlevellock.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_broadcast.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_signal.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_timedwait.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_wait.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_rdlock.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_wrlock.S: Likewise.

2012-05-25  Rayson Ho  <rho@redhat.com>
	    Roland McGrath  <roland@hack.frob.com>

	* DESIGN-systemtap-probes.txt: New file.
	* pthread_cond_broadcast.c: SystemTap probes.
	* pthread_cond_init.c: Likewise.
	* pthread_cond_signal.c: Likewise.
	* pthread_cond_wait.c: Likewise.
	* pthread_cond_destroy.c: Likewise.
	* pthread_create.c: Likewise.
	* pthread_join.c: Likewise.
	* pthread_mutex_destroy.c: Likewise.
	* pthread_mutex_init.c: Likewise.
	* pthread_mutex_lock.c: Likewise.
	* pthread_mutex_timedlock.c: Likewise.
	* pthread_mutex_unlock.c: Likewise.
	* pthread_rwlock_destroy.c: Likewise.
	* pthread_rwlock_rdlock.c: Likewise.
	* pthread_rwlock_unlock.c: Likewise.
	* pthread_rwlock_wrlock.c: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_broadcast.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_signal.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_rdlock.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_wrlock.S: Likewise.

2012-05-24  Roland McGrath  <roland@hack.frob.com>

	* pthread_create.c (start_thread): Define pthread_start LIBC_PROBE.

2012-05-17  Andreas Jaeger  <aj@suse.de>

	* sysdeps/unix/sysv/linux/i386/i686/dl-sysdep.h
	(HAVE_DL_DISCOVER_OSVERSION): Don't declare _dl_discover_osversion
	only for older kernels.

2012-05-15  Joseph Myers  <joseph@codesourcery.com>

	* pthreadP.h [!__NR_set_robust_list] (__NR_set_robust_list): Do
	not define.

2012-05-15  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h (lll_lock): Load
	futex pointer into RDI_LP.  Use RSP_LP to operate on stack.
	(lll_robust_lock): Likewise.
	(lll_cond_lock): Likewise.
	(lll_robust_cond_lock): Likewise.
	(lll_timedlock): Likewise.
	(lll_robust_timedlock): Likewise.
	(lll_unlock): Likewise.
	(lll_robust_unlock): Likewise.

2012-05-15  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_signal.S: Use
	LP_OP(cmp) and RCX_LP on dep_mutex pointer.

2012-05-15  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/x86_64/sem_wait.S: Use LP_OP(op)
	on NWAITERS.
	(__gcc_personality_v0): Replace 8-byte data alignment with
	LP_SIZE alignment and .quad with ASM_ADDR.

2012-05-15  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/x86_64/sem_timedwait.S: Use LP_OP(op)
	on NWAITERS.
	(__gcc_personality_v0): Replace 8-byte data alignment with
	LP_SIZE alignment and .quad with ASM_ADDR.

2012-05-15  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/x86_64/sem_post.S: Use LP_OP(cmp) on
	NWAITERS, which is unsigned long int.

2012-05-15  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/x86_64/pthread_once.S
	(__gcc_personality_v0): Replace 8-byte data alignment with
	LP_SIZE alignment and .quad with ASM_ADDR.

2012-05-15  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S: Use
	LP_OP(cmp), RSI_LP and R8_LP on dep_mutex pointer.  Load
	__vdso_clock_gettime pointer into RAX_LP.
	(__gcc_personality_v0): Replace 8-byte data alignment with
	LP_SIZE alignment and .quad with ASM_ADDR.

2012-05-15  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S: Use
	LP_OP(cmp), RSI_LP and R8_LP on dep_mutex pointer.  Load
	__vdso_clock_gettime pointer into RAX_LP.
	(__gcc_personality_v0): Replace 8-byte data alignment with
	LP_SIZE alignment and .quad with ASM_ADDR.

2012-05-15  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_broadcast.S: Use
	LP_OP(cmp) and R8_LP on dep_mutex pointer.

2012-05-15  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/x86_64/cancellation.S: Use LP_OP(mov)
	to update pointer in memory.  Load pointer into RDI_LP.

2012-05-15  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h
	(LLL_STUB_UNWIND_INFO_START): Align label to LP_SIZE instead
	of 8.
	(LLL_STUB_UNWIND_INFO_END): Likewise.
	(lll_timedlock): Load timeout pointer into RDX_LP.
	(lll_robust_timedlock): Likewise.

2012-05-15  Siddhesh Poyarekar  <siddhesh@redhat.com>
	    Jakub Jelinek  <jakub@redhat.com>

	[BZ #13613]
	* Makefile (tests): Add test cases.
	* descr.h (struct pthread): Add a comment describing multiple_threads.
	* pthreadP.h (__pthread_multiple_threads): Expand comment to include
	single-process case.
	* pthread_cancel.c (pthread_cancel): Enable multiple_threads
	before setting cancelstate of the thread.
	* sysdeps/unix/sysv/linux/libc_multiple_threads.c
	(__libc_multiple_threads): Add explanatory comment.
	* tst-cancel-self-cancelstate.c: New test case.
	* tst-cancel-self-canceltype.c: Likewise.
	* tst-cancel-self-cleanup.c: Supporting file for test cases.
	* tst-cancel-self-testcancel.c: New test case.
	* tst-cancel-self.c: Likewise.
	* vars.c: Expand comment to include single-process case.

2012-05-14  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/x86_64/tls.h: Don't include <bits/wordsize.h>.
	(tcbhead_t): Remove __x86_64__ check.  Align rtld_savespace_sse
	to 32 bytes.

2012-05-14  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/pthread/pthread.h (__PTHREAD_RWLOCK_INT_FLAGS_SHARED):
	New.
	(PTHREAD_RWLOCK_WRITER_NONRECURSIVE_INITIALIZER_NP): Check
	__PTHREAD_RWLOCK_INT_FLAGS_SHARED instead of __WORDSIZE.

2012-05-14  H.J. Lu  <hongjiu.lu@intel.com>

	* shlib-versions: Move x86_64-.*-linux.* entry to ...
	* sysdeps/x86_64/64/shlib-versions: Here.  New file.
	* sysdeps/x86_64/x32/shlib-versions: New file.

2012-05-14  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/x86_64/bits/pthreadtypes.h: Define x32
	__SIZEOF_PTHREAD_XXX_T.
	(__pthread_internal_list): Check __x86_64__ instead of __WORDSIZE.
	(pthread_mutex_t): Likewise.
	(pthread_rwlock_t): Likewise.
	(__PTHREAD_RWLOCK_INT_FLAGS_SHARED): New.  Defined if __x86_64__
	is defined.

2012-05-11  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/x86_64/x32/tls.h: New file.

2012-05-11  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/x86_64/tls.h (THREAD_SETMEM): Use uint64_t on 64-bit
	integer.
	(THREAD_SETMEM_NC): Likewise.

2012-05-11  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/x86_64/tls.h (THREAD_SELF): Replace movq/%q0 with
	mov/%0.

2012-05-11  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/x86_64/bits/pthreadtypes.h
	(__cleanup_fct_attribute): Check __x86_64__ instead of
	__WORDSIZE.

2012-05-11  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/pthread/pthread.h (PTHREAD_MUTEX_INITIALIZER): Check
	__PTHREAD_MUTEX_HAVE_PREV instead of __WORDSIZE.
	(PTHREAD_RECURSIVE_MUTEX_INITIALIZER_NP): Likewise.
	(PTHREAD_ERRORCHECK_MUTEX_INITIALIZER_NP): Likewise.
	(PTHREAD_ADAPTIVE_MUTEX_INITIALIZER_NP): Likewise.

2012-05-11  H.J. Lu  <hongjiu.lu@intel.com>

	* pthread_create.c (start_thread): Check __PTHREAD_MUTEX_HAVE_PREV
	instead of __WORDSIZE.

2012-05-10  Thomas Schwinge  <thomas@schwinge.name>

	[BZ #3748]
	* sysdeps/pthread/bits/libc-lockP.h (__libc_once_get): New macro.

2012-05-09  Chung-Lin Tang  <cltang@codesourcery.com>

	* sysdeps/unix/sysv/linux/sh/pthread_cond_timedwait.S
	(__pthread_cond_timedwait): Use CFI directives.
	* sysdeps/unix/sysv/linux/sh/pthread_cond_wait.S
	(__pthread_cond_wait): Likewise.
	* sysdeps/unix/sysv/linux/sh/sem_timedwait.S (sem_timedwait): Likewise.
	* sysdeps/unix/sysv/linux/sh/sem_wait.S (__new_sem_wait): Likewise.

2012-05-03  David S. Miller  <davem@davemloft.net>

	* sysdeps/sparc/sparc64/pthread_spin_unlock.S: Fix thinko, we
	always have to return 0, especially for the pthread_spin_init
	alias.
	* sysdeps/sparc/sparc32/pthread_spin_lock.S: Add missing trailing
	newline.
	* sysdeps/sparc/sparc32/sparcv9/pthread_spin_lock.S: Likewise.
	* sysdeps/sparc/sparc64/pthread_spin_lock.S: Likewise.

2012-05-02  David S. Miller  <davem@davemloft.net>

	* sysdeps/sparc/sparc64/pthread_spin_lock.S: New.
	* sysdeps/sparc/sparc64/pthread_spin_lock.c: Delete.
	* sysdeps/sparc/sparc64/pthread_spin_unlock.S: New.
	* sysdeps/sparc/sparc64/pthread_spin_unlock.c: Delete.
	* sysdeps/sparc/sparc64/pthread_spin_trylock.S: New.
	* sysdeps/sparc/sparc64/pthread_spin_trylock.c: Delete.
	* sysdeps/sparc/sparc64/pthread_spin_init.c: New.
	* sysdeps/sparc/sparc32/pthread_spin_lock.S: New.
	* sysdeps/sparc/sparc32/pthread_spin_lock.c: Delete.
	* sysdeps/sparc/sparc32/pthread_spin_trylock.S: New.
	* sysdeps/sparc/sparc32/pthread_spin_trylock.c: Delete.
	* sysdeps/sparc/sparc32/sparcv9/pthread_spin_lock.S: New.
	* sysdeps/sparc/sparc32/sparcv9/pthread_spin_lock.c: Delete.
	* sysdeps/sparc/sparc32/sparcv9/pthread_spin_trylock.S: New.
	* sysdeps/sparc/sparc32/sparcv9/pthread_spin_trylock.c: Delete.
	* sysdeps/sparc/sparc32/sparcv9/pthread_spin_unlock.S: New.
	* sysdeps/sparc/sparc32/sparcv9/pthread_spin_unlock.c: Delete.
	* sysdeps/sparc/sparc32/sparcv9/pthread_spin_init.c: New.

2012-05-02  Allan McRae  <allan@archlinux.org>

	* Makefile: (LDFLAGS-tst-tls5): Use $(no-as-needed).
	(LDFLAGS-tst-cancel24): Likewise.

2012-05-02  Paul Pluzhnikov  <ppluzhnikov@google.com>

	* sysdeps/i386/pthread_spin_lock.S: New.
	* sysdeps/i386/pthread_spin_lock.c: Delete.
	* sysdeps/x86_64/pthread_spin_lock.S: New.
	* sysdeps/x86_64/pthread_spin_lock.c: Delete.

2012-04-28  Andreas Schwab  <schwab@linux-m68k.org>

	* Makefile ($(objpfx)tst-stack3-mem, $(objpfx)tst-tls6.out): Don't
	run when cross-compiling.

2012-04-26  Siddhesh Poyarekar  <siddhesh@redhat.com>

	* sysdeps/pthread/unwind-forcedunwind.c: Include gnu/lib-names.h
	instead of libgcc_s.h.

2012-04-20  Paul Pluzhnikov  <ppluzhnikov@google.com>

	* sysdeps/x86_64/tls.h (TLS_GET_FS, TLS_SET_FS): Delete.

2012-03-27  David S. Miller  <davem@davemloft.net>

	* tst-cond16.c (do_test): Use a thread stack size which is either
	PTHREAD_STACK_MIN or the page size, whichever is larger.
	* tst-cond18.c (do_test): Likewise.

2012-03-19  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/x86_64/pthreaddef.h (CURRENT_STACK_FRAME): Use
	register char * __asm__("rsp") to get stack frame.

2012-03-19  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h (SYS_futex): Use
	__NR_futex directly.

2012-03-19  H.J. Lu  <hongjiu.lu@intel.com>

	* unwind.c (unwind_stop): Cast _Unwind_GetCFA return to
	_Unwind_Ptr first.

2012-03-16  David S. Miller  <davem@davemloft.net>

	[BZ #13844]
	* sysdeps/unix/sysv/linux/libc-lowlevellock.c: Include using <..>
	instead of "...".
	* sysdeps/unix/sysv/linux/sparc/sparc32/libc-lowlevellock.c:
	Delete, not needed.

2012-03-15  David S. Miller  <davem@davemloft.net>

	[BZ #13844]
	* sysdeps/unix/sysv/linux/sparc/sparc32/libc-lowlevellock.c: New file.

2012-03-09  Paul Eggert  <eggert@cs.ucla.edu>

	[BZ #13673]
	* pt-crti.S: Replace FSF snail mail address with URL.

2012-03-09  Joseph Myers  <joseph@codesourcery.com>

	* sysdeps/pthread/pthread.h (__need_clockid_t, __need_timespec):
	Do not define before including <time.h>.

2012-03-08  David S. Miller  <davem@davemloft.net>

	* sysdeps/unix/sysv/linux/sparc/sem_post.c: Update copyright year.

2012-03-08  Thomas Schwinge  <thomas@codesourcery.com>

	* sysdeps/unix/sysv/linux/sh/lowlevellock.S (__lll_timedlock_wait):
	Check for timestamp before the Epoch.

	* sysdeps/unix/sysv/linux/sh/sem_timedwait.S (sem_timedwait): Fix
	updating nwaiters.

	* tst-sem13.c (do_test): Add another test case.
	* sysdeps/unix/sysv/linux/i386/i486/sem_timedwait.S (sem_timedwait):
	Fix updating nwaiters.

2012-03-07  Joseph Myers  <joseph@codesourcery.com>

	[BZ #10545]
	* sysdeps/pthread/configure.in (libc_cv_forced_unwind): Change
	link test to a compile test.
	(libc_cv_c_cleanup): Likewise.  Declare puts rather than including
	<stdio.h>.
	* sysdeps/pthread/configure: Regenerated.

2012-03-07  Ulrich Drepper  <drepper@gmail.com>

	* Makefile (distribute): Remove variable.

2012-01-23  Thomas Schwinge  <thomas@codesourcery.com>

	* sysdeps/unix/sysv/linux/sem_timedwait.c (sem_timedwait): Get rid of
	superfluous assignment.
	* sysdeps/unix/sysv/linux/sparc/sem_timedwait.c (sem_timedwait):
	Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sem_timedwait.c
	(sem_timedwait): Likewise.

2012-03-06  Ulrich Drepper  <drepper@gmail.com>

	* sysdeps/pthread/bits/libc-lock.h: Move information not needed in
	installed headers to...
	* sysdeps/pthread/bits/libc-lockP.h: ...here.  New file.

2012-03-06  David S. Miller  <davem@davemloft.net>

	* sysdeps/unix/sysv/linux/sparc/sem_post.c (__new_sem_post): Use
	atomic_increment and remove unused local variable.
	(__old_sem_post): Likewise.

2012-02-27  David S. Miller  <davem@davemloft.net>

	* sysdeps/unix/sysv/linux/i386/bits/pthreadtypes.h: Don't refer to
	non-existing __pthread_attr.
	* sysdeps/unix/sysv/linux/powerpc/bits/pthreadtypes.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/bits/pthreadtypes.h: Likewise.
	* sysdeps/unix/sysv/linux/sh/bits/pthreadtypes.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/bits/pthreadtypes.h: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/bits/pthreadtypes.h: Likewise.

2012-02-26  Ulrich Drepper  <drepper@gmail.com>

	* sysdeps/pthread/pthread.h: Define __need_clockid_t for __USE_XOPEN2K.

	* sysdeps/pthread/pthread.h: Define __need_timespec before including
	<time.h>.
	* sysdeps/unix/sysv/linux/i386/bits/pthreadtypes.h: Name pthread_attr_t
	union.
	* sysdeps/unix/sysv/linux/powerpc/bits/pthreadtypes.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/bits/pthreadtypes.h: Likewise.
	* sysdeps/unix/sysv/linux/sh/bits/pthreadtypes.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/bits/pthreadtypes.h: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/bits/pthreadtypes.h: Likewise.

2012-02-21  Joseph Myers  <joseph@codesourcery.com>

	[BZ #13695]
	* Makefile (generated): Remove crti.S, crtn.S, defs.h and
	pt-initfini.s.
	[crti.S not in sysdirs] (omit-deps): Do not append.
	[crti.S not in sysdirs] (CFLAGS-pt-initfini.s): Remove variable.
	[crti.S not in sysdirs] (pt-initfini.c): Remove vpath directive.
	[crti.S not in sysdirs] ($(objpfx)crti.S): Remove rule.
	[crti.S not in sysdirs] ($(objpfx)crtn.S): Likewise.
	[crti.S not in sysdirs] ($(objpfx)defs.h): Likewise.
	[crti.S not in sysdirs] ($(objpfx)crti.o): Likewise.
	[crti.S not in sysdirs] ($(objpfx)crtn.o): Likewise.
	[crti.S in sysdirs] (extra-objs): Append unconditionally.
	[crti.S in sysdirs] ($(objpfx)crti.o): Define rule
	unconditionally.
	* sysdeps/pthread/pt-initfini.c: Remove file.

2012-02-16  Richard Henderson  <rth@twiddle.net>

	* sysdeps/unix/sysv/linux/s390/s390-32/pt-initfini.c: Remove file.
	* sysdeps/unix/sysv/linux/s390/s390-64/pt-initfini.c: Remove file.

2012-02-15  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/unix/sysv/linux/sh/pt-initfini.c: Remove file.

2012-02-16  David S. Miller  <davem@davemloft.net>

	* sysdeps/sparc/Makefile: Add -fPIC when building pt-crti.S and crtn.S

2012-02-15  Marek Polacek  <polacek@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/Makefile: Remove file.

2012-02-09  Paul Eggert  <eggert@cs.ucla.edu>

	Replace FSF snail mail address with URLs, as per GNU coding standards.

2012-02-08  Andreas Schwab  <schwab@linux-m68k.org>

	* Makefile (extra-objs) [crti.S in sysdirs]: Add pt-crti.o.

2012-02-08  Joseph Myers  <joseph@codesourcery.com>

	Support crti.S and crtn.S provided directly by architectures.
	* Makefile [crti.S in sysdirs] (omit-deps): Do not append.
	[crti.S in sysdirs] (CFLAGS-pt-initfini.s): Do not define variable.
	[crti.S in sysdirs] ($(objpfx)pt-initfini.s): Disable rule.
	[crti.S in sysdirs] ($(objpfx)crti.S): Likewise.
	[crti.S in sysdirs] ($(objpfx)crtn.S): Likewise.
	[crti.S in sysdirs] ($(objpfx)defs.h): Likewise.
	[crti.S in sysdirs] ($(objpfx)crti.o): Likewise.
	[crti.S in sysdirs] ($(objpfx)crtn.o): Likewise.
	[crti.S in sysdirs] (pt-initfini.c): Remove vpath directive.
	[crti.S in sysdirs] ($(objpfx)crti.o): New rule.
	* pt-crti.S: New file.
	* sysdeps/unix/sysv/linux/i386/Makefile: Remove file.

2012-02-03  Joseph Myers  <joseph@codesourcery.com>

	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_wait.S: Use
	macros for PIC register setup.
	* sysdeps/unix/sysv/linux/i386/i486/sem_post.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/sem_timedwait.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/sem_trywait.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/sem_wait.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/pthread_once.S: Likewise.

2012-01-11  Marek Polacek  <polacek@redhat.com>

	* forward.c (FORWARD_NORETURN): Define macro.
	(__pthread_unwind): Use FORWARD_NORETURN macro to avoid warning.
	(__pthread_exit): Likewise.

2012-01-10  Ulrich Drepper  <drepper@gmail.com>

	* sysdeps/pthread/pthread.h: Add const attribute to pthread_equal.

	* pthreadP.h: Add noreturn to __pthread_exit.
	* sysdeps/pthread/pthread-functions.h: Likewise for ptr___pthread_exit.

2011-12-30  Adhemerval Zanella  <azanella@linux.vnet.ibm.com>

	* sysdeps/unix/sysv/linux/aio_misc.h (__aio_create_helper_thread):
	Call pthread_attr_setstacksize() with result of
	__pthread_get_minstack() to account for application TLS usage.

2012-01-08  Marek Polacek  <polacek@redhat.com>

	* sysdeps/unix/sysv/linux/mq_notify.c: Include <nptl/pthreadP.h>.

2012-01-07  Ulrich Drepper  <drepper@gmail.com>

	[BZ #13553]
	* pthreadP.h: Use const instead of __const.
	* semaphore.h: Likewise.
	* sysdeps/pthread/bits/libc-lock.h: Likewise.
	* sysdeps/pthread/bits/sigthread.h: Likewise.
	* sysdeps/pthread/pthread.h: Likewise.

	* Makefile: Remove elf=yes test, only ELF is supported.

	* shlib-versions: Remove entries for ports architectures.

	In case anyone cares, the IA-64 architecture could move to ports.
	* sysdeps/ia64/*: Removed.
	* sysdeps/unix/sysv/linux/ia64/*: Removed.

2011-12-22  Ulrich Drepper  <drepper@gmail.com>

	* sysdeps/pthread/gai_misc.h (__gai_create_helper_thread): Use
	__pthread_get_minstack.
	* sysdeps/unix/sysv/linux/mq_notify.c (init_mq_netlink): Likewise.

	[BZ #13088]
	* sysdeps/unix/sysv/linux/timer_routines.c: Get minimum stack size
	through __pthread_get_minstack.
	* nptl-init.c (__pthread_initialize_minimal_internal): Get page size
	directly from _rtld_global_ro.
	(__pthread_get_minstack): New function.
	* pthreadP.h: Declare __pthread_get_minstack.
	* Versions (libpthread) [GLIBC_PRIVATE]: Add __pthread_get_minstack.

2011-12-21  Ulrich Drepper  <drepper@gmail.com>

	[BZ #13515]
	* sysdeps/unix/sysv/linux/pthread_getname.c (pthread_getname_np):
	Correct reading name from file.

2011-12-14  Carlos O'Donell  <carlos@systemhalted.org>

	* allocatestack.c (allocate_stack): Return errno on failure.

2011-12-14  Jeff Law  <law@redhat.com>

	[BZ #5245]
	* pthread_create.c (__pthread_create_2_1): Translate ENOMEM to EAGAIN.

2011-11-28  Andreas Schwab  <schwab@redhat.com>

	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_wait.S: Handle
	EAGAIN from FUTEX_WAIT_REQUEUE_PI.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S: Likewise.

2011-11-15  Ulrich Drepper  <drepper@gmail.com>

	* pthread_getattr_np.c (pthread_getattr_np): Set FD_CLOEXEC for
	/proc/self/maps.

2011-10-29  Ulrich Drepper  <drepper@gmail.com>

	[BZ #13358]
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S
	(__pthread_cond_timedwait): Initialize %r15 correctly also for code
	path for kernels with FUTEX_CLOCK_REALTIME.
	Debugged by H.J. Lu <hjl.tools@gmail.com>.

2011-10-27  Andreas Schwab  <schwab@redhat.com>

	[BZ #13344]
	* sysdeps/pthread/pthread.h: Use __THREADNL instead of __THREAD
	for memory synchronization functions.
	* semaphore.h: Likewise.

2011-10-24  Ulrich Drepper  <drepper@gmail.com>

	* tst-cancel7.c: Avoid warning.
	* tst-mutex6.c: Likewise.
	* tst-mutex9.c: Likewise.
	* tst-mutexpi6.c: Likewise.

2011-10-23  Ulrich Drepper  <drepper@gmail.com>

	* sysdeps/i386/tls.h: Remove #include <list.h>.

2011-10-15  Ulrich Drepper  <drepper@gmail.com>

	* pthread_create.c (start_thread): Call __ctype_init.

2011-09-15  Andreas Schwab  <schwab@redhat.com>

	* sysdeps/pthread/list.h: Define only list_t if __need_list_t is
	defined.
	(list_add): Add atomic_write_barrier.
	* descr.h: Define __need_list_t before including <list.h>.
	* nptl-init.c: Include <list.h>
	* allocatestack.c: Likewise.

2011-09-11  Ulrich Drepper  <drepper@gmail.com>

	* sysdeps/i386/tls.h: Remove HAVE_TLS_SUPPORT test.
	* sysdeps/ia64/tls.h: Likewise.
	* sysdeps/powerpc/tls.h: Likewise.
	* sysdeps/s390/tls.h: Likewise.
	* sysdeps/sh/tls.h: Likewise.
	* sysdeps/sparc/tls.h: Likewise.
	* sysdeps/x86_64/tls.h: Likewise.

2011-09-10  Ulrich Drepper  <drepper@gmail.com>

	* sysdeps/pthread/malloc-machine.h: Define MUTEX_INITIALIZER.

	* sysdeps/unix/sysv/linux/i386/i486/sem_post.S: Don't handle
	!USE___THREAD.
	* sysdeps/unix/sysv/linux/i386/i486/sem_timedwait.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/sem_trywait.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/sem_wait.S: Likewise.
	* sysdeps/unix/sysv/linux/ia64/sysdep-cancel.h: Likewise.
	* sysdeps/unix/sysv/linux/sh/sem_post.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/sem_timedwait.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/sem_trywait.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/sem_wait.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/sem_post.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/sem_timedwait.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/sem_trywait.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/sem_wait.S: Likewise.

	* tst-tls1.c: Support for __thread is now mandatory.
	* tst-tls2.c: Likewise.
	* tst-tls3.c: Likewise.
	* tst-tls3mod.c: Likewise.
	* tst-tls4.c: Likewise.
	* tst-tls4moda.c: Likewise.
	* tst-tls4modb.c: Likewise.
	* tst-tls5.h: Likewise.

2011-09-08  Ulrich Drepper  <drepper@gmail.com>

	[BZ #12403]
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedwrlock.S
	(pthread_rwlock_timedwrlock): Use correct macro in test.
	Patch by H.J. Lu <hongjiu.lu@intel.com>.

2011-09-06  Ulrich Drepper  <drepper@gmail.com>

	* sysdeps/unix/sysv/linux/x86_64/sem_timedwait.S (sem_timedwait): Don't
	use gettimeofday vsyscall, just call gettimeofday.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/lowlevelrobustlock.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedrdlock.S:
	Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedwrlock.S:
	Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S: Likewise.
	Simplify __vdso_clock_gettime use.

2011-09-05  David S. Miller  <davem@davemloft.net>

	* sysdeps/unix/sysv/linux/sem_timedwait.c (do_futex_timed_wait):
	New function.
	(sem_timedwait): Call it to force an exception region around
	the async cancel enable and the futex operation.
	* sysdeps/unix/sysv/linux/sparc/sem_timedwait.c: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sem_timedwait.c: Likewise.
	* sysdeps/unix/sysv/linux/sem_wait.c (do_futex_wait): New function.
	(__new_sem_wait): Call it to force an exception region around
	the async cancel enable and the futex operation.
	* sysdeps/unix/sysv/linux/sparc/sem_wait.c: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sem_wait.c: Likewise.

2011-08-31  Andreas Schwab  <schwab@redhat.com>

	* allocatestack.c (setxid_mark_thread): Ensure that the exiting
	thread is woken up.

2011-08-20  David S. Miller  <davem@davemloft.net>

	* Makefile (tst-cleanup0.out): Fix typo in output redirection.

2011-08-14  Roland McGrath  <roland@hack.frob.com>

	* sysdeps/i386/pthreaddef.h (TCB_ALIGNMENT): Set to 64, optimal on Atom.
	* sysdeps/x86_64/pthreaddef.h (TCB_ALIGNMENT): Likewise.

2011-08-08  Andreas Schwab  <schwab@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/cancellation.S: Maintain aligned
	stack.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S: Likewise.

2011-07-22  Ulrich Drepper  <drepper@gmail.com>

	* sysdeps/pthread/unwind-forcedunwind.c (_Unwind_Resume): Add read
	barrier.
	(__gcc_personality_v0): Likewise.
	(_Unwind_ForcedUnwind): Likewise.
	(_Unwind_GetCFA): Likewise.

2011-07-14  Roland McGrath  <roland@hack.frob.com>

	* allocatestack.c (__reclaim_stacks): Use uintptr_t cast rather than
	UINTMAX_C.

2011-06-30  Ulrich Drepper  <drepper@gmail.com>

	* nptl-init.c (__nptl_set_robust): New function.
	(pthread_functions): Add reference.
	* npthreadP.h: Declare __nptl_set_robust.
	* sysdeps/pthread/pthread-functions.h (pthread_functions): Add
	ptr_set_robust member.
	* sysdeps/unix/sysv/linux/fork.c: Call set_robust_list syscall in
	child if threads are used.

2011-06-14  Andreas Jaeger  <aj@suse.de>

	* pthread_rwlock_init.c: Include <string.h> for memset declaration.

2011-05-11  Ulrich Drepper  <drepper@gmail.com>

	[BZ #386]
	* allocatestack.c (allocate_stack): Convert ENOMEM error to EAGAIN.

2011-04-10  Ulrich Drepper  <drepper@gmail.com>

	[BZ #12650]
	* allocatestack.c (get_cached_stack): Deallocate DTV entries before
	clearing memory.
	Patch partly by Robert Rex <robert.rex@exasol.com>.

2011-01-19  Roland McGrath  <roland@redhat.com>

	* pthread_cond_wait.c (__pthread_cond_wait): Fix comment typo.
	* pthread_cond_timedwait.c (__pthread_cond_timedwait): Likewise.
	* pthread_rwlock_rdlock.c (__pthread_rwlock_rdlock): Likewise.
	* pthread_rwlock_wrlock.c (__pthread_rwlock_wrlock): Likewise.
	* pthread_rwlock_timedrdlock.c (pthread_rwlock_timedrdlock): Likewise.
	* pthread_rwlock_timedwrlock.c (pthread_rwlock_timedwrlock): Likewise.

2011-01-16  Andreas Schwab  <schwab@linux-m68k.org>

	* Makefile (test-extras): Add tst-cleanup4aux.

2011-01-14  Ulrich Drepper  <drepper@gmail.com>

	[BZ #10563]
	* sysdeps/pthread/setxid.h (__SETXID_1): Add cast to assignment.
	(__SETXID_2): Likewise.
	(__SETXID_3): Likewise.

2011-01-13  Ulrich Drepper  <drepper@gmail.com>

	[BZ #10484]
	* Versions [libc] (GLIBC_PRIVATE): Export __libc_alloca_cutoff.
	* alloca_cutoff.c: Add libc_hidden_def.

2010-10-13  H.J. Lu  <hongjiu.lu@intel.com>

	[BZ #12113]
	* sysdeps/x86_64/pthreaddef.h (TCB_ALIGNMENT): Changed to 32.
	* sysdeps/x86_64/tls.h (TLS_TCB_ALIGN): Defined with alignment
	of "struct pthread".

2010-09-21  Andreas Schwab  <schwab@redhat.com>

	* sysdeps/pthread/pthread.h (pthread_cleanup_push)
	[!__EXCEPTIONS]: Mangle local variable not_first_call.
	(pthread_cleanup_push_defer_np): Likewise.

2010-09-03  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/allocalim.h (__libc_use_alloca): Expect blocks are
	small.

2010-08-10  Dinakar Guniguntala  <dino@in.ibm.com>
	    Stefan Hajnoczi  <stefanha@linux.vnet.ibm.com>

	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_signal.S: If
	FUTEX_WAKE_OP fails make sure to call FUTEX_WAKE instead.

2010-08-12  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/i386/Makefile: New file.

2010-05-01  Alan Modra  <amodra@gmail.com>

	* sysdeps/unix/sysv/linux/powerpc/powerpc64/sysdep-cancel.h
	(PSEUDO): Use correct cr save.  Don't use wrong parm save area
	to save temps.  Correct cfi for possible later frame manipulation.
	(DOCARGS_1, UNDOCARGS_1): Use the correct parm save area.
	(DOCARGS_2, UNDOCARGS_2, DOCARGS_3, UNDOCARGS_3): Likewise.
	(DOCARGS_4, UNDOCARGS_4, DOCARGS_5, UNDOCARGS_5): Likewise.
	(DOCARGS_6, UNDOCARGS_6): Likewise.
	(CENABLE, CDISABLE): Add nops for non-shared calls.

2010-07-06  Andreas Schwab  <schwab@redhat.com>

	* sysdeps/unix/sysv/linux/pthread_getname.c (pthread_getname_np):
	Fix type mismatch.

2010-07-03  Ulrich Drepper  <drepper@redhat.com>

	* tst-abstime.c (do_test): Some more cleanups

2010-07-02  Ulrich Drepper  <drepper@redhat.com>

	* tst-abstime.c: Correct testing and add test for sem_timedwait.

2010-07-01  Andreas Schwab  <schwab@redhat.com>
	    Ulrich Drepper  <drepper@redhat.com>

	* Makefile (tests): Add tst-abstime.
	* tst-abstime.c: New file.
	* sysdeps/unix/sysv/linux/i386/i486/lowlevellock.S
	(__lll_timedlock_wait): Check for timestamp before the Epoch.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.S
	(__lll_timedlock_wait): Likewise.
	* sysdeps/unix/sysv/linux/x86_64/lowlevelrobustlock.S
	(__lll_robust_timedlock_wait): Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S
	(__pthread_cond_timedwait): Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedrdlock.S
	(pthread_rwlock_timedrdlock): Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedwrlock.S
	(pthread_rwlock_timedwrlock): Likewise.
	* sysdeps/unix/sysv/linux/x86_64/sem_timedwait.S (sem_timedwait):
	Likewise.

2010-07-01  Ulrich Drepper  <drepper@redhat.com>

	* Makefile (tst-_res1): Add tst-_res1mod1 to dependency list.

2010-06-01  Takashi Yoshii  <takashi.yoshii.zj@renesas.com>

	* sysdeps/unix/sysv/linux/sh/lowlevellock.S: Fix incorrect
	location of ifndef __ASSUME_FUTEX_CLOCK_REALTIME.

2010-04-09  Ulrich Drepper  <drepper@redhat.com>

	[BZ #11390]
	* sysdeps/unix/sysv/linux/pthread_getname.c: New file.
	* sysdeps/unix/sysv/linux/pthread_setname.c: New file.
	* nptl/sysdeps/pthread/pthread.h: Declare pthread_getname and
	pthread_setname.
	* Makefile (libpthread-routines): Add pthread_getname and
	pthread_setname.
	* Versions: Export pthread_getname and pthread_setname for GLIBC_2.12.

2010-04-05  Thomas Schwinge  <thomas@schwinge.name>

	* sysdeps/pthread/unwind-resume.c: Moved to main tree sysdeps/gnu/.
	* sysdeps/pthread/rt-unwind-resume.c: Likewise.
	* sysdeps/pthread/Makefile: Remove csu section and rt section's
	unwind-resume bits, now in main tree sysdeps/gnu/Makefile instead.

2010-03-23  Luis Machado  <luisgpm@br.ibm.com>

	* pthread_cond_timedwait.c: Add check for
	HAVE_CLOCK_GETTIME_VSYSCALL to use VDSO whenever possible.
	(pthread_cond_timedwait): Use INTERNAL_VSYSCALL instead of
	INTERNAL_SYSCALL.

2010-03-09  Ulrich Drepper  <drepper@redhat.com>

	* pthread_create.c (__pthread_create_2_1): If priorities are incorrect
	and the call fails wake eventually waiting setxid threads.  Don't free
	stack here if we try starting a thread.
	* sysdeps/pthread/createthread.c (do_clone): Only wake setxid waiter
	if the clone call failed.

2010-03-08  Andreas Schwab  <schwab@redhat.com>

	* pthread_create.c (__pthread_create_2_1): Don't set setxid_futex.
	* allocatestack.c (get_cached_stack): Set setxid_futex.
	(allocate_stack): Likewise.

2010-03-05  Andreas Schwab  <schwab@redhat.com>
	    Ulrich Drepper  <drepper@redhat.com>

	* allocatestack.c (setxid_mark_thread): Delay handling of thread if
	it is creating a thread or it is just being created.
	* pthread_create.c (start_thread): Wake setxid thread if it is
	waiting.
	(__pthread_create_2_1): Initialize setxid_futex.
	* sysdeps/pthread/createthread.c (do_clone): Wake setxid thread if it
	is waiting.

2010-01-15  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_timedwait.S:
	Fix unwind info.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_wait.S: Likewise.

2010-01-15  Michal Schmidt  <mschmidt@redhat.com>

	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_timedwait.S:
	Fix pthread_cond_timedwait with requeue-PI.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_wait.S:
	Fix pthread_cond_wait with requeue-PI.

2010-01-14  Ulrich Drepper  <drepper@redhat.com>

	* Versions: Add pthread_mutex_consistent, pthread_mutexattr_getrobust,
	and pthread_mutexattr_setrobust for GLIBC_2.12.
	* pthread_mutex_consistent.c: Define alias pthread_mutex_consistent.
	* pthread_mutexattr_getrobust.c: Define alias
	pthread_mutexattr_getrobust.
	* pthread_mutexattr_setrobust.c: Define alias
	pthread_mutexattr_setrobust.

2010-01-12  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/pthread.h: Cleanup.  Fix up for XPG7.

2010-01-08  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/pthread.h: Fix pthread_mutex_consistent declaration.

2009-12-18  Thomas Schwinge  <thomas@codesourcery.com>

	* sysdeps/unix/sysv/linux/s390/s390-32/pt-initfini.c (_init): Don't
	call __gmon_start__.
	* sysdeps/unix/sysv/linux/s390/s390-64/pt-initfini.c (_init): Likewise.

2009-12-17  Ulrich Drepper  <drepper@redhat.com>

	* pthread_rwlock_init.c (__pthread_rwlock_init): Simplify code by
	using memset.

2009-12-01  Dinakar Guniguntala  <dino@in.ibm.com>

	* sysdeps/unix/sysv/linux/i386/i486/lowlevellock.h: Define
	FUTEX_WAIT_REQUEUE_PI and FUTEX_CMP_REQUEUE_PI.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_broadcast.S: If mutex
	is a non robust PI mutex, then use FUTEX_CMP_REQUEUE_PI.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_signal.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_timedwait.S: If mutex
	is a non robust PI mutex, then use FUTEX_WAIT_REQUEUE_PI.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_wait.S: Likewise.

2009-12-12  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/i386/i486/sem_timedwait.S (sem_timedwait):
	Don't update nwaiters after invalid timeout is recognized.

2009-11-27  Thomas Schwinge  <thomas@codesourcery.com>

	* sysdeps/unix/sysv/linux/sh/pt-initfini.c (_init): Don't call
	__gmon_start__.

2009-11-27  Andreas Schwab  <schwab@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/cancellation.S: Reload
	THREAD_SELF->cancelhandling after returning from futex call.

2009-11-24  Ulrich Drepper  <drepper@redhat.com>

	* tst-sem13.c: New file.
	* Makefile (tests): Add tst-sem13.

2009-11-22  Roland McGrath  <roland@redhat.com>

	* sysdeps/unix/sysv/linux/i386/dl-sysdep.h: # include "i686/dl-sysdep.h"
	instead of recapitulating its contents.

2009-11-18  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_broadcast.S: Minor
	optimizations and cleanups.

2009-11-18  Dinakar Guniguntala  <dino@in.ibm.com>

	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_broadcast.S:
	Remove redundant code. Fix cfi offsets.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_signal.S:
	Fix cfi offsets.

2009-11-17  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S: Minimally
	reduce size of unwind info.

	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_wait.S: Convert to use
	cfi directives.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_timedwait.S: Likewise.
	Based on a patch by Dinakar Guniguntala <dino@in.ibm.com>.

2009-11-03  Andreas Schwab  <schwab@linux-m68k.org>

	[BZ #4457]
	* sysdeps/pthread/unwind-resume.c: Include <libgcc_s.h> and use
	LIBGCC_S_SO.
	* sysdeps/pthread/unwind-forcedunwind.c: Likewise.

2009-10-30  Ulrich Drepper  <drepper@redhat.com>

	* tst-sem11.c (main): Rewrite to avoid aliasing problems.

	[BZ #3270]
	* allocatestack.c (__nptl_setxid): Perform the operation in multiple
	steps to avoid races with creation and terminations.
	* nptl-init.c (sighandler_setxid): Adjust.
	Patch by Daniel Jacobowitz.

2009-09-07  Andreas Schwab  <schwab@redhat.com>

	* sysdeps/pthread/bits/libc-lock.h (BP_SYM): Remove space before paren.

2009-09-02  Suzuki K P  <suzuki@in.ibm.com>
	    Joseph Myers  <joseph@codesourcery.com>

	[BZ #7094]
	* sysdeps/unix/sysv/linux/timer_create.c (timer_create):
	Initialize the sigev_notify field for newly created timer to make sure
	the timer gets deleted from the active timer's list upon timer_delete.

2009-08-27  Andrew Stubbs  <ams@codesourcery.com>

	* sysdeps/unix/sysv/linux/sh/lowlevellock.S (__lll_timedlock_wait):
	Correct a logic error.

2009-08-25  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/x86_64/tls.h (RTLD_ENABLE_FOREIGN_CALL): Store old value
	of the field in local variables.
	(RTLD_FINALIZE_FOREIGN_CALL): Restore rtld_must_xmm_save from local
	variable and don't unconditionally clear it.

2009-08-24  Ulrich Drepper  <drepper@redhat.com>

	* pthread_create.c (start_thread): Hint to the kernel that memory for
	the stack can be reused.  We do not mark all the memory.  The part
	still in use and some reserve are kept.

2009-08-23  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/bits/posix_opt.h: Clean up namespace.

2009-08-11  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_unlock.S: Add CFI
	directives.

2009-08-10  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_rdlock.S: Add CFI
	directives.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_wrlock.S: Likewise.

2009-08-10  Andreas Schwab  <schwab@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_signal.S
	(__pthread_cond_signal): Don't clobber register used for syscall
	number.

2009-08-08  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/sem_timedwait.S (sem_timedwait):
	Optimize code path used when FUTEX_CLOCK_REALTIME is supported.

	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S
	(__pthread_cond_wait): Optimize by avoiding use of callee-safe
	register.

2009-08-07  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/sem_wait.S: Little optimizations
	enabled by the special *_asynccancel functions.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S: Likewise.

	* sysdeps/unix/sysv/linux/x86_64/cancellation.S: Include lowlevellock.h.

2009-08-04  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/cancellation.S: New file.
	* sysdeps/unix/sysv/linux/x86_64/libc-cancellation.S: New file.
	* sysdeps/unix/sysv/linux/x86_64/librt-cancellation.S: New file.
	* sysdeps/unix/sysv/linux/x86_64/sysdep-cancel.h (PSEUDO): Optimize
	since we can assume the special __*_{en,dis}able_asynccancel
	functions.
	(PUSHARGS_*, POPARGS_*, SAVESTK_*, RESTSTK_*): Removed.
	* sysdeps/x86_64/tcb-offsets.sym: Add cancellation-related bits
	and PTHREAD_CANCELED.

2009-07-31  Ulrich Drepper  <drepper@redhat.com>

	* descr.h: Better definition of *_BITMASK macros for cancellation.

2009-07-29  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/x86_64/tls.h (TLS_TCB_ALIGN): Define explicitly to 32.

	* sysdeps/x86_64/tls.h (tcbhead_t): Add room for SSE registers the
	dynamic linker might have to save.
	Define RTLD_CHECK_FOREIGN_CALL, RTLD_ENABLE_FOREIGN_CALL,
	RTLD_PREPARE_FOREIGN_CALL, and RTLD_FINALIZE_FOREIGN_CALL.  Pretty
	printing.

	* sysdeps/x86_64/tcb-offsets.sym: Add RTLD_SAVESPACE_SSE.

2009-07-28  Ulrich Drepper  <drepper@redhat.com>

	* pthread_mutex_lock.c [NO_INCR] (__pthread_mutex_cond_lock_adjust):
	New function.
	* pthreadP.h: Declare __pthread_mutex_cond_lock_adjust.
	* sysdeps/unix/sysv/linux/pthread-pi-defines.sym: Add ROBUST_BIT.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_broadcast.S: Don't use
	requeue_pi for robust mutexes.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_signal.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S: Likewise.
	Don't only skip __pthread_mutex_cond_lock.  Call instead
	__pthread_mutex_cond_lock_adjust.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S: Likewise.

	* pthread_mutex_unlock.c (__pthread_mutex_unlock_full): Minor
	optimization of PI mutex handling.

2009-07-27  Ulrich Drepper  <drepper@redhat.com>

	[BZ #10418]
	* pthread_mutex_unlock.c (__pthread_mutex_unlock_full): Use _rel
	instead of of _acq variants of cmpxchg.

2009-07-23  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/x86_64/configure.in: New file.

	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S: Fix error
	path when not using absolute timeout futex.

2009-07-20  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S: Minor
	optimizations of last changes.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S: Likewise.

2009-07-19  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h: Define
	FUTEX_WAIT_REQUEUE_PI and FUTEX_CMP_REQUEUE_PI.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_broadcast.S: If mutex
	is a PI mutex, then use FUTEX_CMP_REQUEUE_PI.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_signal.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S: If mutex
	is a PI mutex, then use FUTEX_WAIT_REQUEUE_PI.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S: Likewise.

	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S
	(__pthread_cond_timedwait): Make more robust.

2009-07-18  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/lowlevelrobustlock.S
	(__lll_robust_timedlock_wait): If possible use FUTEX_WAIT_BITSET to
	directly use absolute timeout.

	* tst-sem5.c (do_test): Add test for premature timeout.
	* Makefile: Linu tst-sem5 with librt.

	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedwrlock.S
	(pthread_rwlock_timedwrlock): If possible use FUTEX_WAIT_BITSET to
	directly use absolute timeout.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedrdlock.S
	(pthread_rwlock_timedrdlock): Likewise.

	* tst-cond11.c (run_test): Add test to check that the timeout is
	long enough.

	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S
	(__pthread_cond_timedwait): If possible use FUTEX_WAIT_BITSET to
	directly use absolute timeout.

	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S
	(__pthread_cond_wait): Convert to using exception handler instead of
	registered unwind buffer.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S
	(__pthread_cond_timedwait): Likewise.

2009-07-17  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/sem_timedwait.S (sem_timedwait):
	If possible use FUTEX_WAIT_BITSET|FUTEX_CLOCK_REALTIME to directly
	use absolute timeout.

	* sysdeps/unix/sysv/linux/x86_64/sem_wait.S (sem_wait): Optimize
	handling of uncontested semaphore.

	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S
	(__condvar_cleanup): Rewrite to use cfi directives instead of
	hand-coded unwind tables.
	* sysdeps/unix/sysv/linux/x86_64/pthread_once.S (__pthread_once):
	Likewise.
	* sysdeps/unix/sysv/linux/x86_64/sem_wait.S (sem_wait): Likewise.
	* sysdeps/unix/sysv/linux/x86_64/sem_timedwait.S (sem_timedwait):
	Likewise.

2009-06-12  Ulrich Drepper  <drepper@redhat.com>

	* Makefile (libpthread-routines): Add pthread_sigqueue.
	* Versions: Add pthread_sigqueue for GLIBC_2.11.
	* sysdeps/pthread/bits/sigthread.h: Declare pthread_sigqueue.
	* sysdeps/unix/sysv/linux/pthread_sigqueue.c: New file.

2009-06-11  Ulrich Drepper  <drepper@redhat.com>

	[BZ #10262]
	* sysdeps/unix/sysv/linux/i386/i486/lowlevellock.S
	(LOAD_FUTEX_WAIT_ABS): Fix futex parameter in case private futexes
	cannot be assumed.
	Patch by Bryan Kadzban <bz-glibc@kdzbn.homelinux.net>.

2009-05-16  Ulrich Drepper  <drepper@redhat.com>

	* libc-cancellation.c: Move __libc_cleanup_routine to...
	* libc-cleanup.c: ...here.  New file.
	* Makefile (routines): Add libc-cleanup.

	* cancellation.c (__pthread_disable_asynccancel): Remove unnecessary
	test.
	* libc-cancellation.c: Use <nptl/cancellation.c: to define the code.
	* sysdeps/pthread/librt-cancellation.c: Likewise.

	[BZ #9924]
	* nptl-init.c: Renamed from init.c.
	* Makefile: Change all occurences of init.c to nptl-init.c.

2009-05-15  Ulrich Drepper  <drepper@redhat.com>

	* cancellation.c (__pthread_disable_asynccancel): Correct the bits
	to test when deciding on the delay.
	* libc-cancellation.c (__libc_disable_asynccancel): Likewise.
	* pthread_cancel.c: Close race between deciding on sending a signal
	and setting the CANCELING_BIT bit.

	* cancellation.c (__pthread_disable_asynccancel): Don't return if
	thread is canceled.
	* libc-cancellation.c (__libc_disable_asynccancel): Likewise.

2009-04-27  Ulrich Drepper  <drepper@redhat.com>

	* cancellation.c (__pthread_disable_asynccancel): Use THREAD_ATOMIC_AND
	is available.
	* libc-cancellation.c (__libc_disable_asynccancel): Likewise.
	* sysdeps/x86_64/tls.h: Define THREAD_ATOMIC_AND.
	* sysdeps/i386/tls.h: Likewise.
	(tcbhead_t): Add __private_tm member.

2009-04-26  Ulrich Drepper  <drepper@redhat.com>

	* sem_open.c (sem_open): Rewrite initialization of initsem to
	avoid warnings.

	* sysdeps/unix/sysv/linux/libc_pthread_init.c (__libc_pthread_init):
	Avoid warning by using may_alias attribute on ptrhack.

2009-04-22  Ulrich Drepper  <drepper@redhat.com>

	[BZ #10090]
	* pthread_attr_setschedparam.c (__pthread_attr_setschedparam):
	Check policy and priority for validity.
	Patch mostly by Zhang Xiliang <zhangxiliang@cn.fujitsu.com>.

2009-03-15  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S
	(__pthread_cond_timedwait): Change to use cfi directives instead of
	hand-coded unwind sections.

2009-03-10  Ulrich Drepper  <drepper@redhat.com>

	* init.c (nptl_freeres): Compile only for SHARED.

2009-03-09  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/sparc/lowlevellock.h: Define
	FUTEX_WAIT_BITSET, FUTEX_WAKE_BITSET, FUTEX_CLOCK_REALTIME and
	FUTEX_BITSET_MATCH_ANY.

2009-02-27  Roland McGrath  <roland@redhat.com>

	* init.c (__nptl_initial_report_events): Mark __attribute_used__.
	* pthread_create.c (__nptl_threads_events, __nptl_last_event): Likewise.

2009-02-26  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/bits/posix_opt.h: Define
	_POSIX_THREAD_ROBUST_PRIO_INHERIT and
	_POSIX_THREAD_ROBUST_PRIO_PROTECT.  Reset value of macros from
	200112L to 200809L.

2009-02-25  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/pthread.h: The robust mutex functions are in
	POSIX 2008.

2009-02-24  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/bits/posix_opt.h (_BITS_POSIX_OPT_H):
	Unify name of include protector macro.

2009-02-14  SUGIOKA Toshinobu  <sugioka@itonet.co.jp>

	* sysdeps/unix/sysv/linux/sh/lowlevellock.S: Define
	LOAD_FUTEX_WAIT_ABS even if (FUTEX_WAIT == 0).

2009-01-29  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/unwind-forcedunwind.c: Encrypt all function
	pointer variables.

	* allocatestack.c (__free_stacks): Renamed from free_stacks.
	(__free_stack_cache): Removed.  Change callers to call __free_stacks.
	* init.c (nptl_freeres): New function.
	(pthread_functions): Initialize ptr_freeres to nptl_freeres.
	* pthreadP.h: Don't declare __free_stack_cache.  Declare __free_stacks.
	* sysdeps/pthread/unwind-forcedunwind.c (libgcc_s_handle): New
	variable.
	(pthread_cancel_init): Depend in libgcc_s_handle for decision to
	load DSO.  Assign last.
	(__unwind_freeres): New function.

	* allocatestack.c (__reclaim_stacks): Reset in_flight_stack later
	for better debugging.  No need to use stack_list_add here.

2009-01-14  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/unix/sysv/linux/sh/lowlevellock.S
	(__lll_timedlock_wait): Use FUTEX_WAIT_BITSET|FUTEX_CLOCK_REALTIME
	instead of computing relative timeout.
	* sysdeps/unix/sysv/linux/sh/lowlevellock.h: Define
	FUTEX_CLOCK_REALTIME and FUTEX_BITSET_MATCH_ANY.

2009-01-25  Ulrich Drepper  <drepper@redhat.com>

	* pthread_mutex_lock.c (__pthread_mutex_lock): Remove unused label out.

2009-01-08  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/list.h (list_add): Initialize new element first.
	(list_add_tail): Removed.

2009-01-07  Ulrich Drepper  <drepper@redhat.com>

	* (in_flight_stack): New variable.
	(stack_list_del): New function.  Use instead of list_del.
	(stack_list_add): New function.  Use instead of list_add when adding to
	stack_cache and stack_used lists.
	(__reclaim_stacks): Complete operations on stack_cache and stack_used lists
	when the fork call interrupted another thread.

2009-01-04  Ulrich Drepper  <drepper@redhat.com>

	* init.c (__pthread_initialize_minimal_internal): Optimize test
	FUTEX_CLOCK_REALTIME a bit.

2009-01-03  Ulrich Drepper  <drepper@redhat.com>

	* init.c (__pthread_initialize_minimal_internal): Cheat a bit by
	only passing five parameters to FUTEX_WAIT_BITSET call.

	* sysdeps/unix/sysv/linux/i386/i486/lowlevellock.S
	(__lll_timedlock_wait): Use FUTEX_WAIT_BITSET|FUTEX_CLOCK_REALTIME
	instead of computing relative timeout.

2009-01-02  Ulrich Drepper  <drepper@redhat.com>

	* init.c (__pthread_initialize_minimal_internal): Check for
	FUTEX_CLOCK_REALTIME flag.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.S (__lll_timedlock_wait):
	Use FUTEX_WAIT_BITSET|FUTEX_CLOCK_REALTIME instead of computing
	relative timeout.

	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h: Define
	FUTEX_CLOCK_REALTIME and FUTEX_BITSET_MATCH_ANY.
	* sysdeps/unix/sysv/linux/i386/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/ia64/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/lowlevellock.h: Likewise.

2008-12-09  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/pthread.h (pthread_cleanup_pop): Use { } as empty
	loop body instead of ; to avoid gcc warnings.
	(pthread_cleanup_pop_restore_np): Likewise.
	Patch by Caolán McNamara <caolanm@redhat.com>.

2008-12-09  Jakub Jelinek  <jakub@redhat.com>

	* pthread_mutex_lock.c (__pthread_mutex_lock): Handle only the
	fast path here, for robust/PI/PP mutexes call
	__pthread_mutex_lock_full.  Don't use switch, instead use a series
	of ifs according to their probability.
	(__pthread_mutex_lock_full): New function.
	* pthread_mutex_unlock.c: Include assert.h.
	(__pthread_mutex_unlock_usercnt): Handle only the
	fast path here, for robust/PI/PP mutexes call
	__pthread_mutex_unlock_full.  Don't use switch, instead use a series
	of ifs according to their probability.
	(__pthread_mutex_unlock_full): New function.
	* sysdeps/unix/sysv/linux/pthread_mutex_cond_lock.c
	(__pthread_mutex_lock_full): Define.

2008-12-08  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/x86_64/tls.h (tcbhead_t): Add fields reserved for TM
	implementation.  Add necessary padding and.
	* descr.h (struct pthread): Increase padding for tcbhead_t to 24
	words.

2008-12-04  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/unix/sysv/linux/sh/lowlevellock.h: Define FUTEX_WAIT_BITSET
	and FUTEX_WAKE_BITSET.

2008-12-02  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/i386/lowlevellock.h: Define FUTEX_WAIT_BITSET
	and FUTEX_WAKE_BITSET.
	* sysdeps/unix/sysv/linux/ia64/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h: Likewise.

2008-11-25  Roland McGrath  <roland@redhat.com>

	* sysdeps/alpha, sysdeps/unix/sysv/linux/alpha:
	Subdirectories moved to ports repository as
	sysdeps/.../nptl subdirectories.

2008-11-12  Jakub Jelinek  <jakub@redhat.com>

	[BZ #7008]
	* pthread_condattr_setclock.c (pthread_condattr_setclock): Fix masking
	of old value.
	* pthread_cond_init.c (__pthread_cond_init): Fix
	cond->__data.__nwaiters initialization.
	* Makefile (tests): Add tst-cond23.
	* tst-cond23.c: New test.

2008-11-07  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/pthread/malloc-machine.h (MALLOC): Adjust __libc_tsd_define
	arguments.
	(tsd_setspecific, tsd_getspecific): Adjust __libc_tsd_{set,get}
	arguments.

2008-11-01  Ulrich Drepper  <drepper@redhat.com>

	[BZ #6955]
	* pthread_mutex_lock.c: Add support for private PI mutexes.
	* pthread_mutex_timedlock.c: Likewise.
	* pthread_mutex_trylock.c: Likewise.
	* pthread_mutex_unlock.c: Likewise.
	Patch mostly by Ben Jackson <ben@ben.com>.

2008-10-31  Ulrich Drepper  <drepper@redhat.com>

	[BZ #6843]
	* sysdeps/pthread/gai_misc.h (__gai_create_helper_thread):
	Increase stack size for helper thread.

2008-10-06  Martin Schwidefsky  <schwidefsky@de.ibm.com>

	* sysdeps/s390/tls.h (THREAD_SET_STACK_GUARD): Add empty inline
	assembly with a clobber list for access registers a0 and a1.

2008-09-11  Martin Schwidefsky  <schwidefsky@de.ibm.com>

	* sysdeps/unix/sysv/linux/fork.c (__libc_fork): Add memory barrier
	to force runp->refcntr to be read from memory.

2008-09-08  Richard Guenther  <rguenther@suse.de>

	* sysdeps/unix/sysv/linux/i386/lowlevellock.h (lll_lock,
	lll_robust_lock, lll_cond_lock, lll_robust_cond_lock,
	lll_timedlock, lll_robust_timedlock, lll_unlock,
	lll_robust_unlock): Promote private to int.

2008-08-15  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/x86_64/pthreaddef.h: Remove ARCH_MAP_FLAGS and
	ARCH_RETRY_MMAP definitions.
	* allocatestack.c: Remove definition of ARCH_MAP_FLAGS.
	Define MAP_STACK when not defined.
	(allocate_stack): Use MAP_STACK instead of ARCH_MAP_FLAGS.  Remove
	handling of ARCH_RETRY_MMAP.

2008-07-30  Ulrich Drepper  <drepper@redhat.com>

	* tst-align2.c (f): Print message that f is reached.

2008-04-28  Hiroki Kaminaga  <kaminaga@sm.sony.co.jp>

	[BZ #6740]
	* sysdeps/powerpc/tcb-offsets.sym (PRIVATE_FUTEX_OFFSET): Guard symbol
	definition with #ifndef __ASSUME_PRIVATE_FUTEX.

2008-07-25  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/mq_notify.c (init_mq_netlink): Use
	SOCK_CLOEXEC if possible.

2008-05-29  Ulrich Drepper  <drepper@redhat.com>

	* Makefile (tests): Add tst-rwlock2a.
	* tst-rwlock2.c: Use TYPE macro to decide what rwlock type to use.
	* tst-rwlock2a.c: New file.

2008-06-12  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/pthread.h: Remove inadvertant checkin.

2008-05-17  Samuel Thibault  <samuel.thibault@ens-lyon.org>

	* sysdeps/pthread/pthread.h: Fix typo in comment.

2008-05-28  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/createthread.c (do_clone): Pass accurate length
	of CPU set to the kernel.

2008-05-23  Paul Pluzhnikov  <ppluzhnikov@google.com>

	* sysdeps/unix/sysv/linux/i386/i486/pthread_barrier_wait.S: Add
	cfi directives.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_broadcast.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_signal.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_rdlock.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_unlock.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_wrlock.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/sem_post.S: Likewise.

2008-05-22  Paul Pluzhnikov  <ppluzhnikov@google.com>

	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_timedrdlock.S: Add
	cfi directives.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_timedwrlock.S:
	Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedrdlock.S:
	Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedwrlock.S:
	Likewise.

2008-05-26  Ulrich Drepper  <drepper@redhat.com>

	* tst-typesizes.c: Explicitly check __SIZEOF_PTHREAD_* constants.

2008-05-20  Jakub Jelinek  <jakub@redhat.com>

	David S. Miller  <davem@davemloft.net>

	* sysdeps/unix/sysv/linux/sparc/sparc64/Makefile: New file.

2008-05-10  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_rdlock.S: Access
	__pshared correctly.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_timedrdlock.S:
	Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_timedwrlock.S:
	Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_unlock.S:
	Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_wrlock.S:
	Likewise.
	Reported by Clemens Kolbitsch <clemens.kol@gmx.at>.

2008-04-14  David S. Miller  <davem@davemloft.net>

	* sysdeps/unix/sysv/linux/sparc/sparc32/sem_wait.c
	(__old_sem_wait): Fix argument to lll_futex_wait().

2007-11-26  Daniel Jacobowitz  <dan@codesourcery.com>

	* pthread_create.c: Require pthread_mutex_trylock and
	pthread_key_delete for libgcc.

2008-04-08  Jakub Jelinek  <jakub@redhat.com>

	[BZ #6020]
	* sysdeps/unix/sysv/linux/sparc/lowlevellock.h
	(lll_futex_wake_unlock): Add private argument to the pre-v9 macro.
	Patch by Sunil Amitkumar Janki <devel.sjanki@gmail.com>.

2008-03-27  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/bits/local_lim.h: Undefine ARG_MAX if
	<linux/limits.h> has defined it.
	* sysdeps/unix/sysv/linux/alpha/bits/local_lim.h: Likewise.
	* sysdeps/unix/sysv/linux/ia64/bits/local_lim.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/bits/local_lim.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/bits/local_lim.h: Likewise.

2008-03-18  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/ia64/dl-sysdep.h: Use __ASSEMBLER__ instead
	of ASSEMBLER.
	* sysdeps/unix/sysv/linux/i386/i686/dl-sysdep.h: Likewise.
	* sysdeps/unix/sysv/linux/i386/dl-sysdep.h: Likewise.

2008-03-14  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/i386/dl-sysdep.h: Define
	HAVE_DL_DISCOVER_OSVERSION.
	* sysdeps/unix/sysv/linux/i386/i686/dl-sysdep.h: Likewise.
	* sysdeps/unix/sysv/linux/ia64/dl-sysdep.h: Likewise.

2008-03-07  Ulrich Drepper  <drepper@redhat.com>

	[BZ #5778]
	* sysdeps/unix/sysv/linux/bits/posix_opt.h: Change
	_POSIX_CHOWN_RESTRICTED value to zero.

2008-01-31  Roland McGrath  <roland@redhat.com>

	* Makefile (omit-deps): Variable removed.

2008-01-30  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/sem_post.S (sem_post): Avoid
	unnecessary addr32 prefix.

2008-01-29  Roland McGrath  <roland@redhat.com>

	* Makeconfig (ptw-CPPFLAGS, sysd-rules-patterns): New variables.

2008-01-22  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/unix/sysv/linux/sh/sem_post.S: Don't overflow value field.

2008-01-21  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/unix/sysv/linux/sh/lowlevel-atomic.h (XADD): Use
	a scratch register.
	* sysdeps/unix/sysv/linux/sh/lowlevellock.S
	(__lll_lock_wait_private): Fix typo.
	* sysdeps/unix/sysv/linux/sh/pthread_barrier_wait.S
	(pthread_barrier_wait): Likewise.  Adjust XADD use.
	* sysdeps/unix/sysv/linux/sh/sem_post.S (__new_sem_post):
	Adjust XADD use.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_timedrdlock.S
	(pthread_rwlock_timedrdlock): Return correct return value.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_timedwrlock.S
	(pthread_rwlock_timedwrlock): Likewise.

2008-01-15  Ulrich Drepper  <drepper@redhat.com>

	* tst-eintr2.c (do_test): make sure that if mutex_lock in main
	thread returns the program exits with an error code.

2008-01-10  Ulrich Drepper  <drepper@redhat.com>

	* pthread-errnos.sym: Add EOVERFLOW.
	* sysdeps/unix/sysv/linux/structsem.sym: Add SEM_VALUE_MAX.
	* sysdeps/unix/sysv/linux/sem_post.c: Don't overflow value field.
	* sysdeps/unix/sysv/linux/i386/i486/sem_post.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/sem_post.S: Likewise.

2007-12-14  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/x86_64/pthreaddef.h (ARCH_RETRY_MMAP): Take additional
	parameter.  Passed it as permission to mmap.
	* allocatestack.c (allocate_stack): Pass prot as second parameter
	to ARCH_RETRY_MMAP.

2007-12-12  Ulrich Drepper  <drepper@redhat.com>

	* tst-basic7.c: Allocate memory for the stack.

	[BZ #5465]
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S [!SHARED]
	(__pthread_cond_timedwait): Don't use VDSO.
	Patch by Michal Januszewski.

2007-12-07  Ulrich Drepper  <drepper@redhat.com>

	[BZ #5455]
	* sysdeps/pthread/pthread.h [!__EXCEPTIONS] (pthread_cleanup_pop):
	Allow label before pthread_cleanup_pop.
	(pthread_cleanup_pop_restore_np): Likewise.

2007-12-04  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/unix/sysv/linux/sh/lowlevellock.S (__lll_timedlock_wait):
	Store 2 before returning ETIMEDOUT.

2007-11-23  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.S (__lll_timedlock_wait):
	Store 2 before returning ETIMEDOUT.
	* sysdeps/unix/sysv/linux/i386/i486/lowlevellock.S: Likewise
	* sysdeps/unix/sysv/linux/lowlevellock.c: Likewise.
	(__lll_lock_wait_private): Optimize.
	(__lll_lock_wait): Likewise.

2007-11-20  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/pthread/pthread.h (pthread_cleanup_push,
	pthread_cleanup_push_defer_np): Add extra (void *) cast to shut up
	g++ 4.1 and 4.2 -Wstrict-aliasing warnings.

2007-11-08  Ulrich Drepper  <drepper@redhat.com>

	[BZ #5240]
	* sysdeps/unix/sysv/linux/lowlevellock.c (__lll_timedlock_wait):
	If we time out, try one last time to lock the futex to avoid
	losing a wakeup signal.
	* sysdeps/unix/sysv/linux/i386/i486/lowlevellock.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.S: Likewise.

	[BZ #5245]
	* sysdeps/pthread/createthread.c (do_clone): Translate clone error
	if necessary.

2007-11-07  Ulrich Drepper  <drepper@redhat.com>

	[BZ #5245]
	* allocatestack.c (allocate_stack): Change ENOMEM error in case
	mmap failed to EAGAIN.
	* Makefile (tests): Add tst-basic7.
	* tst-basic7.c: New file.

2007-11-05  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/register-atfork.c (__register_atfork):
	Use __linkin_atfork.

2007-11-03  Mike Frysinger  <vapier@gentoo.org>

	* sysdeps/unix/sysv/linux/sh/lowlevellock.S (LOAD_FUTEX_WAIT): Add
	missing line continuations.
	* sysdeps/unix/sysv/linux/sh/lowlevelrobustlock.S (LOAD_FUTEX_WAIT,
	LOAD_FUTEX_WAKE): Likewise.  Also add missing 3rd parameter.

2007-10-28  Ulrich Drepper  <drepper@redhat.com>

	[BZ #5220]
	* sysdeps/unix/sysv/linux/kernel-posix-timers.h: Declare
	__active_timer_sigev_thread and __active_timer_sigev_thread_lock.
	(struct timer): Add next element.
	* sysdeps/unix/sysv/linux/timer_create.c: For SIGEV_THREAD timers,
	enqueue timer structure into __active_timer_sigev_thread list.
	* sysdeps/unix/sysv/linux/timer_delete.c: For SIGEV_THREAD timers,
	remove timer struct from __active_timer_sigev_thread.
	* sysdeps/unix/sysv/linux/timer_routines.c (timer_helper_thread):
	Before using timer structure make sure it is still on the
	__active_timer_sigev_thread list.  Keep lock until done.
	Define __active_timer_sigev_thread and
	__active_timer_sigev_thread_lock.

2007-10-27  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/malloc-machine.h: Define ATFORK_MEM.
	Redefine thread_atfork for use of ATFORK_MEM.
	* sysdeps/unix/sysv/linux/fork.h: Define __linkin_atfork.
	* sysdeps/unix/sysv/linux/register-atfork.c (__linkin_atfork): New
	function.
	* sysdeps/unix/sysv/linux/unregister-atfork.c (__unregister_atfork):
	Use atomic operation when removing first element of list.

2007-10-17  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/i386/i486/sem_post.S (__old_sem_post): New
	routine instead of an alias to __new_sem_post.

2007-10-15  Jakub Jelinek  <jakub@redhat.com>

	* init.c (__pthread_initialize_minimal): Initialize word to appease
	valgrind.

2007-10-10  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/pthread/bits/libc-lock.h (__libc_rwlock_init): Inside of
	libc.so just clear NAME.
	(__libc_rwlock_fini): Nop inside of libc.so.
	* tst-initializers1.c (main): Test if PTHREAD_RWLOCK_INITIALIZER is
	all zeros.

2007-09-02  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S
	(__pthread_cond_wait): Fix unlocking of internal lock after mutex
	unlocking failed.
	Patch by Luca Barbieri <luca.barbieri@gmail.com>.

2007-08-21  Ulrich Drepper  <drepper@redhat.com>

	[BZ #4938]
	* allocatestack.c (__reclaim_stacks): Clear the TSD in the
	reclaimed stack if necessary.
	* Makefile (tests): Add tst-tsd6.
	* tst-tsd6.c: New file.

2007-08-21  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/alpha/lowlevellock.h (lll_robust_dead):
	Add private argument.

2007-08-20  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S
	(__pthread_cond_timedwait): Use clock_gettime from VDSO if possible.

2007-08-16  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/alpha/lowlevellock.h
	(__lll_robust_timedlock): Pass private as last argument to
	__lll_robust_timedlock_wait.
	(__lll_unlock): Fix a pasto.

2007-08-15  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/sparc/internaltypes.h (sparc_new_sem,
	sparc_old_sem): New structs.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sem_wait.c
	(__sem_wait_cleanup): New function.
	(__new_sem_wait): Use sparc_new_sem structure.  Bump and afterwards
	decrease nwaiters.  Register __sem_wait_cleanup as cleanup handler.
	Pass isem->private ^ FUTEX_PRIVATE_FLAG as last argument to
	lll_futex_wait.
	(__old_sem_wait): New function.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sparcv9/sem_wait.c: Include
	nptl/sysdeps/unix/sysv/linux/sparc version.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sparcv9/sem_timedwait.c:
	Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sparcv9/sem_post.c: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sem_trywait.c
	(__new_sem_trywait): Use sparc_old_sem structure.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sem_timedwait.c
	(sem_timedwait): Use sparc_new_sem structure.  Bump and afterwards
	decrease nwaiters.  Register __sem_wait_cleanup as cleanup handler.
	Pass isem->private ^ FUTEX_PRIVATE_FLAG as last argument to
	lll_futex_timed_wait.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sem_post.c (__new_sem_post):
	Use sparc_new_sem structure.  Only wake if nwaiters > 0.  Pass
	isem->private ^ FUTEX_PRIVATE_FLAG as last argument to
	lll_futex_wake.
	(__old_sem_post): New function.
	* sysdeps/unix/sysv/linux/sparc/sem_wait.c: New file.
	* sysdeps/unix/sysv/linux/sparc/sem_init.c: New file.
	* sysdeps/unix/sysv/linux/sparc/sem_timedwait.c: New file.
	* sysdeps/unix/sysv/linux/sparc/sem_post.c: New file.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sparcv9/sem_init.c: Remove.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sem_init.c: Remove.

2007-08-14  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/unix/sysv/linux/sh/pthread_cond_broadcast.S
	(__pthread_cond_broadcast): Pass LLL_PRIVATE to lll_* and or
	FUTEX_PRIVATE_FLAG into SYS_futex op if cv is process private.
	Don't use FUTEX_CMP_REQUEUE if dep_mutex is not process private.
	* sysdeps/unix/sysv/linux/shpthread_cond_signal.S
	(__pthread_cond_signal): Pass LLL_PRIVATE to lll_* and or
	FUTEX_PRIVATE_FLAG into SYS_futex op if cv is process private.
	Use FUTEX_WAKE_OP.
	* sysdeps/unix/sysv/linux/sh/pthread_cond_wait.S: Include
	kernel-features.h and tcb-offsets.h.
	(__pthread_cond_wait, __condvar_w_cleanup): Pass LLL_PRIVATE to
	lll_* and or FUTEX_PRIVATE_FLAG into SYS_futex op if cv is
	process private.
	* sysdeps/unix/sysv/linux/sh/pthread_cond_timedwait.S: Include
	tcb-offsets.h.
	(__pthread_cond_timedwait, __condvar_tw_cleanup): Pass LLL_PRIVATE
	to lll_* and or FUTEX_PRIVATE_FLAG into SYS_futex op if cv is
	process private.
	* sysdeps/unix/sysv/linux/sh/pthread_once.S: Use #ifdef
	__ASSUME_PRIVATE_FUTEX instead of #if __ASSUME_PRIVATE_FUTEX.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_rdlock.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_timedrdlock.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_timedwrlock.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_unlock.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_wrlock.S: Likewise.

2007-08-14  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/lowlevellock.c: Comment fix.
	* sysdeps/unix/sysv/linux/sparc/sparc32/lowlevellock.c
	(__lll_timedwait_tid): Pass LLL_SHARED as 4th argument to
	lll_futex_timed_wait.

	* sysdeps/unix/sysv/linux/alpha/lowlevellock.h (__lll_unlock,
	__lll_robust_unlock): Rewrite as macros instead of inline functions.
	* sysdeps/unix/sysv/linux/s390/lowlevellock.h (__lll_unlock,
	__lll_robust_unlock, __lll_wait_tid): Likewise.

2007-08-13  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/i386/lowlevellock.h (__lll_private_flag):
	Fix a pasto.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_broadcast.S
	(__pthread_cond_broadcast): Pass LLL_PRIVATE to lll_* and or
	FUTEX_PRIVATE_FLAG into SYS_futex op if cv is process private.
	Don't use FUTEX_CMP_REQUEUE if dep_mutex is not process private.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_signal.S
	(__pthread_cond_signal): Pass LLL_PRIVATE to lll_* and or
	FUTEX_PRIVATE_FLAG into SYS_futex op if cv is process private.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_wait.S: Include
	kernel-features.h.
	(__pthread_cond_wait, __condvar_w_cleanup): Pass LLL_PRIVATE to
	lll_* and or FUTEX_PRIVATE_FLAG into SYS_futex op if cv is
	process private.  Switch DW_CFA_advance_loc1 and some
	DW_CFA_advance_loc .eh_frame opcodes to DW_CFA_advance_loc4.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_timedwait.S
	(__pthread_cond_timedwait, __condvar_tw_cleanup): Pass LLL_PRIVATE to
	lll_* and or FUTEX_PRIVATE_FLAG into SYS_futex op if cv is
	process private.  Switch DW_CFA_advance_loc{1,2} and some
	DW_CFA_advance_loc .eh_frame opcodes to DW_CFA_advance_loc4.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_rdlock.S: Use
	#ifdef __ASSUME_PRIVATE_FUTEX instead of #if __ASSUME_PRIVATE_FUTEX.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_timedwrlock.S:
	Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_unlock.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_wrlock.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_timedrdlock.S:
	Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_broadcast.S
	(__pthread_cond_broadcast): Compare %r8 instead of
	dep_mutex-cond_*(%rdi) with $-1.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_signal.S
	(__pthread_cond_signal): Xor FUTEX_WAKE_OP with FUTEX_WAKE instead
	of oring.

2007-08-13  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/i386/i786/Implies: New file.

2007-08-13  Jakub Jelinek  <jakub@redhat.com>

	* allocatestack.c: Include kernel-features.h.
	* pthread_create.c: Likewise.
	* pthread_mutex_init.c: Likewise.
	* init.c: Likewise.
	* pthread_cond_timedwait.c: Likewise.
	* sysdeps/unix/sysv/linux/alpha/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/ia64/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_wrlock.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_rdlock.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_unlock.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_timedwait.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_timedwrlock.S:
	Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_timedrdlock.S:
	Likewise.
	* sysdeps/unix/sysv/linux/s390/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_cond_timedwait.S: Likewise.

2007-08-12  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/sparc/bits/pthreadtypes.h
	[__WORDSIZE=32] (pthread_rwlock_t): Split __flags element into four
	byte elements.  One of them is the new __shared element.
	[__WORDSIZE=64] (pthread_rwlock_t): Renamed __pad1 element to __shared,
	adjust names of other padding elements.
	* sysdeps/unix/sysv/linux/s390/bits/pthreadtypes.h
	[__WORDSIZE=32] (pthread_rwlock_t): Split __flags element into four
	byte elements.  One of them is the new __shared element.
	[__WORDSIZE=64] (pthread_rwlock_t): Renamed __pad1 element to __shared,
	adjust names of other padding elements.
	* sysdeps/unix/sysv/linux/ia64/bits/pthreadtypes.h (pthread_rwlock_t):
	Renamed __pad1 element to __shared, adjust names of other padding
	elements.
	* sysdeps/unix/sysv/linux/alpha/bits/pthreadtypes.h
	(pthread_rwlock_t): Likewise.
	* sysdeps/unix/sysv/linux/ia64/lowlevellock.h (__lll_lock): Fix a
	typo.

2007-08-09  Anton Blanchard  <anton@samba.org>

	* sysdeps/unix/sysv/linux/powerpc/pthread_spin_unlock.c: New file.

2007-08-12  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S: Include
	<kernel-features.h>.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S: Likewise.

2007-08-11  Ulrich Drepper  <drepper@redhat.com>

	* pthreadP.h (PTHREAD_ROBUST_MUTEX_PSHARED): Define.
	* pthread_mutex_lock.c: Use it instead of PTHREAD_MUTEX_PSHARED when
	dealing with robust mutexes.
	* pthread_mutex_timedlock.c: Likewise.
	* pthread_mutex_trylock.c: Likewise.
	* pthread_mutex_unlock.c: Likewise.
	* sysdeps/unix/sysv/linux/pthread_mutex_cond_lock.c: Likewise.

2007-08-06  Jakub Jelinek  <jakub@redhat.com>

	* pthreadP.h (PTHREAD_MUTEX_PSHARED_BIT): Define.
	(PTHREAD_MUTEX_TYPE): Mask __kind with 127.
	(PTHREAD_MUTEX_PSHARED): Define.
	* pthread_mutex_init.c (__pthread_mutex_init): Set
	PTHREAD_MUTEX_PSHARED_BIT for pshared or robust
	mutexes.
	* pthread_mutex_lock.c (LLL_MUTEX_LOCK): Take mutex as argument
	instead of its __data.__lock field, pass PTHREAD_MUTEX_PSHARED
	as second argument to lll_lock.
	(LLL_MUTEX_TRYLOCK): Take mutex as argument
	instead of its __data.__lock field.
	(LLL_ROBUST_MUTEX_LOCK): Take mutex as argument instead of its
	__data.__lock field, pass PTHREAD_MUTEX_PSHARED as second argument
	to lll_robust_lock.
	(__pthread_mutex_lock): Update LLL_MUTEX_LOCK, LLL_MUTEX_TRYLOCK,
	LLL_ROBUST_MUTEX_LOCK users, use PTHREAD_MUTEX_TYPE (mutex)
	instead of mutex->__data.__kind directly, pass
	PTHREAD_MUTEX_PSHARED (mutex) to lll_unlock and lll_futex_wait.
	* pthread_mutex_trylock.c (__pthread_mutex_trylock): Use
	PTHREAD_MUTEX_TYPE (mutex) instead of mutex->__data.__kind
	directly, pass PTHREAD_MUTEX_PSHARED (mutex) to lll_unlock.
	(pthread_mutex_timedlock): Pass PTHREAD_MUTEX_PSHARED (mutex)
	to lll_timedlock, lll_robust_timedlock, lll_unlock and
	lll_futex_timed_wait.  Use PTHREAD_MUTEX_TYPE (mutex) instead
	of mutex->__data.__kind directly.
	* pthread_mutex_timedlock.c (pthread_mutex_timedlock): Pass
	PTHREAD_MUTEX_PSHARED (mutex) to lll_timedlock,
	lll_robust_timedlock, lll_unlock and lll_futex_timed_wait.  Use
	PTHREAD_MUTEX_TYPE (mutex) instead of mutex->__data.__kind directly.
	* pthread_mutex_unlock.c (__pthread_mutex_unlock_usercnt): Pass
	PTHREAD_MUTEX_PSHARED (mutex) to lll_unlock, lll_robust_unlock
	and lll_futex_wake.
	* pthread_mutex_setprioceiling.c (pthread_mutex_setprioceiling): Pass
	PTHREAD_MUTEX_PSHARED (mutex) to lll_futex_wait and lll_futex_wake.
	Use PTHREAD_MUTEX_TYPE (mutex) instead of mutex->__data.__kind
	directly.
	* sysdeps/unix/sysv/linux/pthread_mutex_cond_lock.c (LLL_MUTEX_LOCK):
	Take mutex as argument instead of its __data.__lock field, pass
	PTHREAD_MUTEX_PSHARED as second argument to lll_cond_lock.
	(LLL_MUTEX_TRYLOCK): Take mutex as argument instead of its
	__data.__lock field.
	(LLL_ROBUST_MUTEX_LOCK): Take mutex as argument instead of its
	__data.__lock field, pass PTHREAD_MUTEX_PSHARED as second argument
	to lll_robust_cond_lock.
	* pthread_cond_broadcast.c (__pthread_cond_broadcast): Add pshared
	variable, pass it to lll_lock, lll_unlock, lll_futex_requeue and
	lll_futex_wake.  Don't use lll_futex_requeue if dependent mutex
	has PTHREAD_MUTEX_PSHARED_BIT bit set in its __data.__kind.
	* pthread_cond_destroy.c (__pthread_cond_destroy): Add pshared
	variable, pass it to lll_lock, lll_unlock, lll_futex_wake and
	lll_futex_wait.
	* pthread_cond_signal.c (__pthread_cond_signal): Add pshared
	variable, pass it to lll_lock, lll_unlock, lll_futex_wake_unlock and
	lll_futex_wake.
	* pthread_cond_timedwait.c (__pthread_cond_wait): Add
	pshared variable, pass it to lll_lock, lll_unlock,
	lll_futex_timedwait and lll_futex_wake.
	* pthread_cond_wait.c (__condvar_cleanup, __pthread_cond_wait): Add
	pshared variable, pass it to lll_lock, lll_unlock, lll_futex_wait
	and lll_futex_wake.
	* sysdeps/unix/sysv/linux/alpha/lowlevellock.h (lll_futex_requeue,
	lll_futex_wake_unlock): Add private argument, use __lll_private_flag
	macro.
	* sysdeps/unix/sysv/linux/ia64/lowlevellock.h (lll_futex_requeue,
	lll_futex_wake_unlock): Likewise.
	* sysdeps/unix/sysv/linux/powerpc/lowlevellock.h (lll_futex_requeue):
	Likewise.
	* sysdeps/unix/sysv/linux/sparc/lowlevellock.h (lll_futex_requeue,
	lll_futex_wake_unlock): Likewise.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h (lll_futex_requeue):
	Likewise.
	* sysdeps/unix/sysv/linux/s390/lowlevellock.h (lll_futex_requeue,
	lll_futex_wake_unlock): Likewise.
	(lll_futex_wake): Fix a typo.
	* sysdeps/unix/sysv/linux/pthread-pi-defines.sym (PS_BIT): Add.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_broadcast.S
	(__pthread_cond_broadcast): Pass LLL_PRIVATE to lll_* and or
	FUTEX_PRIVATE_FLAG into SYS_futex op if cv is process private.
	Don't use FUTEX_CMP_REQUEUE if dep_mutex is not process private.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_signal.S
	(__pthread_cond_signal): Pass LLL_PRIVATE to lll_* and or
	FUTEX_PRIVATE_FLAG into SYS_futex op if cv is process private.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S
	(__pthread_cond_timedwait): Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S:
	(__condvar_cleanup, __pthread_cond_wait): Likewise.

2007-08-05  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/powerpc/powerpc32/sysdep-cancel.h (PSEUDO):
	Don't use CGOTSETUP and CGOTRESTORE macros.
	(CGOTSETUP, CGOTRESTORE): Remove.
	<IS_IN_rtld> (CENABLE, CDISABLE): Don't use JUMPTARGET, branch to
	@local symbol.

2007-08-01  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/unix/sysv/linux/sh/libc-lowlevellock.S: Remove
	definitions for private futexes.
	* sysdeps/unix/sysv/linux/sh/lowlevellock.S: Include
	kernel-features.h and lowlevellock.h.  Use private futexes if
	they are available.
	(__lll_lock_wait_private, __lll_unlock_wake_private): New.
	(__lll_mutex_lock_wait): Rename to
	(__lll_lock_wait): ... this.  Don't compile in for libc.so.
	(__lll_mutex_timedlock_wait): Rename to ...
	(__lll_timedlock_wait): ... this.  Use __NR_gettimeofday.
	Don't compile in for libc.so.
	(__lll_mutex_unlock_wake): Rename to ...
	(__lll_unlock_wake): ... this.  Don't compile in for libc.so.
	(__lll_timedwait_tid): Use __NR_gettimeofday.
	* sysdeps/unix/sysv/linux/sh/lowlevellock.h: Allow including
	the header from assembler.  Renamed all lll_mutex_* resp.
	lll_robust_mutex_* macros to lll_* resp. lll_robust_*.
	Renamed all LLL_MUTEX_LOCK_* macros to LLL_LOCK_*.
	(FUTEX_CMP_REQUEUE, FUTEX_WAKE_OP, FUTEX_OP_CLEAR_WAKE_IF_GT_ONE):
	Define.
	(__lll_lock_wait_private): Add prototype.
	(__lll_lock_wait, __lll_timedlock_wait, __lll_robust_lock_wait,
	__lll_robust_timedlock_wait, __lll_unlock_wake_private,
	__lll_unlock_wake): Likewise.
	(lll_lock): Add private argument.  Call __lll_lock_wait_private
	if private is constant LLL_PRIVATE.
	(lll_robust_lock, lll_cond_lock, lll_robust_cond_lock,
	lll_timedlock, lll_robust_timedlock): Add private argument.
	(lll_unlock): Add private argument.  Call __lll_unlock_wake_private
	if private is constant LLL_PRIVATE.
	(lll_robust_unlock, lll_robust_dead): Add private argument.
	(lll_lock_t): Remove.
	(__lll_cond_wait, __lll_cond_timedwait, __lll_cond_wake,
	__lll_cond_broadcast, lll_cond_wait, lll_cond_timedwait,
	lll_cond_wake, lll_cond_broadcast): Remove.
	* sysdeps/unix/sysv/linux/sh/lowlevelrobustlock.S: Include
	kernel-features.h and lowlevellock.h.
	(SYS_gettimeofday, SYS_futex, FUTEX_WAIT, FUTEX_WAKE): Remove.
	(LOAD_FUTEX_WAIT): Define.
	(__lll_robust_mutex_lock_wait): Rename to ...
	(__lll_robust_lock_wait): ... this.  Add private argument.
	Use LOAD_FUTEX_WAIT macro.
	(__lll_robust_mutex_timedlock_wait): Rename to ...
	(__lll_robust_timedlock_wait): ... this.    Add private argument.
	Use __NR_gettimeofday.  Use LOAD_FUTEX_WAIT macro.
	* sysdeps/unix/sysv/linux/sh/pthread_barrier_wait.S: Include
	lowlevellock.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE): Remove.
	(pthread_barrier_wait): Use __lll_{lock,unlock}_* instead of
	__lll_mutex_{lock,unlock}_*.
	* sysdeps/unix/sysv/linux/sh/pthread_cond_broadcast.S: Include
	lowlevellock.h and pthread-errnos.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, FUTEX_REQUEUE,
	FUTEX_CMP_REQUEUE, EINVAL): Remove.
	(__pthread_cond_broadcast): Use __lll_{lock,unlock}_* instead of
	__lll_mutex_{lock,unlock}_*.
	* sysdeps/unix/sysv/linux/sh/pthread_cond_signal.S: Include
	lowlevellock.h and pthread-errnos.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, FUTEX_REQUEUE, EINVAL): Remove.
	(__pthread_cond_signal): Use __lll_{lock,unlock}_* instead of
	__lll_mutex_{lock,unlock}_*.
	* sysdeps/unix/sysv/linux/sh/pthread_cond_timedwait.S: Include
	lowlevellock.h.
	(SYS_futex, SYS_gettimeofday, FUTEX_WAIT, FUTEX_WAKE): Remove.
	(__pthread_cond_timedwait): Use __lll_{lock,unlock}_* instead of
	__lll_mutex_{lock,unlock}_*.  Use __NR_gettimeofday.
	(__condvar_tw_cleanup): Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_cond_wait.S: Include
	lowlevellock.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE): Remove.
	(__pthread_cond_wait): Use __lll_{lock,unlock}_* instead of
	__lll_mutex_{lock,unlock}_*.
	( __condvar_w_cleanup): Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_once.S: Include lowlevellock.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, FUTEX_PRIVATE_FLAG): Remove.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_rdlock.S: Include
	lowlevellock.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, FUTEX_PRIVATE_FLAG): Remove.
	(__pthread_rwlock_rdlock): Use __lll_{lock,unlock}_* instead of
	__lll_mutex_{lock,unlock}_*.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_timedrdlock.S: Include
	lowlevellock.h.
	(SYS_gettimeofday, SYS_futex, FUTEX_WAIT, FUTEX_WAKE,
	FUTEX_PRIVATE_FLAG): Remove.
	(pthread_rwlock_timedrdlock): Use __lll_{lock,unlock}_* instead of
	__lll_mutex_{lock,unlock}_*.  Use __NR_gettimeofday.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_timedwrlock.S: Include
	lowlevellock.h.
	(SYS_gettimeofday, SYS_futex, FUTEX_WAIT, FUTEX_WAKE,
	FUTEX_PRIVATE_FLAG): Remove.
	(pthread_rwlock_timedwrlock): Use __lll_{lock,unlock}_* instead of
	__lll_mutex_{lock,unlock}_*.  Use __NR_gettimeofday.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_unlock.S: Include
	lowlevellock.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, FUTEX_PRIVATE_FLAG): Remove.
	(__pthread_rwlock_unlock): Use __lll_{lock,unlock}_* instead of
	__lll_mutex_{lock,unlock}_*.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_wrlock.S: Include
	lowlevellock.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, FUTEX_PRIVATE_FLAG): Remove.
	(__pthread_rwlock_wrlock): Use __lll_{lock,unlock}_* instead of
	__lll_mutex_{lock,unlock}_*.
	* sysdeps/unix/sysv/linux/sh/sem_post.S: Include lowlevellock.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, FUTEX_PRIVATE_FLAG): Remove.
	(__new_sem_post): Use standard initial exec code sequences.
	* sysdeps/unix/sysv/linux/sh/sem_timedwait.S: Include
	lowlevellock.h.
	(SYS_gettimeofday, SYS_futex, FUTEX_WAIT, FUTEX_WAKE,
	FUTEX_PRIVATE_FLAG): Remove.
	(sem_timedwait): Use __NR_gettimeofday.  Use standard initial
	exec code sequences.
	* sysdeps/unix/sysv/linux/sh/sem_trywait.S: Include lowlevellock.h.
	(__new_sem_trywait): Use standard initial exec code sequences.
	* sysdeps/unix/sysv/linux/sh/sem_wait.S: Include lowlevellock.h.
	(__new_sem_wait): Use standard initial exec code sequences.

2007-07-31  Anton Blanchard  <anton@samba.org>

	* sysdeps/unix/sysv/linux/powerpc/sem_post.c (__new_sem_post):
	Use __asm __volatile (__lll_acq_instr ::: "memory") instead of
	atomic_full_barrier.

2007-07-31  Jakub Jelinek  <jakub@redhat.com>

	* allocatestack.c (stack_cache_lock): Change type to int.
	(get_cached_stack, allocate_stack, __deallocate_stack,
	__make_stacks_executable, __find_thread_by_id, __nptl_setxid,
	__pthread_init_static_tls, __wait_lookup_done): Add LLL_PRIVATE
	as second argument to lll_lock and lll_unlock macros on
	stack_cache_lock.
	* pthread_create.c (__find_in_stack_list): Likewise.
	(start_thread): Similarly with pd->lock.  Use lll_robust_dead
	macro instead of lll_robust_mutex_dead, pass LLL_SHARED to it
	as second argument.
	* descr.h (struct pthread): Change lock and setxid_futex field
	type to int.
	* old_pthread_cond_broadcast.c (__pthread_cond_broadcast_2_0): Use
	LLL_LOCK_INITIALIZER instead of LLL_MUTEX_LOCK_INITIALIZER.
	* old_pthread_cond_signal.c (__pthread_cond_signal_2_0): Likewise.
	* old_pthread_cond_timedwait.c (__pthread_cond_timedwait_2_0):
	Likewise.
	* old_pthread_cond_wait.c (__pthread_cond_wait_2_0): Likewise.
	* pthread_cond_init.c (__pthread_cond_init): Likewise.
	* pthreadP.h (__attr_list_lock): Change type to int.
	* pthread_attr_init.c (__attr_list_lock): Likewise.
	* pthread_barrier_destroy.c (pthread_barrier_destroy): Pass
	ibarrier->private ^ FUTEX_PRIVATE_FLAG as second argument to
	lll_{,un}lock.
	* pthread_barrier_wait.c (pthread_barrier_wait): Likewise and
	also for lll_futex_{wake,wait}.
	* pthread_barrier_init.c (pthread_barrier_init): Make iattr
	a pointer to const.
	* pthread_cond_broadcast.c (__pthread_cond_broadcast): Pass
	LLL_SHARED as second argument to lll_{,un}lock.
	* pthread_cond_destroy.c (__pthread_cond_destroy): Likewise.
	* pthread_cond_signal.c (__pthread_cond_singal): Likewise.
	* pthread_cond_timedwait.c (__pthread_cond_timedwait): Likewise.
	* pthread_cond_wait.c (__condvar_cleanup, __pthread_cond_wait):
	Likewise.
	* pthread_getattr_np.c (pthread_getattr_np): Add LLL_PRIVATE
	as second argument to lll_{,un}lock macros on pd->lock.
	* pthread_getschedparam.c (__pthread_getschedparam): Likewise.
	* pthread_setschedparam.c (__pthread_setschedparam): Likewise.
	* pthread_setschedprio.c (pthread_setschedprio): Likewise.
	* tpp.c (__pthread_tpp_change_priority, __pthread_current_priority):
	Likewise.
	* sysdeps/pthread/createthread.c (do_clone, create_thread):
	Likewise.
	* pthread_once.c (once_lock): Change type to int.
	(__pthread_once): Pass LLL_PRIVATE as second argument to
	lll_{,un}lock macros on once_lock.
	* pthread_rwlock_rdlock.c (__pthread_rwlock_rdlock): Use
	lll_{,un}lock macros instead of lll_mutex_{,un}lock, pass
	rwlock->__data.__shared as second argument to them and similarly
	for lll_futex_w*.
	* pthread_rwlock_timedrdlock.c (pthread_rwlock_timedrdlock):
	Likewise.
	* pthread_rwlock_timedwrlock.c (pthread_rwlock_timedwrlock):
	Likewise.
	* pthread_rwlock_tryrdlock.c (__pthread_rwlock_tryrdlock): Likewise.
	* pthread_rwlock_trywrlock.c (__pthread_rwlock_trywrlock): Likewise.
	* pthread_rwlock_unlock.c (__pthread_rwlock_unlock): Likewise.
	* pthread_rwlock_wrlock.c (__pthread_rwlock_wrlock): Likewise.
	* sem_close.c (sem_close): Pass LLL_PRIVATE as second argument
	to lll_{,un}lock macros on __sem_mappings_lock.
	* sem_open.c (check_add_mapping): Likewise.
	(__sem_mappings_lock): Change type to int.
	* semaphoreP.h (__sem_mappings_lock): Likewise.
	* pthread_mutex_lock.c (LLL_MUTEX_LOCK, LLL_MUTEX_TRYLOCK,
	LLL_ROBUST_MUTEX_LOCK): Use lll_{,try,robust_}lock macros
	instead of lll_*mutex_*, pass LLL_SHARED as last
	argument.
	(__pthread_mutex_lock): Use lll_unlock instead of lll_mutex_unlock,
	pass LLL_SHARED as last argument.
	* sysdeps/unix/sysv/linux/pthread_mutex_cond_lock.c (LLL_MUTEX_LOCK,
	LLL_MUTEX_TRYLOCK, LLL_ROBUST_MUTEX_LOCK): Use
	lll_{cond_,cond_try,robust_cond}lock macros instead of lll_*mutex_*,
	pass LLL_SHARED as last argument.
	* pthread_mutex_timedlock.c (pthread_mutex_timedlock): Use
	lll_{timed,try,robust_timed,un}lock instead of lll_*mutex*, pass
	LLL_SHARED as last argument.
	* pthread_mutex_trylock.c (__pthread_mutex_trylock): Similarly.
	* pthread_mutex_unlock.c (__pthread_mutex_unlock_usercnt):
	Similarly.
	* sysdeps/pthread/bits/libc-lock.h (__libc_lock_lock,
	__libc_lock_lock_recursive, __libc_lock_unlock,
	__libc_lock_unlock_recursive): Pass LLL_PRIVATE as second
	argument to lll_{,un}lock.
	* sysdeps/pthread/bits/stdio-lock.h (_IO_lock_lock,
	_IO_lock_unlock): Likewise.
	* sysdeps/unix/sysv/linux/fork.c (__libc_fork): Don't use
	compound literal.
	* sysdeps/unix/sysv/linux/unregister-atfork.c (__unregister_atfork):
	Pass LLL_PRIVATE as second argument to lll_{,un}lock macros on
	__fork_lock.
	* sysdeps/unix/sysv/linux/register-atfork.c (__register_atfork,
	free_mem): Likewise.
	(__fork_lock): Change type to int.
	* sysdeps/unix/sysv/linux/fork.h (__fork_lock): Likewise.
	* sysdeps/unix/sysv/linux/sem_post.c (__new_sem_post): Pass
	isem->private ^ FUTEX_PRIVATE_FLAG as second argument to
	lll_futex_wake.
	* sysdeps/unix/sysv/linux/sem_timedwait.c (sem_timedwait): Likewise.
	* sysdeps/unix/sysv/linux/sem_wait.c (__new_sem_wait): Likewise.
	* sysdeps/unix/sysv/linux/lowlevellock.c (__lll_lock_wait_private):
	New function.
	(__lll_lock_wait, __lll_timedlock_wait): Add private argument and
	pass it through to lll_futex_*wait, only compile in when
	IS_IN_libpthread.
	* sysdeps/unix/sysv/linux/lowlevelrobustlock.c
	(__lll_robust_lock_wait, __lll_robust_timedlock_wait): Add private
	argument and pass it through to lll_futex_*wait.
	* sysdeps/unix/sysv/linux/alpha/lowlevellock.h: Renamed all
	lll_mutex_* resp. lll_robust_mutex_* macros to lll_* resp.
	lll_robust_*.  Renamed all __lll_mutex_* resp. __lll_robust_mutex_*
	inline functions to __lll_* resp. __lll_robust_*.
	(LLL_MUTEX_LOCK_INITIALIZER): Remove.
	(lll_mutex_dead): Add private argument.
	(__lll_lock_wait_private): New prototype.
	(__lll_lock_wait, __lll_robust_lock_wait, __lll_lock_timedwait,
	__lll_robust_lock_timedwait): Add private argument to prototypes.
	(__lll_lock): Add private argument, if it is constant LLL_PRIVATE,
	call __lll_lock_wait_private, otherwise pass private to
	__lll_lock_wait.
	(__lll_robust_lock, __lll_cond_lock, __lll_timedlock,
	__lll_robust_timedlock): Add private argument, pass it to
	__lll_*wait functions.
	(__lll_unlock): Add private argument, if it is constant LLL_PRIVATE,
	call __lll_unlock_wake_private, otherwise pass private to
	__lll_unlock_wake.
	(__lll_robust_unlock): Add private argument, pass it to
	__lll_robust_unlock_wake.
	(lll_lock, lll_robust_lock, lll_cond_lock, lll_timedlock,
	lll_robust_timedlock, lll_unlock, lll_robust_unlock): Add private
	argument, pass it through to __lll_* inline function.
	(__lll_mutex_unlock_force, lll_mutex_unlock_force): Remove.
	(lll_lock_t): Remove.
	(__lll_cond_wait, __lll_cond_timedwait, __lll_cond_wake,
	__lll_cond_broadcast, lll_cond_wait, lll_cond_timedwait,
	lll_cond_wake, lll_cond_broadcast): Remove.
	* sysdeps/unix/sysv/linux/ia64/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/i386/lowlevellock.h: Allow including
	the header from assembler.  Renamed all lll_mutex_* resp.
	lll_robust_mutex_* macros to lll_* resp. lll_robust_*.
	(LOCK, FUTEX_CMP_REQUEUE, FUTEX_WAKE_OP,
	FUTEX_OP_CLEAR_WAKE_IF_GT_ONE): Define.
	(LLL_MUTEX_LOCK_INITIALIZER, LLL_MUTEX_LOCK_INITIALIZER_LOCKED,
	LLL_MUTEX_LOCK_INITIALIZER_WAITERS): Remove.
	(__lll_mutex_lock_wait, __lll_mutex_timedlock_wait,
	__lll_mutex_unlock_wake, __lll_lock_wait, __lll_unlock_wake):
	Remove prototype.
	(__lll_trylock_asm, __lll_lock_asm_start, __lll_unlock_asm): Define.
	(lll_robust_trylock, lll_cond_trylock): Use LLL_LOCK_INITIALIZER*
	rather than LLL_MUTEX_LOCK_INITIALIZER* macros.
	(lll_trylock): Likewise, use __lll_trylock_asm, pass
	MULTIPLE_THREADS_OFFSET as another asm operand.
	(lll_lock): Add private argument, use __lll_lock_asm_start, pass
	MULTIPLE_THREADS_OFFSET as last asm operand, call
	__lll_lock_wait_private if private is constant LLL_PRIVATE,
	otherwise pass private as another argument to __lll_lock_wait.
	(lll_robust_lock, lll_cond_lock, lll_robust_cond_lock,
	lll_timedlock, lll_robust_timedlock): Add private argument, pass
	private as another argument to __lll_*lock_wait call.
	(lll_unlock): Add private argument, use __lll_unlock_asm, pass
	MULTIPLE_THREADS_OFFSET as another asm operand, call
	__lll_unlock_wake_private if private is constant LLL_PRIVATE,
	otherwise pass private as another argument to __lll_unlock_wake.
	(lll_robust_unlock): Add private argument, pass private as another
	argument to __lll_unlock_wake.
	(lll_robust_dead): Add private argument, use __lll_private_flag
	macro.
	(lll_islocked): Use LLL_LOCK_INITIALIZER instead of
	LLL_MUTEX_LOCK_INITIALIZER.
	(lll_lock_t): Remove.
	(LLL_LOCK_INITIALIZER_WAITERS): Define.
	(__lll_cond_wait, __lll_cond_timedwait, __lll_cond_wake,
	__lll_cond_broadcast, lll_cond_wait, lll_cond_timedwait,
	lll_cond_wake, lll_cond_broadcast): Remove.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/libc-lowlevellock.S: Revert
	2007-05-2{3,9} changes.
	* sysdeps/unix/sysv/linux/i386/i486/lowlevellock.S: Include
	kernel-features.h and lowlevellock.h.
	(LOAD_PRIVATE_FUTEX_WAIT): Define.
	(LOAD_FUTEX_WAIT): Rewritten.
	(LOCK, SYS_gettimeofday, SYS_futex, FUTEX_WAIT, FUTEX_WAKE): Don't
	define.
	(__lll_lock_wait_private, __lll_unlock_wake_private): New functions.
	(__lll_mutex_lock_wait): Rename to ...
	(__lll_lock_wait): ... this.  Take futex addr from %edx instead of
	%ecx, %ecx is now private argument.  Don't compile in for libc.so.
	(__lll_mutex_timedlock_wait): Rename to ...
	(__lll_timedlock_wait): ... this.  Use __NR_gettimeofday.  %esi
	contains private argument.  Don't compile in for libc.so.
	(__lll_mutex_unlock_wake): Rename to ...
	(__lll_unlock_wake): ... this.  %ecx contains private argument.
	Don't compile in for libc.so.
	(__lll_timedwait_tid): Use __NR_gettimeofday.
	* sysdeps/unix/sysv/linux/i386/i486/lowlevelrobustlock.S: Include
	kernel-features.h and lowlevellock.h.
	(LOAD_FUTEX_WAIT): Define.
	(LOCK, SYS_gettimeofday, SYS_futex, FUTEX_WAIT, FUTEX_WAKE): Don't
	define.
	(__lll_robust_mutex_lock_wait): Rename to ...
	(__lll_robust_lock_wait): ... this.  Futex addr is now in %edx
	argument, %ecx argument contains private.  Use LOAD_FUTEX_WAIT
	macro.
	(__lll_robust_mutex_timedlock_wait): Rename to ...
	(__lll_robust_timedlock_wait): ... this.  Use __NR_gettimeofday.
	%esi argument contains private, use LOAD_FUTEX_WAIT macro.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_barrier_wait.S: Include
	lowlevellock.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, LOCK): Don't define.
	(pthread_barrier_wait): Rename __lll_mutex_* to __lll_*, pass
	PRIVATE(%ebx) ^ LLL_SHARED as private argument in %ecx to
	__lll_lock_wait and __lll_unlock_wake, pass MUTEX(%ebx) address
	to __lll_lock_wait in %edx.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_broadcast.S:
	Include lowlevellock.h and pthread-errnos.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, FUTEX_REQUEUE,
	FUTEX_CMP_REQUEUE, EINVAL, LOCK): Don't define.
	(__pthread_cond_broadcast): Rename __lll_mutex_* to __lll_*, pass
	cond_lock address in %edx rather than %ecx to __lll_lock_wait,
	pass LLL_SHARED in %ecx to both __lll_lock_wait and
	__lll_unlock_wake.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_signal.S:
	Include lowlevellock.h and pthread-errnos.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, FUTEX_WAKE_OP,
	FUTEX_OP_CLEAR_WAKE_IF_GT_ONE, EINVAL, LOCK): Don't define.
	(__pthread_cond_signal): Rename __lll_mutex_* to __lll_*, pass
	cond_lock address in %edx rather than %ecx to __lll_lock_wait,
	pass LLL_SHARED in %ecx to both __lll_lock_wait and
	__lll_unlock_wake.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_timedwait.S:
	Include lowlevellock.h.
	(SYS_futex, SYS_gettimeofday, FUTEX_WAIT, FUTEX_WAKE, LOCK):
	Don't define.
	(__pthread_cond_timedwait): Rename __lll_mutex_* to __lll_*, pass
	cond_lock address in %edx rather than %ecx to __lll_lock_wait,
	pass LLL_SHARED in %ecx to both __lll_lock_wait and
	__lll_unlock_wake.  Use __NR_gettimeofday.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_wait.S:
	Include lowlevellock.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, LOCK): Don't define.
	(__pthread_cond_wait, __condvar_w_cleanup): Rename __lll_mutex_*
	to __lll_*, pass cond_lock address in %edx rather than %ecx to
	__lll_lock_wait, pass LLL_SHARED in %ecx to both __lll_lock_wait
	and __lll_unlock_wake.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_rdlock.S:
	Include lowlevellock.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, LOCK): Don't define.
	(__pthread_rwlock_rdlock): Rename __lll_mutex_* to __lll_*, pass
	MUTEX(%ebx) address in %edx rather than %ecx to
	__lll_lock_wait, pass PSHARED(%ebx) in %ecx to both __lll_lock_wait
	and __lll_unlock_wake.  Move return value from %ecx to %edx
	register.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_timedrdlock.S:
	Include lowlevellock.h.
	(SYS_futex, SYS_gettimeofday, FUTEX_WAIT, FUTEX_WAKE, LOCK):
	Don't define.
	(__pthread_rwlock_wrlock): Rename __lll_mutex_* to __lll_*, pass
	MUTEX(%ebp) address in %edx rather than %ecx to
	__lll_lock_wait, pass PSHARED(%ebp) in %ecx to both __lll_lock_wait
	and __lll_unlock_wake.  Move return value from %ecx to %edx
	register.  Use __NR_gettimeofday.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_timedwrlock.S:
	Include lowlevellock.h.
	(SYS_futex, SYS_gettimeofday, FUTEX_WAIT, FUTEX_WAKE, LOCK):
	Don't define.
	(__pthread_rwlock_wrlock): Rename __lll_mutex_* to __lll_*, pass
	MUTEX(%ebp) address in %edx rather than %ecx to
	__lll_lock_wait, pass PSHARED(%ebp) in %ecx to both __lll_lock_wait
	and __lll_unlock_wake.  Move return value from %ecx to %edx
	register.  Use __NR_gettimeofday.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_unlock.S:
	Include lowlevellock.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, LOCK): Don't define.
	(__pthread_rwlock_unlock): Rename __lll_mutex_* to __lll_*, pass
	MUTEX(%edi) address in %edx rather than %ecx to
	__lll_lock_wait, pass PSHARED(%edi) in %ecx to both __lll_lock_wait
	and __lll_unlock_wake.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_wrlock.S:
	Include lowlevellock.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, LOCK): Don't define.
	(__pthread_rwlock_wrlock): Rename __lll_mutex_* to __lll_*, pass
	MUTEX(%ebx) address in %edx rather than %ecx to
	__lll_lock_wait, pass PSHARED(%ebx) in %ecx to both __lll_lock_wait
	and __lll_unlock_wake.  Move return value from %ecx to %edx
	register.
	* sysdeps/unix/sysv/linux/i386/pthread_once.S: Include
	lowlevellock.h.
	(LOCK, SYS_futex, FUTEX_WAIT, FUTEX_WAKE, FUTEX_PRIVATE_FLAG): Don't
	define.
	* sysdeps/unix/sysv/linux/i386/i486/sem_post.S: Include lowlevellock.h.
	(LOCK, SYS_futex, FUTEX_WAKE): Don't define.
	* sysdeps/unix/sysv/linux/i386/i486/sem_timedwait.S: Include
	lowlevellock.h.
	(LOCK, SYS_futex, SYS_gettimeofday, FUTEX_WAIT): Don't define.
	(sem_timedwait): Use __NR_gettimeofday.
	* sysdeps/unix/sysv/linux/i386/i486/sem_trywait.S: Include
	lowlevellock.h.
	(LOCK): Don't define.
	* sysdeps/unix/sysv/linux/i386/i486/sem_wait.S: Include
	lowlevellock.h.
	(LOCK, SYS_futex, FUTEX_WAIT): Don't define.
	* sysdeps/unix/sysv/linux/powerpc/sem_post.c: Wake only when there
	are waiters.
	* sysdeps/unix/sysv/linux/x86_64/libc-lowlevellock.S: Revert
	2007-05-2{3,9} changes.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.S: Include
	kernel-features.h and lowlevellock.h.
	(LOAD_PRIVATE_FUTEX_WAIT): Define.
	(LOAD_FUTEX_WAIT): Rewritten.
	(LOCK, SYS_futex, FUTEX_WAIT, FUTEX_WAKE): Don't define.
	(__lll_lock_wait_private, __lll_unlock_wake_private): New functions.
	(__lll_mutex_lock_wait): Rename to ...
	(__lll_lock_wait): ... this.  %esi is now private argument.
	Don't compile in for libc.so.
	(__lll_mutex_timedlock_wait): Rename to ...
	(__lll_timedlock_wait): ... this.  %esi contains private argument.
	Don't compile in for libc.so.
	(__lll_mutex_unlock_wake): Rename to ...
	(__lll_unlock_wake): ... this.  %esi contains private argument.
	Don't compile in for libc.so.
	* sysdeps/unix/sysv/linux/x86_64/lowlevelrobustlock.S: Include
	kernel-features.h and lowlevellock.h.
	(LOAD_FUTEX_WAIT): Define.
	(LOCK, SYS_futex, FUTEX_WAIT, FUTEX_WAKE): Don't define.
	(__lll_robust_mutex_lock_wait): Rename to ...
	(__lll_robust_lock_wait): ... this.  %esi argument contains private.
	Use LOAD_FUTEX_WAIT macro.
	(__lll_robust_mutex_timedlock_wait): Rename to ...
	(__lll_robust_timedlock_wait): ... this. %esi argument contains
	private, use LOAD_FUTEX_WAIT macro.
	* sysdeps/unix/sysv/linux/x86_64/pthread_barrier_wait.S: Include
	lowlevellock.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, LOCK): Don't define.
	(pthread_barrier_wait): Rename __lll_mutex_* to __lll_*, pass
	PRIVATE(%rdi) ^ LLL_SHARED as private argument in %esi to
	__lll_lock_wait and __lll_unlock_wake.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_broadcast.S:
	Include lowlevellock.h and pthread-errnos.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, FUTEX_REQUEUE,
	FUTEX_CMP_REQUEUE, EINVAL, LOCK): Don't define.
	(__pthread_cond_broadcast): Rename __lll_mutex_* to __lll_*,
	pass LLL_SHARED in %esi to both __lll_lock_wait and
	__lll_unlock_wake.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_signal.S:
	Include lowlevellock.h and pthread-errnos.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, FUTEX_WAKE_OP,
	FUTEX_OP_CLEAR_WAKE_IF_GT_ONE, EINVAL, LOCK): Don't define.
	(__pthread_cond_signal): Rename __lll_mutex_* to __lll_*,
	pass LLL_SHARED in %esi to both __lll_lock_wait and
	__lll_unlock_wake.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S:
	Include lowlevellock.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, LOCK): Don't define.
	(__pthread_cond_timedwait): Rename __lll_mutex_* to __lll_*,
	pass LLL_SHARED in %esi to both __lll_lock_wait and
	__lll_unlock_wake.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S:
	Include lowlevellock.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, LOCK): Don't define.
	(__pthread_cond_wait, __condvar_cleanup): Rename __lll_mutex_*
	to __lll_*, pass LLL_SHARED in %esi to both __lll_lock_wait
	and __lll_unlock_wake.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_rdlock.S:
	Include lowlevellock.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, FUTEX_PRIVATE_FLAG, LOCK):
	Don't define.
	(__pthread_rwlock_rdlock): Rename __lll_mutex_* to __lll_*,
	pass PSHARED(%rdi) in %esi to both __lll_lock_wait
	and __lll_unlock_wake.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedrdlock.S:
	Include lowlevellock.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, FUTEX_PRIVATE_FLAG, LOCK):
	Don't define.
	(__pthread_rwlock_wrlock): Rename __lll_mutex_* to __lll_*,
	pass PSHARED(%rdi) in %esi to both __lll_lock_wait
	and __lll_unlock_wake.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedwrlock.S:
	Include lowlevellock.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, FUTEX_PRIVATE_FLAG, LOCK):
	Don't define.
	(__pthread_rwlock_wrlock): Rename __lll_mutex_* to __lll_*,
	pass PSHARED(%rdi) in %esi to both __lll_lock_wait
	and __lll_unlock_wake.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_unlock.S:
	Include lowlevellock.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, FUTEX_PRIVATE_FLAG, LOCK):
	Don't define.
	(__pthread_rwlock_unlock): Rename __lll_mutex_* to __lll_*,
	pass PSHARED(%rdi) in %esi to both __lll_lock_wait
	and __lll_unlock_wake.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_wrlock.S:
	Include lowlevellock.h.
	(SYS_futex, FUTEX_WAIT, FUTEX_WAKE, FUTEX_PRIVATE_FLAG, LOCK):
	Don't define.
	(__pthread_rwlock_wrlock): Rename __lll_mutex_* to __lll_*,
	pass PSHARED(%rdi) in %ecx to both __lll_lock_wait
	and __lll_unlock_wake.
	* sysdeps/unix/sysv/linux/x86_64/pthread_once.S: Include
	lowlevellock.h.
	(LOCK, SYS_futex, FUTEX_WAIT, FUTEX_WAKE, FUTEX_PRIVATE_FLAG): Don't
	define.
	* sysdeps/unix/sysv/linux/x86_64/sem_post.S: Include lowlevellock.h.
	(LOCK, SYS_futex, FUTEX_WAKE): Don't define.
	* sysdeps/unix/sysv/linux/x86_64/sem_timedwait.S: Include
	lowlevellock.h.
	(LOCK, SYS_futex, FUTEX_WAIT): Don't define.
	* sysdeps/unix/sysv/linux/x86_64/sem_trywait.S: Include
	lowlevellock.h.
	(LOCK): Don't define.
	* sysdeps/unix/sysv/linux/x86_64/sem_wait.S: Include
	lowlevellock.h.
	(LOCK, SYS_futex, FUTEX_WAIT): Don't define.
	* sysdeps/unix/sysv/linux/sparc/internaltypes.h: New file.
	* sysdeps/unix/sysv/linux/sparc/pthread_barrier_destroy.c: New file.
	* sysdeps/unix/sysv/linux/sparc/pthread_barrier_init.c: New file.
	* sysdeps/unix/sysv/linux/sparc/pthread_barrier_wait.c: New file.
	* sysdeps/unix/sysv/linux/sparc/sparc32/lowlevellock.c
	(__lll_lock_wait_private): New function.
	(__lll_lock_wait, __lll_timedlock_wait): Add private argument, pass
	it to lll_futex_*wait.  Don't compile in for libc.so.
	* sysdeps/unix/sysv/linux/sparc/sparc32/pthread_barrier_init.c:
	Remove.
	* sysdeps/unix/sysv/linux/sparc/sparc32/pthread_barrier_wait.c
	(struct sparc_pthread_barrier): Remove.
	(pthread_barrier_wait): Use union sparc_pthread_barrier instead of
	struct sparc_pthread_barrier.  Pass
	ibarrier->s.pshared ? LLL_SHARED : LLL_PRIVATE to lll_{,un}lock
	and lll_futex_wait macros.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sparcv9/pthread_barrier_init.c:
	Remove.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sparcv9/pthread_barrier_wait.c:
	Include sparc pthread_barrier_wait.c instead of generic one.

2007-07-30  Jakub Jelinek  <jakub@redhat.com>

	* tst-rwlock14.c (do_test): Avoid warnings on 32-bit arches.

	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_timedrdlock.S
	(pthread_rwlock_timedrdlock): Copy futex retval to %esi rather than
	%ecx.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_timedwrlock.S
	(pthread_rwlock_timedwrlock): Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_unlock.S
	(__pthread_rwlock_unlock): Fix MUTEX != 0 args to __lll_*.

2007-07-31  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/sparc/tls.h (tcbhead_t): Add private_futex field.

2007-07-26  Jakub Jelinek  <jakub@redhat.com>

	* tst-locale2.c (useless): Add return statement.

2007-07-24  Jakub Jelinek  <jakub@redhat.com>

	* allocatestack.c (__nptl_setxid, __wait_lookup_done): Replace
	lll_private_futex_* (*) with lll_futex_* (*, LLL_PRIVATE).
	* pthread_create.c (start_thread): Likewise.
	* init.c (sighandler_setxid): Likewise.
	* sysdeps/alpha/tls.h (THREAD_GSCOPE_RESET_FLAG): Likewise.
	* sysdeps/ia64/tls.h (THREAD_GSCOPE_RESET_FLAG): Likewise.
	* sysdeps/i386/tls.h (THREAD_GSCOPE_RESET_FLAG): Likewise.
	* sysdeps/s390/tls.h (THREAD_GSCOPE_RESET_FLAG): Likewise.
	* sysdeps/powerpc/tls.h (THREAD_GSCOPE_RESET_FLAG): Likewise.
	* sysdeps/x86_64/tls.h (THREAD_GSCOPE_RESET_FLAG): Likewise.
	* sysdeps/sparc/tls.h (THREAD_GSCOPE_RESET_FLAG): Likewise.
	* sysdeps/sh/tls.h (THREAD_GSCOPE_RESET_FLAG): Likewise.
	* sysdeps/pthread/aio_misc.h (AIO_MISC_NOTIFY, AIO_MISC_WAIT):
	Likewise.
	* sysdeps/pthread/gai_misc.h (GAI_MISC_NOTIFY, GAI_MISC_WAIT):
	Likewise.
	* sysdeps/unix/sysv/linux/unregister-atfork.c (__unregister_atfork):
	Likewise.
	* sysdeps/unix/sysv/linux/rtld-lowlevel.h (__rtld_waitzero,
	__rtld_notify): Likewise.
	* sysdeps/unix/sysv/linux/fork.c (__libc_fork): Likewise.
	* sysdeps/unix/sysv/linux/powerpc/pthread_once.c (clear_once_control,
	__pthread_once): Likewise.
	* sysdeps/unix/sysv/linux/alpha/pthread_once.c (clear_once_control,
	__pthread_once): Add LLL_PRIVATE as last argument to lll_futex_*.
	* sysdeps/unix/sysv/linux/alpha/lowlevellock.h (FUTEX_PRIVATE_FLAG,
	LLL_PRIVATE, LLL_SHARED, __lll_private_flag): Define.
	(lll_futex_wait): Add private argument, define as wrapper around
	lll_futex_timed_wait.
	(lll_futex_timed_wait, lll_futex_wake): Add private argument,
	use __lll_private_flag macro.
	(lll_robust_mutex_dead, __lll_mutex_unlock, __lll_robust_mutex_unlock,
	__lll_mutex_unlock_force): Pass LLL_SHARED as last arg to lll_futex_*.
	* sysdeps/unix/sysv/linux/ia64/pthread_once.c (clear_once_control,
	__pthread_once): Add LLL_PRIVATE as last argument to lll_futex_*.
	* sysdeps/unix/sysv/linux/ia64/lowlevellock.h (FUTEX_PRIVATE_FLAG,
	LLL_PRIVATE, LLL_SHARED, __lll_private_flag): Define.
	(lll_futex_wait): Add private argument, define as wrapper around
	lll_futex_timed_wait.
	(lll_futex_timed_wait, lll_futex_wake): Add private argument,
	use __lll_private_flag macro.
	(__lll_mutex_unlock, __lll_robust_mutex_unlock, lll_wait_tid,
	__lll_mutex_unlock_force): Pass LLL_SHARED as last arg to lll_futex_*.
	* sysdeps/unix/sysv/linux/i386/lowlevellock.h (__lll_private_flag):
	Define.
	(lll_futex_timed_wait, lll_futex_wake): Use it.
	(lll_private_futex_wait, lll_private_futex_timed_wait,
	lll_private_futex_wake): Removed.
	* sysdeps/unix/sysv/linux/s390/pthread_once.c (clear_once_control,
	__pthread_once): Add LLL_PRIVATE as last argument to lll_futex_*.
	* sysdeps/unix/sysv/linux/s390/lowlevellock.h (FUTEX_PRIVATE_FLAG,
	LLL_PRIVATE, LLL_SHARED, __lll_private_flag): Define.
	(lll_futex_wait): Add private argument, define as wrapper around
	lll_futex_timed_wait.
	(lll_futex_timed_wait, lll_futex_wake): Add private argument,
	use __lll_private_flag macro.
	(lll_robust_mutex_dead, __lll_mutex_unlock, __lll_robust_mutex_unlock,
	lll_wait_tid, __lll_mutex_unlock_force): Pass LLL_SHARED as last arg
	to lll_futex_*.
	* sysdeps/unix/sysv/linux/powerpc/lowlevellock.h
	(lll_private_futex_wait, lll_private_futex_timed_wait,
	lll_private_futex_wake): Removed.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h (__lll_private_flag):
	Fix !__ASSUME_PRIVATE_FUTEX non-constant private case.
	(lll_private_futex_wait, lll_private_futex_timed_wait,
	lll_private_futex_wake): Removed.
	* sysdeps/unix/sysv/linux/sparc/pthread_once.c (clear_once_control,
	__pthread_once): Add LLL_PRIVATE as last argument to lll_futex_*.
	* sysdeps/unix/sysv/linux/sparc/lowlevellock.h (FUTEX_PRIVATE_FLAG,
	LLL_PRIVATE, LLL_SHARED, __lll_private_flag): Define.
	(lll_futex_wait): Add private argument, define as wrapper around
	lll_futex_timed_wait.
	(lll_futex_timed_wait, lll_futex_wake): Add private argument,
	use __lll_private_flag macro.
	(lll_robust_mutex_dead, __lll_mutex_unlock, __lll_robust_mutex_unlock,
	lll_wait_tid, __lll_mutex_unlock_force): Pass LLL_SHARED as last arg
	to lll_futex_*.
	* sysdeps/unix/sysv/linux/sh/lowlevellock.h (__lll_private_flag):
	Define.
	(lll_futex_timed_wait, lll_futex_wake): Use it.
	(lll_private_futex_wait, lll_private_futex_timed_wait,
	lll_private_futex_wake): Removed.

2007-07-27  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/sparc/tls.h (tcbhead_t): Move gscope_flag to the end
	of the structure for sparc32.

2007-07-26  Aurelien Jarno  <aurelien@aurel32.net>

	* sysdeps/sparc/tls.h (tcbhead_t): Add gscope_flag.

2007-07-23  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedrdlock.S: Fix
	code used when private futexes are assumed.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedwrlock.S:
	Likewise.

2007-07-23  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/powerpc/lowlevellock.h
	(__lll_private_flag): Define.
	(lll_futex_wait): Define as a wrapper around lll_futex_timed_wait.
	(lll_futex_timed_wait, lll_futex_wake, lll_futex_wake_unlock): Use
	__lll_private_flag.
	(lll_private_futex_wait, lll_private_futex_timedwait,
	lll_private_futex_wake): Define as wrapper around non-_private
	macros.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h
	(__lll_private_flag): Define.
	(lll_futex_timed_wait, lll_futex_wake): Use __lll_private_flag.
	(lll_private_futex_wait, lll_private_futex_timedwait,
	lll_private_futex_wake): Define as wrapper around non-_private
	macros.

2007-07-10  Steven Munroe  <sjmunroe@us.ibm.com>

	* pthread_rwlock_rdlock.c (__pthread_rwlock_rdlock): Add LLL_SHARED
	parameter to lll_futex_wait call.
	* pthread_rwlock_wrlock.c (__pthread_rwlock_wrlock): Likewise.

	* sysdeps/unix/sysv/linux/powerpc/pthread_once.c (__pthread_once):
	Replace lll_futex_wait with lll_private_futex_wait.
	* sysdeps/unix/sysv/linux/powerpc/sem_post.c (__new_sem_post):
	Add LLL_SHARED parameter to lll_futex_wake().

	* sysdeps/unix/sysv/linux/powerpc/lowlevellock.h: Define LLL_PRIVATE
	LLL_SHARED, lll_private_futex_wait, lll_private_futex_timed_wait and
	lll_private_futex_wake.
	(lll_futex_wait): Add private parameter. Adjust FUTEX_PRIVATE_FLAG
	bit from private parm before syscall.
	(lll_futex_timed_wait): Likewise.
	(lll_futex_wake): Likewise.
	(lll_futex_wake_unlock): Likewise.
	(lll_mutex_unlock): Add LLL_SHARED parm to lll_futex_wake call.
	(lll_robust_mutex_unlock): Likewise.
	(lll_mutex_unlock_force): Likewise.
	(lll_wait_tid): Add LLL_SHARED parm to lll_futex_wait call.

2007-07-23  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedrdlock.S: Fix
	compilation when unconditionally using private futexes.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_rdlock.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedwrlock.S:
	Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_unlock.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_wrlock.S: Likewise.

2007-07-17  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/pthread/bits/stdio-lock.h (_IO_acquire_lock_clear_flags2):
	Define.

2007-07-06  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/sh/tls.h: Include stdlib.h, list.h, sysdep.h and
	kernel-features.h.

2007-05-16  Roland McGrath  <roland@redhat.com>

	* init.c (__nptl_initial_report_events): New variable.
	(__pthread_initialize_minimal_internal): Initialize pd->report_events
	to that.

2007-06-22  Jakub Jelinek  <jakub@redhat.com>

	* pthread_getattr_np.c (pthread_getattr_np): Clear cpuset and
	cpusetsize if pthread_getaffinity_np failed with ENOSYS.

2007-06-19  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/rtld-lowlevel.h: Remove mrlock
	implementation.

2007-06-18  Ulrich Drepper  <drepper@redhat.com>

	* pthreadP.h: Define PTHREAD_MUTEX_TYPE.
	* phtread_mutex_lock.c: Use PTHREAD_MUTEX_TYPE.
	* pthread_mutex_timedlock.c: Likewise.
	* pthread_mutex_trylock.c: Likewise.
	* pthread_mutex_unlock.c: Likewise.

2007-06-17  Andreas Schwab  <schwab@suse.de>

	* sysdeps/pthread/pt-initfini.c: Tell gcc about the nonstandard
	sections.

2007-06-17  Ulrich Drepper  <drepper@redhat.com>

	* allocatestack.c (allocate_stack): Make code compile if
	__ASSUME_PRIVATE_FUTEX is set.

2007-06-17  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_rdlock.S:
	(__pthread_rwlock_rdlock): Don't use non SH-3/4 instruction.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_wrlock.S:
	(__pthread_rwlock_wrlock): Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_timedrdlock.S:
	(pthread_rwlock_timedrdlock): Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_timedwrlock.S:
	(pthread_rwlock_timedwrlock): Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_unlock.S:
	(__pthread_rwlock_unlock): Likewise.

2007-06-10  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/sh/tcb-offsets.sym: Add PRIVATE_FUTEX.
	* sysdeps/unix/sysv/linux/sh/bits/pthreadtypes.h: Include endian.h.
	Split __flags into __flags, __shared, __pad1 and __pad2.
	* sysdeps/unix/sysv/linux/sh/libc-lowlevellock.S: Use private
	futexes if they are available.
	* sysdeps/unix/sysv/linux/sh/lowlevellock.S: Adjust so that change
	in libc-lowlevellock.S allow using private futexes.
	* sysdeps/unix/sysv/linux/sh/lowlevellock.h: Define
	FUTEX_PRIVATE_FLAG.  Add additional parameter to lll_futex_wait,
	lll_futex_timed_wait and lll_futex_wake.  Change lll_futex_wait
	to call lll_futex_timed_wait.  Add lll_private_futex_wait,
	lll_private_futex_timed_wait and lll_private_futex_wake.
	(lll_robust_mutex_unlock): Fix typo.
	* sysdeps/unix/sysv/linux/sh/pthread_barrier_wait.S: Use private
	field in futex command setup.
	* sysdeps/unix/sysv/linux/sh/pthread_cond_timedwait.S: Use
	COND_NWAITERS_SHIFT instead of COND_CLOCK_BITS.
	* sysdeps/unix/sysv/linux/sh/pthread_cond_wait.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_once.S: Use private futexes
	if they are available.  Remove clear_once_control.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_rdlock.S: Use private
	futexes if they are available.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_timedrdlock.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_timedwrlock.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_unlock.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/pthread_rwlock_wrlock.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/sem_post.S: Add private futex support.
	Wake only when there are waiters.
	* sysdeps/unix/sysv/linux/sh/sem_wait.S: Add private futex
	support.  Indicate that there are waiters.  Remove unnecessary
	extra cancellation test.
	* sysdeps/unix/sysv/linux/sh/sem_timedwait.S: Likewise.  Removed
	left-over duplication of __sem_wait_cleanup.

2007-06-07  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h: Add additional
	parameter to lll_futex_wait, lll_futex_timed_wait, and
	lll_futex_wake.  Change lll_futex_wait to call lll_futex_timed_wait.
	Add lll_private_futex_wait, lll_private_futex_timed_wait, and
	lll_private_futex_wake.
	* sysdeps/unix/sysv/linux/i386/lowlevellock.h: Likewise.
	* allocatestack.c: Adjust use of lll_futex_* macros.
	* init.c: Likewise.
	* lowlevellock.h: Likewise.
	* pthread_barrier_wait.c: Likewise.
	* pthread_cond_broadcast.c: Likewise.
	* pthread_cond_destroy.c: Likewise.
	* pthread_cond_signal.c: Likewise.
	* pthread_cond_timedwait.c: Likewise.
	* pthread_cond_wait.c: Likewise.
	* pthread_create.c: Likewise.
	* pthread_mutex_lock.c: Likewise.
	* pthread_mutex_setprioceiling.c: Likewise.
	* pthread_mutex_timedlock.c: Likewise.
	* pthread_mutex_unlock.c: Likewise.
	* pthread_rwlock_timedrdlock.c: Likewise.
	* pthread_rwlock_timedwrlock.c: Likewise.
	* pthread_rwlock_unlock.c: Likewise.
	* sysdeps/alpha/tls.h: Likewise.
	* sysdeps/i386/tls.h: Likewise.
	* sysdeps/ia64/tls.h: Likewise.
	* sysdeps/powerpc/tls.h: Likewise.
	* sysdeps/pthread/aio_misc.h: Likewise.
	* sysdeps/pthread/gai_misc.h: Likewise.
	* sysdeps/s390/tls.h: Likewise.
	* sysdeps/sh/tls.h: Likewise.
	* sysdeps/sparc/tls.h: Likewise.
	* sysdeps/unix/sysv/linux/fork.c: Likewise.
	* sysdeps/unix/sysv/linux/lowlevellock.c: Likewise.
	* sysdeps/unix/sysv/linux/lowlevelrobustlock.c: Likewise.
	* sysdeps/unix/sysv/linux/rtld-lowlevel.h: Likewise.
	* sysdeps/unix/sysv/linux/sem_post.c: Likewise.
	* sysdeps/unix/sysv/linux/sem_timedwait.c: Likewise.
	* sysdeps/unix/sysv/linux/sem_wait.c: Likewise.
	* sysdeps/unix/sysv/linux/unregister-atfork.c: Likewise.
	* sysdeps/unix/sysv/linux/sparc/pthread_once.c: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/pthread_barrier_wait.c:
	Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sem_post.c: Likewise.
	* sysdeps/x86_64/tls.h: Likewise.

2007-05-29  Ulrich Drepper  <drepper@redhat.com>

	* pthread_getattr_np.c: No need to install a cancellation handler,
	this is no cancellation point.
	* pthread_getschedparam.c: Likewise.
	* pthread_setschedparam.c: Likewise.
	* pthread_setschedprio.c: Likewise.
	* sysdeps/unix/sysv/linux/lowlevellock.c: Remove all traces of
	lll_unlock_wake_cb.
	* sysdeps/unix/sysv/linux/alpha/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/i386/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/lowlevellock.S: Likewise.
	* sysdeps/unix/sysv/linux/ia64/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/sh/lowlevellock.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/lowlevellock.c: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h: Likewise.

	* sysdeps/unix/sysv/linux/i386/i486/libc-lowlevellock.S: Checking
	whether there are more than one thread makes no sense here since
	we only call the slow path if the locks are taken.
	* sysdeps/unix/sysv/linux/x86_64/libc-lowlevellock.S: Likewise.

	* sysdeps/unix/sysv/linux/internaltypes.h: Introduce
	COND_NWAITERS_SHIFT.
	* pthread_cond_destroy.c: Use COND_NWAITERS_SHIFT instead of
	COND_CLOCK_BITS.
	* pthread_cond_init.c: Likewise.
	* pthread_cond_timedwait.c: Likewise.
	* pthread_cond_wait.c: Likewise.
	* pthread_condattr_getclock.c: Likewise.
	* pthread_condattr_setclock.c: Likewise.
	* sysdeps/unix/sysv/linux/lowlevelcond.sym: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_timedwait.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_wait.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_timedwait.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S: Likewise.

2007-05-28  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/powerpc/pthread_attr_setstacksize.c: Include
	unistd.h.

	* sysdeps/i386/tls.h (THREAD_GSCOPE_RESET_FLAG): Use explicit
	insn suffix.
	(THREAD_GSCOPE_GET_FLAG): Remove.
	* sysdeps/x86_64/tls.h (THREAD_GSCOPE_GET_FLAG): Remove.
	* allocatestack.c (__wait_lookup_done): Revert 2007-05-24
	changes.
	* sysdeps/powerpc/tls.h (tcbhead_t): Remove gscope_flag.
	(THREAD_GSCOPE_GET_FLAG): Remove.
	(THREAD_GSCOPE_RESET_FLAG): Use THREAD_SELF->header.gscope_flag
	instead of THREAD_GSCOPE_GET_FLAG.
	(THREAD_GSCOPE_SET_FLAG): Likewise.  Add atomic_write_barrier after
	it.
	* sysdeps/s390/tls.h (THREAD_GSCOPE_FLAG_UNUSED,
	THREAD_GSCOPE_FLAG_USED, THREAD_GSCOPE_FLAG_WAIT,
	THREAD_GSCOPE_RESET_FLAG, THREAD_GSCOPE_SET_FLAG,
	THREAD_GSCOPE_WAIT): Define.
	* sysdeps/sparc/tls.h (THREAD_GSCOPE_FLAG_UNUSED,
	THREAD_GSCOPE_FLAG_USED, THREAD_GSCOPE_FLAG_WAIT,
	THREAD_GSCOPE_RESET_FLAG, THREAD_GSCOPE_SET_FLAG,
	THREAD_GSCOPE_WAIT): Define.
	* sysdeps/sh/tls.h (THREAD_GSCOPE_FLAG_UNUSED,
	THREAD_GSCOPE_FLAG_USED, THREAD_GSCOPE_FLAG_WAIT,
	THREAD_GSCOPE_RESET_FLAG, THREAD_GSCOPE_SET_FLAG,
	THREAD_GSCOPE_WAIT): Define.
	* sysdeps/ia64/tls.h (THREAD_GSCOPE_FLAG_UNUSED,
	THREAD_GSCOPE_FLAG_USED, THREAD_GSCOPE_FLAG_WAIT,
	THREAD_GSCOPE_RESET_FLAG, THREAD_GSCOPE_SET_FLAG,
	THREAD_GSCOPE_WAIT): Define.

2007-05-24  Richard Henderson  <rth@redhat.com>

	* descr.h (struct pthread): Add header.gscope_flag.
	* sysdeps/alpha/tls.h (THREAD_GSCOPE_FLAG_UNUSED,
	THREAD_GSCOPE_FLAG_USED, THREAD_GSCOPE_FLAG_WAIT,
	THREAD_GSCOPE_RESET_FLAG, THREAD_GSCOPE_SET_FLAG,
	THREAD_GSCOPE_WAIT): Define.

2007-05-27  Ulrich Drepper  <drepper@redhat.com>

	* init.c: Make it compile with older kernel headers.

	* tst-initializers1.c: Show through exit code which test failed.

	* pthread_rwlock_init.c: Also initialize __shared field.
	* sysdeps/unix/sysv/linux/i386/bits/pthreadtypes.h: Split __flags
	element in rwlock structure into four byte elements.  One of them is
	the new __shared element.
	* sysdeps/unix/sysv/linux/x86_64/bits/pthreadtypes.h [__WORDSIZE=32]:
	Likewise.
	[__WORDSIZE=64]: Renamed __pad1 element int rwlock structure to
	__shared, adjust names of other padding elements.
	* sysdeps/unix/sysv/linux/powerpc/bits/pthreadtypes.h: Likewise.
	* sysdeps/pthread/pthread.h: Adjust rwlock initializers.
	* sysdeps/unix/sysv/linux/lowlevelrwlock.sym: Add PSHARED.
	* sysdeps/unix/sysv/linux/powerpc/lowlevellock.h: Define
	FUTEX_PRIVATE_FLAG.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_rdlock.S: Change main
	futex to use private operations if possible.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedrdlock.S:
	Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_timedwrlock.S:
	Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_unlock.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_rwlock_wrlock.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_rdlock.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_timedrdlock.S:
	Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_timedwrlock.S:
	Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_unlock.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_rwlock_wrlock.S: Likewise.

2007-05-26  Ulrich Drepper  <drepper@redhat.com>

	* pthreadP.h (PTHREAD_RWLOCK_PREFER_READER_P): Define.
	* pthread_rwlock_rdlock.c: Use PTHREAD_RWLOCK_PREFER_READER_P.
	* pthread_rwlock_timedrdlock.c: Likewise.
	* pthread_rwlock_tryrdlock.c: Likewise.

	* sysdeps/unix/sysv/linux/x86_64/sem_trywait.S (sem_trywait): Tiny
	optimization.

	* sysdeps/unix/sysv/linux/sem_wait.c: Add missing break.
	* sysdeps/unix/sysv/linux/sem_timedwait.c: Removed left-over
	duplication of __sem_wait_cleanup.

	* allocatestack.c: Revert last change.
	* init.c: Likewise.
	* sysdeps/i386/tls.h: Likewise.
	* sysdeps/x86_64/tls.h: Likewise.
	* descr.h [TLS_DTV_AT_TP] (struct pthread): Add private_futex field to
	header structure.
	* sysdeps/powerpc/tcb-offsets.sym: Add PRIVATE_FUTEX_OFFSET.

	* sysdeps/unix/sysv/linux/internaltypes.h (struct pthread_barrier):
	Add private field.
	* sysdeps/unix/sysv/linux/lowlevelbarrier.sym: Add PRIVATE definition.
	* pthread_barrier_init.c: Set private flag if pshared and private
	futexes are supported.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_barrier_wait.S: Use
	private field in futex command setup.
	* sysdeps/unix/sysv/linux/x86_64/pthread_barrier_wait.S: Likewise.

2007-05-25  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/i386/i486/sem_post.S: Add private futex
	support.
	* sysdeps/unix/sysv/linux/i386/i486/sem_timedwait.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/sem_wait.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/sem_post.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/sem_timedwait.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/sem_wait.S: Likewise.

	* semaphoreP.h: Declare __old_sem_init and __old_sem_wait.
	* sem_init.c (__new_sem_init): Rewrite to initialize all three
	fields in the structure.
	(__old_sem_init): New function.
	* sem_open.c: Initialize all fields of the structure.
	* sem_getvalue.c: Adjust for renamed element.
	* sysdeps/unix/sysv/linux/Makefile [subdir=nptl]
	(gen-as-const-headers): Add structsem.sym.
	* sysdeps/unix/sysv/linux/structsem.sym: New file.
	* sysdeps/unix/sysv/linux/internaltypes.h: Rename struct sem to
	struct new_sem.  Add struct old_sem.
	* sysdeps/unix/sysv/linux/sem_post.c: Wake only when there are waiters.
	* sysdeps/unix/sysv/linux/i386/i486/sem_post.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/sem_post.S: Likewise.
	* sysdeps/unix/sysv/linux/sem_wait.c: Indicate that there are waiters.
	* sysdeps/unix/sysv/linux/i386/i486/sem_wait.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/sem_wait.S: Likewise.
	* sysdeps/unix/sysv/linux/sem_timedwait.c: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/sem_timedwait.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/sem_timedwait.S: Likewise.
	* Makefile (tests): Add tst-sem10, tst-sem11, tst-sem12.
	* tst-sem10.c: New file.
	* tst-sem11.c: New file.
	* tst-sem12.c: New file.
	* tst-typesizes.c: Test struct new_sem and struct old_sem instead
	of struct sem.

2007-05-25  Ulrich Drepper  <drepper@redhat.com>
	    Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/i386/i486/sem_timedwait.S (sem_timedwait):
	Move __pthread_enable_asynccancel right before futex syscall.
	* sysdeps/unix/sysv/linux/x86_64/sem_timedwait.S (sem_timedwait):
	Likewise.

2007-05-24  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/i386/tls.h (THREAD_SET_PRIVATE_FUTEX,
	THREAD_COPY_PRIVATE_FUTEX): Define.
	* sysdeps/x86_64/tls.h (THREAD_SET_PRIVATE_FUTEX,
	THREAD_COPY_PRIVATE_FUTEX): Define.
	* allocatestack.c (allocate_stack): Use THREAD_COPY_PRIVATE_FUTEX.
	* init.c (__pthread_initialize_minimal_internal): Use
	THREAD_SET_PRIVATE_FUTEX.

	* sysdeps/powerpc/tls.h (tcbhead_t): Add gscope_flag.
	(THREAD_GSCOPE_FLAG_UNUSED, THREAD_GSCOPE_FLAG_USED,
	THREAD_GSCOPE_FLAG_WAIT): Define.
	(THREAD_GSCOPE_GET_FLAG, THREAD_GSCOPE_SET_FLAG,
	THREAD_GSCOPE_RESET_FLAG, THREAD_GSCOPE_WAIT): Define.
	* sysdeps/i386/tls.h (THREAD_GSCOPE_WAIT): Don't use
	PTR_DEMANGLE.
	(THREAD_GSCOPE_GET_FLAG): Define.
	* sysdeps/x86_64/tls.h (THREAD_GSCOPE_GET_FLAG): Define.
	* allocatestack.c (__wait_lookup_done): Use THREAD_GSCOPE_GET_FLAG
	instead of ->header.gscope_flag directly.

2007-05-23  Ulrich Drepper  <drepper@redhat.com>

	* init.c (__pthread_initialize_minimal_internal): Check whether
	private futexes are available.
	* allocatestack.c (allocate_stack): Copy private_futex field from
	current thread into the new stack.
	* sysdeps/unix/sysv/linux/x86_64/libc-lowlevellock.S: Use private
	futexes if they are available.
	* sysdeps/unix/sysv/linux/i386/i486/libc-lowlevellock.S: Likewise
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.S: Adjust so that change
	in libc-lowlevellock.S allow using private futexes.
	* sysdeps/unix/sysv/linux/i386/i486/lowlevellock.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h: Define
	FUTEX_PRIVATE_FLAG.
	* sysdeps/unix/sysv/linux/i386/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_once.S: Use private futexes
	if they are available.
	* sysdeps/unix/sysv/linux/i386/pthread_once.S: Likewise.
	* sysdeps/x86_64/tcb-offsets.sym: Add PRIVATE_FUTEX.
	* sysdeps/i386/tcb-offsets.sym: Likewise.
	* sysdeps/x86_64/tls.h (tcbhead_t): Add private_futex field.
	* sysdeps/i386/tls.h (tcbhead_t): Likewise.

2007-05-21  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/pthread-functions.h (struct pthread_functions):
	Remove ptr_wait_lookup_done again.
	* init.c (pthread_functions): Don't add .ptr_wait_lookup_done here.
	(__pthread_initialize_minimal_internal): Initialize
	_dl_wait_lookup_done pointer in _rtld_global directly.
	* sysdeps/unix/sysv/linux/libc_pthread_init.c (__libc_pthread_init):
	Remove code to code _dl_wait_lookup_done.
	* sysdeps/x86_64/tls.h (THREAD_GSCOPE_WAIT): The pointer is not
	encrypted for now.

2007-05-21  Jakub Jelinek  <jakub@redhat.com>

	* tst-robust9.c (do_test): Don't fail if ENABLE_PI and
	pthread_mutex_init failed with ENOTSUP.

2007-05-19  Ulrich Drepper  <drepper@redhat.com>

	* allocatestack.c (__wait_lookup_done): New function.
	* sysdeps/pthread/pthread-functions.h (struct pthread_functions):
	Add ptr_wait_lookup_done.
	* init.c (pthread_functions): Initialize .ptr_wait_lookup_done.
	* pthreadP.h: Declare __wait_lookup_done.
	* sysdeps/i386/tls.h (tcbhead_t): Add gscope_flag.
	Define macros to implement reference handling of global scope.
	* sysdeps/x86_64/tls.h: Likewise.
	* sysdeps/unix/sysv/linux/libc_pthread_init.c (__libc_pthread_init):
	Initialize GL(dl_wait_lookup_done).

2007-05-17  Ulrich Drepper  <drepper@redhat.com>

	[BZ #4512]
	* pthread_mutex_lock.c: Preserve FUTEX_WAITERS bit when dead owner
	is detected.
	* pthread_mutex_timedlock.c: Likewise.
	* pthread_mutex_trylock.c: Likewise.
	Patch in part by Atsushi Nemoto <anemo@mba.ocn.ne.jp>.

	* Makefile (tests): Add tst-robust9 and tst-robustpi9.
	* tst-robust9.c: New file.
	* tst-robustpi9.c: New file.

	* sysdeps/unix/sysv/linux/sem_wait.c (__new_sem_wait): Remove
	unnecessary extra cancellation test.

2007-05-14  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/sem_wait.S: Remove unnecessary
	extra cancellation test.
	* sysdeps/unix/sysv/linux/x86_64/sem_timedwait.S: Likewise.

2007-05-10  Ulrich Drepper  <drepper@redhat.com>

	* descr.h (struct pthread): Rearrange members to fill hole in
	64-bit layout.

	* sysdeps/unix/sysv/linux/pthread_setaffinity.c
	(__pthread_setaffinity_new): If syscall was successful and
	RESET_VGETCPU_CACHE is defined, use it before returning.
	* sysdeps/unix/sysv/linux/x86_64/pthread_setaffinity.c: New file.

2007-05-10  Jakub Jelinek  <jakub@redhat.com>

	[BZ #4455]
	* tst-align2.c: Include stackinfo.h.
	* tst-getpid1.c: Likewise.

2007-05-02  Carlos O'Donell  <carlos@systemhalted.org>

	[BZ #4455]
	* tst-align2.c (do_test): Add _STACK_GROWS_UP case.
	* tst-getpid1.c (do_test): Likewise.

	[BZ #4456]
	* allocatestack.c (change_stack_perm): Add _STACK_GROWS_UP case.
	(allocate_stack): Likewise.

2007-05-07  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/lowlevelrobustlock.c
	(__lll_robust_lock_wait): Fix race caused by reloading of futex value.
	(__lll_robust_timedlock_wait): Likewise.
	Reported by Alexey Kuznetsov <kuznet@ms2.inr.ac.ru>.

2007-05-06  Mike Frysinger  <vapier@gentoo.org>

	[BZ #4465]
	* tst-cancel-wrappers.sh: Set C["fdatasync"] to 1.
	* tst-cancel4.c (tf_fdatasync): New test.

2007-04-27  Ulrich Drepper  <drepper@redhat.com>

	[BZ #4392]
	* pthread_mutex_trylock.c (__pthread_mutex_trylock): Treat error
	check mutexes like normal mutexes.

	[BZ #4306]
	* sysdeps/unix/sysv/linux/timer_create.c (timer_create):
	Initialize the whole sigevent structure to appease valgrind.

2007-04-25  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/x86_64/tls.h (tcbhead_t): Add vgetcpu_cache.
	* sysdeps/x86_64/tcb-offsets.sym: Add VGETCPU_CACHE_OFFSET.

2007-04-06  Ulrich Drepper  <drepper@redhat.com>

	* tst-locale1.c: Avoid warnings.
	* tst-locale2.c: Likewise.

2007-03-19  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/unix/sysv/linux/powerpc/lowlevellock.h
	(__lll_robust_trylock):	Add MUTEX_HINT_ACQ to lwarx instruction.

2007-03-16  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/pthread/bits/libc-lock.h: Use __extern_inline and
	__extern_always_inline where appropriate.
	* sysdeps/pthread/pthread.h: Likewise.

2007-03-13  Richard Henderson  <rth@redhat.com>

	* sysdeps/unix/sysv/linux/alpha/sysdep-cancel.h (PSEUDO): Use two
	separate cfi regions for the two subsections.

2007-02-25  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/fork.c (__libc_fork): Reset refcntr in
	new thread, don't just decrement it.
	Patch by Suzuki K P <suzuki@in.ibm.com>.

2007-02-21  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/pthread-functions.h: Correct last patch, correct
	PTHFCT_CALL definition.

2007-02-18  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/pthread-functions.h: If PTR_DEMANGLE is not
	available, don't use it.

2007-02-09  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.S
	(__lll_mutex_timedlock_wait): Use correct pointer when we don't
	call into the kernel to delay.

2007-01-18  Ulrich Drepper  <drepper@redhat.com>

	* tst-initializers1.c: We want to test the initializers as seen
	outside of libc, so undefined _LIBC.

	* pthread_join.c (cleanup): Avoid warning.

2007-01-17  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.S
	(__lll_timedwait_tid): Add unwind info.

	* sysdeps/unix/sysv/linux/libc_pthread_init.c: Don't just copy the
	function table, mangle the pointers.
	* sysdeps/pthread/pthread-functions.h: Define PTHFCT_CALL.
	* forward.c: Use PTHFCT_CALL and __libc_pthread_functions_init.
	* sysdeps/pthread/bits/libc-lock.h: When using __libc_pthread_functions
	demangle pointers before use.
	* sysdeps/unix/sysv/linux/s390/jmp-unwind.c: Use PTHFCT_CALL to
	demangle pointer.
	* sysdeps/unix/sysv/linux/jmp-unwind.c: Likewise.
	* sysdeps/pthread/setxid.h: Likewise.

2007-01-12  Ulrich Drepper  <drepper@redhat.com>

	* tst-rwlock7.c: Show some more information in case of correct
	behavior.

2007-01-11  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h
	(lll_futex_timed_wait): Undo part of last change, don't negate
	return value.

2007-01-10  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h: Cleanups.  Define
	FUTEX_CMP_REQUEUE and lll_futex_requeue.

2006-12-28  David S. Miller  <davem@davemloft.net>

	* shlib-versions: Fix sparc64 linux target specification.

2007-01-10  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/sparc/sparc32/sparcv9/pthread_barrier_wait.c:
	Adjust include path for pthread_barrier_wait.c move.

2006-12-21  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/pthread_kill.c (pthread_kill): Make sure
	tid isn't reread from pd->tid in between ESRCH test and the syscall.

2006-12-06  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/s390/s390-32/sysdep-cancel.h (PSEUDO): Handle
	6 argument cancellable syscalls.
	(STM_6, LM_6, LR7_0, LR7_1, LR7_2, LR7_3, LR7_4, LR7_5, LR7_6): Define.
	* sysdeps/unix/sysv/linux/s390/s390-64/sysdep-cancel.h (PSEUDO): Handle
	6 argument cancellable syscalls.
	(STM_6, LM_6, LR7_0, LR7_1, LR7_2, LR7_3, LR7_4, LR7_5, LR7_6): Define.

2006-12-09  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/rtld-lowlevel.h
	(__rtld_mrlock_initialize): Add missing closing parenthesis.

2006-10-30  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/ia64/pthread_spin_unlock.c (pthread_spin_unlock): Use
	__sync_lock_release instead of __sync_lock_release_si.

2006-10-29  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/i386/sysdep-cancel.h (RTLD_SINGLE_THREAD_P):
	Define.
	(SINGLE_THREAD_P): Define to 1 if IS_IN_rtld.
	* sysdeps/unix/sysv/linux/alpha/sysdep-cancel.h: Likewise.
	* sysdeps/unix/sysv/linux/ia64/sysdep-cancel.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-32/sysdep-cancel.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-64/sysdep-cancel.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/sysdep-cancel.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/sysdep-cancel.h: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/sysdep-cancel.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sysdep-cancel.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc64/sysdep-cancel.h: Likewise.
	* sysdeps/unix/sysv/linux/sh/sysdep-cancel.h: Likewise.

2006-10-27  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/pthread_barrier_wait.c: Move to...
	* pthread_barrier_wait.c: ...here.
	* sysdeps/pthread/pthread_cond_broadcast.c: Move to...
	* pthread_cond_broadcast.c: ...here.
	* sysdeps/pthread/pthread_cond_signal.c: Move to...
	* pthread_cond_signal.c: ...here.
	* sysdeps/pthread/pthread_cond_timedwait.c: Move to...
	* pthread_cond_timedwait.c: ...here.
	* sysdeps/pthread/pthread_cond_wait.c: Move to...
	* pthread_cond_wait.c: ...here.
	* sysdeps/pthread/pthread_once.c: Move to...
	* pthread_once.c: ...here.
	* sysdeps/pthread/pthread_rwlock_rdlock.c: Move to...
	* pthread_rwlock_rdlock.c: ...here.
	* sysdeps/pthread/pthread_rwlock_timedrdlock.c: Move to...
	* pthread_rwlock_timedrdlock.c: ...here.
	* sysdeps/pthread/pthread_rwlock_timedwrlock.c: Move to...
	* pthread_rwlock_timedwrlock.c: ...here.
	* sysdeps/pthread/pthread_rwlock_unlock.c: Move to...
	* pthread_rwlock_unlock.c: ...here.
	* sysdeps/pthread/pthread_rwlock_wrlock.c: Move to...
	* pthread_rwlock_wrlock.c: ...here.
	* sysdeps/pthread/pthread_spin_destroy.c: Move to...
	* pthread_spin_destroy.c: ...here.
	* sysdeps/pthread/pthread_spin_init.c: Move to...
	* pthread_spin_init.c: ...here.
	* sysdeps/pthread/pthread_spin_unlock.c: Move to...
	* pthread_spin_unlock.c: ...here.
	* sysdeps/pthread/pthread_getcpuclockid.c: Move to...
	* pthread_getcpuclockid.c: ...here.

	* init.c: USE_TLS support is now always enabled.
	* tst-tls5.h: Likewise.
	* sysdeps/alpha/tls.h: Likewise.
	* sysdeps/i386/tls.h: Likewise.
	* sysdeps/ia64/tls.h: Likewise.
	* sysdeps/powerpc/tls.h: Likewise.
	* sysdeps/s390/tls.h: Likewise.
	* sysdeps/sh/tls.h: Likewise.
	* sysdeps/sparc/tls.h: Likewise.
	* sysdeps/x86_64/tls.h: Likewise.

2006-10-27  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/rtld-lowlevel.h (__rtld_mrlock_lock,
	__rtld_mrlock_change): Update oldval if atomic compare and exchange
	failed.

	* sysdeps/unix/sysv/linux/alpha/sysdep-cancel.h (SINGLE_THREAD_P):
	Define to THREAD_SELF->header.multiple_threads.
	* sysdeps/unix/sysv/linux/ia64/sysdep-cancel.h (SINGLE_THREAD_P):
	Likewise.
	* sysdeps/unix/sysv/linux/i386/sysdep-cancel.h (SINGLE_THREAD_P):
	Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-32/sysdep-cancel.h
	(SINGLE_THREAD_P): Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-64/sysdep-cancel.h
	(SINGLE_THREAD_P): Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/sysdep-cancel.h
	(SINGLE_THREAD_P): Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/sysdep-cancel.h
	(SINGLE_THREAD_P): Likewise.
	* sysdeps/unix/sysv/linux/x86_64/sysdep-cancel.h (SINGLE_THREAD_P):
	Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sysdep-cancel.h
	(SINGLE_THREAD_P): Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc64/sysdep-cancel.h
	(SINGLE_THREAD_P): Likewise.
	* sysdeps/unix/sysv/linux/sh/sysdep-cancel.h (SINGLE_THREAD_P):
	Likewise.

2006-10-26  Jakub Jelinek  <jakub@redhat.com>

	* pthread_attr_setstacksize.c (NEW_VERNUM): Define to GLIBC_2_3_3
	by default rather than 2_3_3.

2006-10-17  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/rtld-lowlevel.h (__rtld_mrlock_lock,
	__rtld_mrlock_unlock, __rtld_mrlock_change, __rtld_mrlock_done): Use
	atomic_* instead of catomic_* macros.

2006-10-12  Ulrich Drepper  <drepper@redhat.com>

	[BZ #3285]
	* sysdeps/unix/sysv/linux/bits/local_lim.h: Add SEM_VALUE_MAX.
	* sysdeps/unix/sysv/linux/powerpc/bits/local_lim.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/bits/local_lim.h: Likewise.
	* sysdeps/unix/sysv/linux/alpha/bits/local_lim.h: Likewise.
	* sysdeps/unix/sysv/linux/ia64/bits/local_lim.h: Likewise.
	* sysdeps/unix/sysv/linux/i386/bits/semaphore.h: Remove SEM_VALUE_MAX.
	* sysdeps/unix/sysv/linux/powerpc/bits/semaphore.h: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/bits/semaphore.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/bits/semaphore.h: Likewise.
	* sysdeps/unix/sysv/linux/alpha/bits/semaphore.h: Likewise.
	* sysdeps/unix/sysv/linux/sh/bits/semaphore.h: Likewise.
	* sysdeps/unix/sysv/linux/ia64/bits/semaphore.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/bits/semaphore.h: Likewise.

2006-10-11  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/i386/sysdep-cancel.h: Add support for
	cancelable syscalls with six parameters.

	* sysdeps/unix/sysv/linux/rtld-lowlevel.h: Use catomic_*
	operations instead of atomic_*.

2006-10-09  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/rtld-lowlevel.h: New file..

2006-10-07  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/powerpc/bits/local_lim.h: New file.
	* sysdeps/unix/sysv/linux/powerpc/pthread_attr_setstack.c: New file.
	* sysdeps/unix/sysv/linux/powerpc/pthread_attr_setstacksize.c:
	New file.
	* pthread_attr_setstack.c: Allow overwriting the version number of the
	new symbol.
	* pthread_attr_setstacksize.c: Likewise.
	(__old_pthread_attr_setstacksize): If STACKSIZE_ADJUST is defined use
	it.
	* sysdeps/unix/sysv/linux/powerpc/Versions (libpthread): Add
	pthread_attr_setstack and pthread_attr_setstacksize to GLIBC_2.6.

2006-09-24  Ulrich Drepper  <drepper@redhat.com>

	[BZ #3251]
	* descr.h (ENQUEUE_MUTEX_BOTH): Add cast to avoid warning.
	Patch by Petr Baudiš.

2006-09-18  Jakub Jelinek  <jakub@redhat.com>

	* tst-kill4.c (do_test): Explicitly set tf thread's stack size.

	* tst-cancel2.c (tf): Loop as long as something was written.

2006-09-12  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/unix/sysv/linux/sh/pthread_cond_broadcast.S: For PI
	mutexes wake all mutexes.
	* sysdeps/unix/sysv/linux/sh/pthread_cond_wait.S: Don't increment
	WAKEUP_SEQ if this would increase the value beyond TOTAL_SEQ.
	* sysdeps/unix/sysv/linux/sh/pthread_cond_timedwait.S: Likewise.

2006-09-12  Ulrich Drepper  <drepper@redhat.com>

	* tst-cond22.c (tf): Slight changes to the pthread_cond_wait use
	to guarantee the thread is always canceled.

2006-09-08  Jakub Jelinek  <jakub@redhat.com>

	* tst-cond22.c: Include pthread.h instead of pthreadP.h.
	Include stdlib.h.
	* sysdeps/pthread/pthread_cond_wait.c (__condvar_cleanup): Only
	increase FUTEX if increasing WAKEUP_SEQ.  Fix comment typo.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_wait.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_timedwait.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S: Likewise.

2006-09-08  Ulrich Drepper  <drepper@redhat.com>

	[BZ #3123]
	* sysdeps/pthread/pthread_cond_wait.c (__condvar_cleanup): Don't
	increment WAKEUP_SEQ if this would increase the value beyond TOTAL_SEQ.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_wait.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_timedwait.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_wait.S: Likewise.
	* Makefile (tests): Add tst-cond22.
	* tst-cond22.c: New file.

2006-09-05  Ulrich Drepper  <drepper@redhat.com>

	[BZ #3124]
	* descr.h (struct pthread): Add parent_cancelhandling.
	* sysdeps/pthread/createthread.c (create_thread): Pass parent
	cancelhandling value to child.
	* pthread_create.c (start_thread): If parent thread was canceled
	reset the SIGCANCEL mask.
	* Makefile (tests): Add tst-cancel25.
	* tst-cancel25.c: New file.

2006-09-05  Jakub Jelinek  <jakub@redhat.com>
	    Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/gai_misc.h (GAI_MISC_NOTIFY): Don't decrement
	counterp if it is already zero.
	* sysdeps/pthread/aio_misc.h (AIO_MISC_NOTIFY): Likewise..

2006-03-04  Jakub Jelinek  <jakub@redhat.com>
	    Roland McGrath  <roland@redhat.com>

	* sysdeps/unix/sysv/linux/i386/lowlevellock.h
	(LLL_STUB_UNWIND_INFO_START, LLL_STUB_UNWIND_INFO_END,
	LLL_STUB_UNWIND_INFO_3, LLL_STUB_UNWIND_INFO_4): Define.
	(lll_mutex_lock, lll_robust_mutex_lock, lll_mutex_cond_lock,
	lll_robust_mutex_cond_lock, lll_mutex_timedlock,
	lll_robust_mutex_timedlock, lll_mutex_unlock,
	lll_robust_mutex_unlock, lll_lock, lll_unlock): Use them.
	Add _L_*_ symbols around the subsection.
	* sysdeps/unix/sysv/linux/i386/i486/lowlevellock.S: Add unwind info.
	* sysdeps/unix/sysv/linux/i386/i486/lowlevelrobustlock.S: Likewise.

2006-03-03  Jakub Jelinek  <jakub@redhat.com>
	    Roland McGrath  <roland@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h
	(LLL_STUB_UNWIND_INFO_START, LLL_STUB_UNWIND_INFO_END,
	LLL_STUB_UNWIND_INFO_5, LLL_STUB_UNWIND_INFO_6): Define.
	(lll_mutex_lock, lll_robust_mutex_lock, lll_mutex_cond_lock,
	lll_robust_mutex_cond_lock, lll_mutex_timedlock,
	lll_robust_mutex_timedlock, lll_mutex_unlock,
	lll_robust_mutex_unlock, lll_lock, lll_unlock): Use them.
	Add _L_*_ symbols around the subsection.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.S: Add unwind info.
	* sysdeps/unix/sysv/linux/x86_64/lowlevelrobustlock.S: Likewise.

2006-08-31  Ulrich Drepper  <drepper@redhat.com>

	* pthread_rwlock_trywrlock.c (__pthread_rwlock_trywrlock): Undo last
	change because it can disturb too much existing code.  If real hard
	reader preference is needed we'll introduce another type.
	* sysdeps/pthread/pthread_rwlock_timedwrlock.c
	(pthread_rwlock_timedwrlock): Likewise.
	* sysdeps/pthread/pthread_rwlock_wrlock.c (__pthread_rwlock_wrlock):
	Likewise.

2006-08-30  Ulrich Drepper  <drepper@redhat.com>

	* pthread_rwlock_trywrlock.c (__pthread_rwlock_trywrlock): Respect
	reader preference.
	* sysdeps/pthread/pthread_rwlock_timedwrlock.c
	(pthread_rwlock_timedwrlock): Likewise.
	* sysdeps/pthread/pthread_rwlock_wrlock.c (__pthread_rwlock_wrlock):
	Likewise.

2006-08-25  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/libc_pthread_init.c (freeres_libpthread):
	Only define ifdef SHARED.

2006-08-23  Ulrich Drepper  <drepper@redhat.com>

	* allocatestack.c (queue_stack): Move freeing of surplus stacks to...
	(free_stacks): ...here.
	(__free_stack_cache): New function.
	* pthreadP.h: Declare __free_stack_cache.
	* sysdeps/pthread/pthread-functions.h (pthread_functions): Add
	ptr_freeres.
	* init.c (pthread_functions): Initialize ptr_freeres.
	* sysdeps/unix/sysv/linux/libc_pthread_init.c (freeres_libptread):
	New freeres function.

2006-07-30  Joseph S. Myers  <joseph@codesourcery.com>

	[BZ #3018]
	* Makefile (extra-objs): Add modules to extra-test-objs instead.

2006-08-20  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/bits/posix_opt.h: Define
	_XOPEN_REALTIME_THREADS.

2006-08-15  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/clock_settime.c (INTERNAL_VSYSCALL): Use
	HAVE_CLOCK_GETRES_VSYSCALL as guard macro rather than
	HAVE_CLOCK_GETTIME_VSYSCALL.
	(maybe_syscall_settime_cpu): Use plain INTERNAL_VSYSCALL here.

2006-08-14  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/bits/posix_opt.h
	(_POSIX_THREAD_PRIO_PROTECT): Define to 200112L.
	* descr.h (struct priority_protection_data): New type.
	(struct pthread): Add tpp field.
	* pthreadP.h (PTHREAD_MUTEX_PP_NORMAL_NP,
	PTHREAD_MUTEX_PP_RECURSIVE_NP, PTHREAD_MUTEX_PP_ERRORCHECK_NP,
	PTHREAD_MUTEX_PP_ADAPTIVE_NP): New enum values.
	* pthread_mutex_init.c (__pthread_mutex_init): Handle non-robust
	TPP mutexes.
	* pthread_mutex_lock.c (__pthread_mutex_lock): Handle TPP mutexes.
	* pthread_mutex_trylock.c (__pthread_mutex_trylock): Likewise.
	* pthread_mutex_timedlock.c (pthread_mutex_timedlock): Likewise.
	* pthread_mutex_unlock.c (__pthread_mutex_unlock_usercnt): Likewise.
	* tpp.c: New file.
	* pthread_setschedparam.c (__pthread_setschedparam): Handle priority
	boosted by TPP.
	* pthread_setschedprio.c (pthread_setschedprio): Likewise.
	* pthread_mutexattr_getprioceiling.c
	(pthread_mutexattr_getprioceiling): If ceiling is 0, ensure it is
	in the SCHED_FIFO priority range.
	* pthread_mutexattr_setprioceiling.c
	(pthread_mutexattr_setprioceiling): Fix prioceiling validation.
	* pthread_mutex_getprioceiling.c (pthread_mutex_getprioceiling): Fail
	if mutex is not TPP.  Ceiling is now in __data.__lock.
	* pthread_mutex_setprioceiling.c: Include stdbool.h.
	(pthread_mutex_setprioceiling): Fix prioceiling validation.  Ceiling
	is now in __data.__lock.  Add locking.
	* pthread_create.c (__free_tcb): Free pd->tpp structure.
	* Makefile (libpthread-routines): Add tpp.
	(xtests): Add tst-mutexpp1, tst-mutexpp6 and tst-mutexpp10.
	* tst-tpp.h: New file.
	* tst-mutexpp1.c: New file.
	* tst-mutexpp6.c: New file.
	* tst-mutexpp10.c: New file.
	* tst-mutex1.c (TEST_FUNCTION): Don't redefine if already defined.
	* tst-mutex6.c (TEST_FUNCTION): Likewise.

2006-08-12  Ulrich Drepper  <drepper@redhat.com>

	[BZ #2843]
	* pthread_join.c (pthread_join): Account for self being canceled
	when checking for deadlocks.
	* tst-join5.c: Cleanups.  Allow to be used in tst-join6.
	(tf1): Don't print anything after pthread_join returns, this would be
	another cancellation point.
	(tf2): Likewise.
	* tst-join6.c: New file.
	* Makefile (tests): Add tst-join6.

2006-08-03  Ulrich Drepper  <drepper@redhat.com>

	[BZ #2892]
	* pthread_setspecific.c (__pthread_setspecific): Check
	out-of-range index before checking for unused key.

	* sysdeps/pthread/gai_misc.h: New file.

2006-08-01  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/i386/smp.h: New file.  Old Linux-specific
	file.  Don't use sysctl.
	* sysdeps/unix/sysv/linux/smp.h: Always assume SMP.  Archs can
	overwrite the file if this is likely not true.

2006-07-31  Daniel Jacobowitz  <dan@codesourcery.com>

	* allocatestack.c (__reclaim_stacks): Reset the PID on cached stacks.
	* Makefile (tests): Add tst-getpid3.
	* tst-getpid3.c: New file.

2006-07-30  Roland McGrath  <roland@redhat.com>

	* Makefile (libpthread-routines): Add ptw-sigsuspend.

	* sysdeps/unix/sysv/linux/i386/not-cancel.h
	(pause_not_cancel): New macro.
	(nanosleep_not_cancel): New macro.
	(sigsuspend_not_cancel): New macro.
	* pthread_mutex_timedlock.c (pthread_mutex_timedlock): Use
	nanosleep_not_cancel macro from <not-cancel.h>.
	* pthread_mutex_lock.c (__pthread_mutex_lock): Use pause_not_cancel
	macro from <not-cancel.h>.

2006-07-28  Ulrich Drepper  <drepper@redhat.com>
	    Jakub Jelinek  <jakub@redhat.com>

	* descr.h: Change ENQUEUE_MUTEX and DEQUEUE_MUTEX for bit 0
	notification of PI mutex.  Add ENQUEUE_MUTEX_PI.
	* pthreadP.h: Define PTHREAD_MUTEX_PI_* macros for PI mutex types.
	* pthread_mutex_setprioceilining.c: Adjust for mutex type name change.
	* pthread_mutex_init.c: Add support for priority inheritance mutex.
	* pthread_mutex_lock.c: Likewise.
	* pthread_mutex_timedlock.c: Likewise.
	* pthread_mutex_trylock.c: Likewise.
	* pthread_mutex_unlock.c: Likewise.
	* sysdeps/pthread/pthread_cond_broadcast.c: For PI mutexes wake
	all mutexes.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_cond_broadcast.c: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/pthread_cond_broadcast.c: Likewise.
	* sysdeps/unix/sysv/linux/pthread-pi-defines.sym: New file.
	* sysdeps/unix/sysv/linux/Makefile (gen-as-const-header): Add
	pthread-pi-defines.sym.
	* sysdeps/unix/sysv/linux/i386/lowlevellock.h: Define FUTEX_LOCK_PI,
	FUTEX_UNLOCK_PI, and FUTEX_TRYLOCK_PI.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/alpha/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/ia64/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/sh/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/bits/posix_opt.h: Define
	_POSIX_THREAD_PRIO_INHERIT to 200112L.
	* tst-mutex1.c: Adjust to allow use in PI mutex test.
	* tst-mutex2.c: Likewise.
	* tst-mutex3.c: Likewise.
	* tst-mutex4.c: Likewise.
	* tst-mutex5.c: Likewise.
	* tst-mutex6.c: Likewise.
	* tst-mutex7.c: Likewise.
	* tst-mutex7a.c: Likewise.
	* tst-mutex8.c: Likewise.
	* tst-mutex9.c: Likewise.
	* tst-robust1.c: Likewise.
	* tst-robust7.c: Likewise.
	* tst-robust8.c: Likewise.
	* tst-mutexpi1.c: New file.
	* tst-mutexpi2.c: New file.
	* tst-mutexpi3.c: New file.
	* tst-mutexpi4.c: New file.
	* tst-mutexpi5.c: New file.
	* tst-mutexpi6.c: New file.
	* tst-mutexpi7.c: New file.
	* tst-mutexpi7a.c: New file.
	* tst-mutexpi8.c: New file.
	* tst-mutexpi9.c: New file.
	* tst-robust1.c: New file.
	* tst-robust2.c: New file.
	* tst-robust3.c: New file.
	* tst-robust4.c: New file.
	* tst-robust5.c: New file.
	* tst-robust6.c: New file.
	* tst-robust7.c: New file.
	* tst-robust8.c: New file.
	* Makefile (tests): Add the new tests.

	* pthread_create.c (start_thread): Add some casts to avoid warnings.
	* pthread_mutex_destroy.c: Remove unneeded label.

2006-07-01  Ulrich Drepper  <drepper@redhat.com>

	* pthread_mutex_init.c (__pthread_mutex_init): Move some
	computations to compile time.

2006-06-04  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/pthread.h: Add pthread_equal inline version.

2006-05-15  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/fork.h: Mark __fork_handlers as hidden.

2006-05-11  Ulrich Drepper  <drepper@redhat.com>

	* pthread_key_create.c (__pthread_key_create): Do away with
	__pthread_keys_lock.

	* sysdeps/unix/sysv/linux/pthread_setaffinity.c
	(__kernel_cpumask_size): Mark as hidden.
	* sysdeps/unix/sysv/linux/pthread_attr_setaffinity.c: Likewise.

	* sem_open.c (__sem_mappings_lock): Mark as hidden.
	* semaphoreP.h (__sem_mappings_lock): Likewise.

2006-05-10  Ulrich Drepper  <drepper@redhat.com>

	* pthread_atfork.c: Mark __dso_handle as hidden.

2006-05-09  Ulrich Drepper  <drepper@redhat.com>

	[BZ #2644]
	* sysdeps/pthread/unwind-forcedunwind.c: Different solution for
	the reload problem.  Change the one path in pthread_cancel_init
	which causes the problem.  Force gcc to reload.  Simplify callers.
	* sysdeps/unix/sysv/linux/ia64/unwind-forcedunwind.c
	(_Unwind_GetBSP): Undo last patch.

2006-05-07  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/ia64/unwind-forcedunwind.c: Make sure the
	function pointer is reloaded after pthread_cancel_init calls.

	[BZ #2644]
	* sysdeps/pthread/unwind-forcedunwind.c: Make sure functions
	pointers are reloaded after pthread_cancel_init calls.

2006-05-01  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/allocalim.h (__libc_use_alloca): Mark with
	__always_inline.

2006-04-27  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/timer_routines.c (timer_helper_thread):
	Allocate new object which is passed to timer_sigev_thread so that
	the timer can be deleted before the new thread is scheduled.

2006-04-26  Roland McGrath  <roland@redhat.com>

	* sysdeps/x86_64/tls.h: Include <asm/prctl.h> inside [! __ASSEMBLER__].

2006-04-08  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/i386/lowlevellock.h: Remove branch predicion
	suffix for conditional jumps.
	* sysdeps/unix/sysv/linux/i386/i486/sem_trywait.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/lowlevellock.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/libc-lowlevellock.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/pthread_barrier_wait.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/sem_timedwait.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/sem_wait.S: Likewise.

	* init.c (sigcancel_handler): Compare with correct PID even if the
	thread is in the middle of a fork call.
	(sighandler_setxid): Likewise.
	Reported by Suzuki K P <suzuki@in.ibm.com> .

2006-04-07  Jakub Jelinek  <jakub@redhat.com>

	* pthreadP.h (FUTEX_TID_MASK): Sync with kernel.

2006-04-06  Ulrich Drepper  <drepper@redhat.com>

	* pthread_getattr_np.c (pthread_getattr_np): Close fp if getrlimit
	fails [Coverity CID 105].

2006-04-05  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/pthread.h: Add nonnull attributes.

2006-04-03  Steven Munroe  <sjmunroe@us.ibm.com>

	[BZ #2505]
	* sysdeps/unix/sysv/linux/powerpc/lowlevellock.h [_ARCH_PWR4]:
	Define __lll_rel_instr using lwsync.

2006-03-27  Ulrich Drepper  <drepper@redhat.com>

	* allocatestack.c (allocate_stack): Always initialize robust_head.
	* descr.h: Define struct robust_list_head.
	(struct pthread): Use robust_list_head in robust mutex list definition.
	Adjust ENQUEUE_MUTEX and DEQUEUE_MUTEX.
	* init.c [!__ASSUME_SET_ROBUST_LIST] (__set_robust_list_avail): Define.
	(__pthread_initialize_minimal_internal): Register robust_list with
	the kernel.
	* pthreadP.h: Remove PRIVATE_ from PTHREAD_MUTEX_ROBUST_* names.
	Declare __set_robust_list_avail.
	* pthread_create.c (start_thread): Register robust_list of new thread.
	[!__ASSUME_SET_ROBUST_LIST]: If robust_list is not empty wake up
	waiters.
	* pthread_mutex_destroy.c: For robust mutexes don't look at the
	number of users, it's unreliable.
	* pthread_mutex_init.c: Allow use of pshared robust mutexes if
	set_robust_list syscall is available.
	* pthread_mutex_consistent.c: Adjust for PTHREAD_MUTEX_ROBUST_* rename.
	* pthread_mutex_lock.c: Simplify robust mutex code a bit.
	Set robust_head.list_op_pending before trying to lock a robust mutex.
	* pthread_mutex_timedlock.c: Likewise.
	* pthread_mutex_trylock.c: Likewise.
	* pthread_mutex_unlock.c: Likewise for unlocking.
	* Makefile (tests): Add tst-robust8.
	* tst-robust8.c: New file.

2006-03-08  Andreas Schwab  <schwab@suse.de>

	* sysdeps/unix/sysv/linux/ia64/dl-sysdep.h
	(DL_SYSINFO_IMPLEMENTATION): Add missing newline.

2006-03-05  Roland McGrath  <roland@redhat.com>

	* configure (libc_add_on): Disable add-on when $add_ons_automatic = yes
	and $config_os doesn't match *linux*.

2006-03-05  David S. Miller  <davem@sunset.davemloft.net>

	* sysdeps/unix/sysv/linux/sparc/sparc32/pt-vfork.S:
	Use __syscall_error.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sysdep-cancel.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/vfork.S: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc64/pt-vfork.S: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc64/sysdep-cancel.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc64/vfork.S: Likewise.
	* sysdeps/unix/sysv/linux/sparc/Makefile: New file.

2006-03-02  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/aio_misc.h: Various cleanups.

2006-03-01  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/lowlevelrobustlock.S
	(__lll_robust_lock_wait): Also set FUTEX_WAITERS bit if we got the
	mutex.
	(__lll_robust_timedlock_wait): Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/lowlevelrobustlock.S
	(__lll_robust_lock_wait): Likewise.
	(__lll_robust_timedlock_wait): Likewise.
	* sysdeps/unix/sysv/linux/lowlevelrobustlock.c
	(__lll_robust_lock_wait): Likewise.
	(__lll_robust_timedlock_wait): Likewise.

2006-03-01  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/sparc/lowlevellock.h (lll_robust_mutex_dead,
	lll_robust_mutex_trylock, lll_robust_mutex_lock,
	lll_robust_mutex_cond_lock, lll_robust_mutex_timedlock,
	lll_robust_mutex_unlock): Define.
	(__lll_robust_lock_wait, __lll_robust_timedlock_wait): New prototypes.

2006-02-28  H.J. Lu  <hongjiu.lu@intel.com>

	* sysdeps/unix/sysv/linux/ia64/clone2.S: Include <clone2.S>
	instead of <clone.S>.

2006-02-27  Jakub Jelinek  <jakub@redhat.com>

	* Makefile (libpthread-routines): Add
	pthread_mutexattr_[sg]etprotocol, pthread_mutexattr_[sg]etprioceiling
	and pthread_mutex_[sg]etprioceiling.
	* Versions (GLIBC_2.4): Export pthread_mutexattr_getprotocol,
	pthread_mutexattr_setprotocol, pthread_mutexattr_getprioceiling,
	pthread_mutexattr_setprioceiling, pthread_mutex_getprioceiling and
	pthread_mutex_setprioceiling.
	* sysdeps/pthread/pthread.h (PTHREAD_PRIO_NONE, PTHREAD_PRIO_INHERIT,
	PTHREAD_PRIO_PROTECT): New enum values.
	(pthread_mutexattr_getprotocol, pthread_mutexattr_setprotocol,
	pthread_mutexattr_getprioceiling, pthread_mutexattr_setprioceiling,
	pthread_mutex_getprioceiling, pthread_mutex_setprioceiling): New
	prototypes.
	* pthreadP.h (PTHREAD_MUTEX_PRIO_INHERIT_PRIVATE_NP,
	PTHREAD_MUTEX_PRIO_PROTECT_PRIVATE_NP): New enum values.
	(PTHREAD_MUTEX_PRIO_CEILING_SHIFT, PTHREAD_MUTEX_PRIO_CEILING_MASK):
	Define.
	(PTHREAD_MUTEXATTR_PROTOCOL_SHIFT, PTHREAD_MUTEXATTR_PROTOCOL_MASK,
	PTHREAD_MUTEXATTR_PRIO_CEILING_SHIFT,
	PTHREAD_MUTEXATTR_PRIO_CEILING_MASK): Define.
	(PTHREAD_MUTEXATTR_FLAG_BITS): Or in PTHREAD_MUTEXATTR_PROTOCOL_MASK
	and PTHREAD_MUTEXATTR_PRIO_CEILING_MASK.
	* pthread_mutex_init.c (__pthread_mutex_init): For the time being
	return ENOTSUP for PTHREAD_PRIO_INHERIT or PTHREAD_PRIO_PROTECT
	protocol mutexes.
	* pthread_mutex_getprioceiling.c: New file.
	* pthread_mutex_setprioceiling.c: New file.
	* pthread_mutexattr_getprioceiling.c: New file.
	* pthread_mutexattr_setprioceiling.c: New file.
	* pthread_mutexattr_getprotocol.c: New file.
	* pthread_mutexattr_setprotocol.c: New file.

2006-02-27  Daniel Jacobowitz  <dan@codesourcery.com>

	* sysdeps/unix/sysv/linux/aio_misc.h: Include <limits.h>.

2006-02-27  Roland McGrath  <roland@redhat.com>

	* sysdeps/pthread/Subdirs: List nptl here too.
	* configure (libc_add_on_canonical): New variable.

	* sysdeps/unix/sysv/linux/sh/sh4/lowlevellock.h: Use #include_next.

	* sysdeps/unix/sysv/linux/sleep.c: Use #include_next after #include of
	self to get main source tree's file.
	* sysdeps/unix/sysv/linux/alpha/clone.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/clone.S: Likewise.
	* sysdeps/unix/sysv/linux/i386/vfork.S: Likewise.
	* sysdeps/unix/sysv/linux/ia64/clone2.S: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc32/clone.S: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/clone.S: Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-32/clone.S: Likewise.
	* sysdeps/unix/sysv/linux/s390/s390-64/clone.S: Likewise.
	* sysdeps/unix/sysv/linux/sh/clone.S: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc32/clone.S: Likewise.
	* sysdeps/unix/sysv/linux/sparc/sparc64/clone.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/clone.S: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/vfork.S: Likewise.

	* Makefile: Use $(sysdirs) in vpath directive.

	* sysdeps/pthread/Makefile (CFLAGS-libc-start.c): Variable removed.
	(CPPFLAGS-timer_routines.c): Likewise.

	* Makeconfig (includes): Variable removed.

2006-02-26  Roland McGrath  <roland@redhat.com>

	* sysdeps/generic/pt-raise.c: Moved to ...
	* pt-raise.c: ... here.
	* sysdeps/generic/lowlevellock.h: Moved to ...
	* lowlevellock.h: ... here.

2006-02-23  Roland McGrath  <roland@redhat.com>

	* descr.h (struct pthread): Add final member `end_padding'.
	(PTHREAD_STRUCT_END_PADDING): Use it.

2006-02-20  Roland McGrath  <roland@redhat.com>

	* sysdeps/mips: Directory removed, saved in ports repository.
	* sysdeps/unix/sysv/linux/mips: Likewise.

2006-02-18  Ulrich Drepper  <drepper@redhat.com>

	* tst-robust1.c: Add second mutex to check that the mutex list is
	handled correctly.

2006-02-17  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/alpha/lowlevellock.h (lll_robust_mutex_dead,
	lll_robust_mutex_trylock, lll_robust_mutex_lock,
	lll_robust_mutex_cond_lock, lll_robust_mutex_timedlock,
	lll_robust_mutex_unlock): New macros.
	(__lll_robust_lock_wait, __lll_robust_timedlock_wait): New prototypes.
	* sysdeps/unix/sysv/linux/s390/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/ia64/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/lowlevelrobustlock.c: New file.

2006-02-17  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/unix/sysv/linux/sh/lowlevellock.h: Add lll_robust_mutex_*
	definitions.
	* sysdeps/unix/sysv/linux/sh/lowlevelrobustlock.S: New file.

2006-02-17  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h
	(lll_robust_mutex_unlock): Avoid unnecessary wakeups.
	* sysdeps/unix/sysv/linux/i386/lowlevellock.h
	(lll_robust_mutex_unlock): Likewise.

2006-02-13  Jakub Jelinek  <jakub@redhat.com>

	* descr.h [!__PTHREAD_MUTEX_HAVE_PREV] (DEQUEUE_MUTEX):
	Set robust_list.__next rather than robust_list.
	* sysdeps/unix/sysv/linux/alpha/bits/pthreadtypes.h
	(__pthread_list_t): New typedef.
	(pthread_mutex_t): Replace __next and __prev fields with __list.
	* sysdeps/unix/sysv/linux/ia64/bits/pthreadtypes.h
	(__pthread_list_t): New typedef.
	(pthread_mutex_t): Replace __next and __prev fields with __list.
	* sysdeps/unix/sysv/linux/powerpc/bits/pthreadtypes.h
	(__pthread_list_t, __pthread_slist_t): New typedefs.
	(pthread_mutex_t): Replace __next and __prev fields with __list.
	* sysdeps/unix/sysv/linux/s390/bits/pthreadtypes.h
	(__pthread_list_t, __pthread_slist_t): New typedefs.
	(pthread_mutex_t): Replace __next and __prev fields with __list.
	* sysdeps/unix/sysv/linux/sparc/bits/pthreadtypes.h
	(__pthread_list_t, __pthread_slist_t): New typedefs.
	(pthread_mutex_t): Replace __next and __prev fields with __list.
	* sysdeps/unix/sysv/linux/sh/bits/pthreadtypes.h
	(__pthread_slist_t): New typedef.
	(pthread_mutex_t): Replace __next field with __list.

2006-02-15  Ulrich Drepper  <drepper@redhat.com>

	* pthreadP.h: Define PTHREAD_MUTEX_INCONSISTENT instead of
	PTHREAD_MUTEX_OWNERDEAD.
	(PTHREAD_MUTEX_ROBUST_PRIVATE_NP): Define as 16, not 256.
	Define FUTEX_WAITERS, FUTEX_OWNER_DIED, FUTEX_TID_MASK.
	* Makefile (libpthread-routines): Add lowlevelrobustlock.
	* pthread_create.c (start_thread): Very much simplify robust_list loop.
	* pthread_mutex_consistent.c: Inconsistent mutex have __owner now set
	to PTHREAD_MUTEX_INCONSISTENT.
	* pthread_mutex_destroy.c: Allow destroying of inconsistent mutexes.
	* pthread_mutex_lock.c: Reimplement robust mutex handling.
	* pthread_mutex_trylock.c: Likewise.
	* pthread_mutex_timedlock.c: Likewise.
	* pthread_mutex_unlock.c: Likewise.
	* sysdeps/unix/sysv/linux/pthread_mutex_cond_lock.c: Likewise.
	* sysdeps/unix/sysv/linux/Makefile (gen-as-const-headers): Add
	lowlevelrobustlock.sym.
	* sysdeps/unix/sysv/linux/lowlevelrobustlock.sym: New file.
	* sysdeps/unix/sysv/linux/i386/lowlevellock.h: Add lll_robust_mutex_*
	definitions.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h: Likewise.
	* sysdeps/unix/sysv/linux/i386/i486/lowlevelrobustlock.S: New file.
	* sysdeps/unix/sysv/linux/i386/i586/lowlevelrobustlock.S: New file.
	* sysdeps/unix/sysv/linux/i386/i686/lowlevelrobustlock.S: New file.
	* sysdeps/unix/sysv/linux/x86_64/lowlevelrobustlock.S: New file.

2006-02-12  Ulrich Drepper  <drepper@redhat.com>

	* allocatestack.c (allocate_stack): Initialize robust_list.
	* init.c (__pthread_initialize_minimal_internal): Likewise.
	* descr.h (struct xid_command): Pretty printing.
	(struct pthread): Use __pthread_list_t or __pthread_slist_t for
	robust_list.  Adjust macros.
	* pthread_create.c (start_thread): Adjust robust_list handling.
	* phtread_mutex_unlock.c: Don't allow unlocking from any thread
	but the owner for all robust mutex types.
	* sysdeps/unix/sysv/linux/i386/bits/pthreadtypes.h: Define
	__pthread_list_t and __pthread_slist_t.  Use them in pthread_mutex_t.
	* sysdeps/unix/sysv/linux/x86_64/bits/pthreadtypes.h: Likewise.
	* sysdeps/pthread/pthread.h: Adjust mutex initializers.

	* sysdeps/unix/sysv/linux/i386/not-cancel.h: Define openat_not_cancel,
	openat_not_cancel_3, openat64_not_cancel, and openat64_not_cancel_3.

2006-02-08  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/i386/lowlevellock.h (lll_futex_wait,
	lll_futex_timedwait, lll_wait_tid): Add "memory" clobber.

2006-01-20  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/unix/sysv/linux/sh/lowlevellock.h (lll_futex_wait):
	Return status.
	(lll_futex_timed_wait): Define.

2006-01-19  Ulrich Drepper  <drepper@redhat.com>

	* tst-cancel4.c: Test ppoll.

2006-01-18  Andreas Jaeger  <aj@suse.de>

	[BZ #2167]
	* sysdeps/unix/sysv/linux/mips/bits/pthreadtypes.h
	(pthread_mutex_t): Follow changes for other archs.  Based on patch
	by Jim Gifford <patches@jg555.com>.

2006-01-13  Richard Henderson  <rth@redhat.com>

	* sysdeps/alpha/tls.h (tcbhead_t): Rename member to __private.

2006-01-10  Roland McGrath  <roland@redhat.com>

	* sysdeps/alpha/jmpbuf-unwind.h: File moved to main source tree.
	* sysdeps/i386/jmpbuf-unwind.h: Likewise.
	* sysdeps/mips/jmpbuf-unwind.h: Likewise.
	* sysdeps/powerpc/jmpbuf-unwind.h: Likewise.
	* sysdeps/s390/jmpbuf-unwind.h: Likewise.
	* sysdeps/sh/jmpbuf-unwind.h: Likewise.
	* sysdeps/sparc/sparc32/jmpbuf-unwind.h: Likewise.
	* sysdeps/sparc/sparc64/jmpbuf-unwind.h: Likewise.
	* sysdeps/x86_64/jmpbuf-unwind.h: Likewise.
	* sysdeps/unix/sysv/linux/ia64/jmpbuf-unwind.h: Likewise.

2006-01-09  Roland McGrath  <roland@redhat.com>

	* tst-initializers1-c89.c: New file.
	* tst-initializers1-c99.c: New file.
	* tst-initializers1-gnu89.c: New file.
	* tst-initializers1-gnu99.c: New file.
	* Makefile (tests): Add them.
	(CFLAGS-tst-initializers1-c89.c): New variable.
	(CFLAGS-tst-initializers1-c99.c): New variable.
	(CFLAGS-tst-initializers1-gnu89.c): New variable.
	(CFLAGS-tst-initializers1-gnu99.c): New variable.

	* sysdeps/unix/sysv/linux/i386/bits/pthreadtypes.h (pthread_mutex_t):
	Use __extension__ on anonymous union definition.
	* sysdeps/unix/sysv/linux/x86_64/bits/pthreadtypes.h: Likewise.
	* sysdeps/unix/sysv/linux/sh/bits/pthreadtypes.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/bits/pthreadtypes.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/bits/pthreadtypes.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/bits/pthreadtypes.h: Likewise.

2006-01-08  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/alpha/bits/pthreadtypes.h (pthread_mutex_t):
	Don't give the union a name because it changes the mangled name.
	Instead name the struct for __data.
	* sysdeps/unix/sysv/linux/sh/bits/pthreadtypes.h (pthread_mutex_t):
	Likewise.
	* sysdeps/unix/sysv/linux/sparc/bits/pthreadtypes.h (pthread_mutex_t):
	Likewise.

2006-01-09  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/sparc/sparc64/jmpbuf-unwind.h (_JMPBUF_UNWINDS_ADJ): Add
	stack bias to mc_ftp field.

2006-01-07  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/aio_misc.h (AIO_MISC_WAIT): Work around gcc
	being too clever and reloading the futex value where it shouldn't.

2006-01-06  Ulrich Drepper  <drepper@redhat.com>

	* descr.h [!__PTHREAD_MUTEX_HAVE_PREV] (DEQUEUE_MUTEX): Use
	correct type.

2006-01-06  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/sparc/sparc64/sysdep-cancel.h (PSEUDO):
	Add cfi directives.

2006-01-06  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/ia64/tls.h (tcbhead_t): Rename private member to __private.
	* sysdeps/ia64/tcb-offsets.sym: Adjust for private->__private
	rename in tcbhead_t.

	* sysdeps/unix/sysv/linux/i386/bits/pthreadtypes.h (pthread_mutex_t):
	Don't give the union a name because it changes the mangled name.
	Instead name the struct for __data.
	* sysdeps/unix/sysv/linux/ia64/bits/pthreadtypes.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/bits/pthreadtypes.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/bits/pthreadtypes.h: Likewise.
	* sysdeps/unix/sysv/linux/x86_64/bits/pthreadtypes.h: Likewise.
	* pthread_create.c (start_thread): Adjust robust mutex free loop.
	* descr.h (ENQUEUE_MUTEX, DEQUEUE_MUTEX): Adjust.

2006-01-05  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/i386/lowlevellock.h (lll_futex_wait):
	Return status.
	(lll_futex_timed_wait): Define.
	* sysdeps/unix/sysv/linux/x86_64/lowlevellock.h: Likewise.
	* sysdeps/pthread/aio_misc.h: New file.

2006-01-03  Joseph S. Myers  <joseph@codesourcery.com>

	* Makefile ($(objpfx)$(multidir)): Use mkdir -p.

2006-01-03  Steven Munroe  <sjmunroe@us.ibm.com>

	* sysdeps/unix/sysv/linux/powerpc/powerpc32/sysdep-cancel.h
	(PSEUDO): Remove redundant cfi_startproc and cfi_endproc directives.
	* sysdeps/unix/sysv/linux/powerpc/powerpc64/sysdep-cancel.h: Likewise.

2006-01-04  Ulrich Drepper  <drepper@redhat.com>

	* tst-cancel24.cc: Use C headers instead of C++ headers.

2006-01-03  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/sparc/lowlevellock.h: Remove #error for
	sparc-linux configured glibc.
	(lll_futex_wake_unlock): Define to 1 for sparc-linux configured glibc.
	(__lll_mutex_trylock, __lll_mutex_cond_trylock, __lll_mutex_lock,
	__lll_mutex_cond_lock, __lll_mutex_timedlock): Use
	atomic_compare_and_exchange_val_24_acq instead of
	atomic_compare_and_exchange_val_acq.
	(lll_mutex_unlock, lll_mutex_unlock_force): Use atomic_exchange_24_rel
	instead of atomic_exchange_rel.
	* sysdeps/unix/sysv/linux/sparc/sparc32/lowlevellock.c: New file.
	* sysdeps/unix/sysv/linux/sparc/sparc32/pthread_barrier_init.c: New
	file.
	* sysdeps/unix/sysv/linux/sparc/sparc32/pthread_barrier_wait.c: New
	file.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sem_init.c: New file.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sem_post.c: New file.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sem_timedwait.c: New file.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sem_trywait.c: New file.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sem_wait.c: New file.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sparcv9/pthread_barrier_init.c:
	New file.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sparcv9/pthread_barrier_wait.c:
	New file.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sparcv9/sem_init.c: New file.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sparcv9/sem_post.c: New file.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sparcv9/sem_timedwait.c: New
	file.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sparcv9/sem_trywait.c: New
	file.
	* sysdeps/unix/sysv/linux/sparc/sparc32/sparcv9/sem_wait.c: New file.

2006-01-03  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/pthread.h [__WORDSIZE==64]: Don't use cast in
	mutex initializers.

2006-01-02  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/sparc/tls.h (tcbhead_t): Add pointer_guard field.
	(THREAD_GET_POINTER_GUARD, THREAD_SET_POINTER_GUARD,
	THREAD_COPY_POINTER_GUARD): Define.
	* sysdeps/sparc/tcb-offsets.sym (POINTER_GUARD): Define.
	* sysdeps/sparc/sparc64/jmpbuf-unwind.h: Revert 2005-12-27 changes.

2006-01-01  Ulrich Drepper  <drepper@redhat.com>

	* version.c: Update copyright year.

2005-12-29  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/unix/sysv/linux/sh/sysdep-cancel.h: Remove explicit
	.eh_frame section, use cfi_* directives.
	* sysdeps/unix/sysv/linux/sh/lowlevellock.S: Add cfi instrumentation.

2005-12-30  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/ia64/jmpbuf-unwind.h: Undo last change for
	now.

2005-12-29  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/sigaction.c: Removed.
	* sigaction.c: New file.
	* sysdeps/unix/sysv/linux/Makefile: Define CFLAGS-sigaction.c.

2005-12-28  Ulrich Drepper  <drepper@redhat.com>

	* Makefile (tests): Add tst-signal7.
	* tst-signal7.c: New file.

2005-12-27  Roland McGrath  <roland@redhat.com>

	* sysdeps/x86_64/jmpbuf-unwind.h (_jmpbuf_sp): New inline function.
	(_JMPBUF_UNWINDS_ADJ): Use it, to PTR_DEMANGLE before comparison.
	* sysdeps/alpha/jmpbuf-unwind.h: Likewise.
	* sysdeps/i386/jmpbuf-unwind.h: Likewise.
	* sysdeps/mips/jmpbuf-unwind.h: Likewise.
	* sysdeps/powerpc/jmpbuf-unwind.h: Likewise.
	* sysdeps/s390/jmpbuf-unwind.h: Likewise.
	* sysdeps/sh/jmpbuf-unwind.h: Likewise.
	* sysdeps/sparc/sparc32/jmpbuf-unwind.h: Likewise.
	* sysdeps/sparc/sparc64/jmpbuf-unwind.h: Likewise.
	* sysdeps/unix/sysv/linux/ia64/jmpbuf-unwind.h: Likewise.

2005-12-27  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/alpha/bits/pthreadtypes.h: Add __next
	and __prev field to pthread_mutex_t.
	* sysdeps/unix/sysv/linux/ia64/bits/pthreadtypes.h: Likewise.
	* sysdeps/unix/sysv/linux/powerpc/bits/pthreadtypes.h: Likewise.
	* sysdeps/unix/sysv/linux/s390/bits/pthreadtypes.h: Likewise.
	* sysdeps/unix/sysv/linux/sparc/bits/pthreadtypes.h: Likewise.
	* sysdeps/unix/sysv/linux/sh/bits/pthreadtypes.h: Add __next field
	to pthread_mutex_t.

2005-12-26  Ulrich Drepper  <drepper@redhat.com>

	* pthreadP.h: Define PTHREAD_MUTEX_ROBUST_PRIVATE_NP,
	PTHREAD_MUTEX_ROBUST_PRIVATE_RECURSIVE_NP,
	PTHREAD_MUTEX_ROBUST_PRIVATE_ERRORCHECK_NP,
	PTHREAD_MUTEX_ROBUST_PRIVATE_ADAPTIVE_NP,
	PTHREAD_MUTEXATTR_FLAG_ROBUST, PTHREAD_MUTEXATTR_FLAG_PSHARED,
	and PTHREAD_MUTEXATTR_FLAG_BITS.
	* descr.h (struct pthread): Add robust_list field and define
	ENQUEUE_MUTEX and DEQUEUE_MUTEX macros.
	* pthread_mutexattr_getrobust.c: New file.
	* pthread_mutexattr_setrobust.c: New file.
	* pthread_mutex_consistent.c: New file.
	* sysdeps/pthread/pthread.h: Declare pthread_mutexattr_getrobust,
	pthread_mutexattr_setrobust, and pthread_mutex_consistent.
	Define PTHREAD_MUTEX_STALLED_NP and PTHREAD_MUTEX_ROBUST_NP.
	Adjust pthread_mutex_t initializers.
	* nptl/sysdeps/unix/sysv/linux/i386/bits/pthreadtypes.h: Add __next
	field to pthread_mutex_t.
	* nptl/sysdeps/unix/sysv/linux/x86_64/bits/pthreadtypes.h: Add __next
	and __prev field to pthread_mutex_t.
	* Versions [GLIBC_2.4]: Export pthread_mutexattr_getrobust_np,
	pthread_mutexattr_setrobust_np, and pthread_mutex_consistent_np.
	* pthread_mutexattr_getpshared.c: Use PTHREAD_MUTEXATTR_FLAG_PSHARED
	and PTHREAD_MUTEXATTR_FLAG_BITS macros instead of magic numbers.
	* pthread_mutexattr_gettype.c: Likewise.
	* pthread_mutexattr_setpshared.c: Likewise.
	* pthread_mutexattr_settype.c: Likewise.
	* pthread_mutex_init.c: Reject robust+pshared attribute for now.
	Initialize mutex kind according to robust flag.
	* pthread_mutex_lock.c: Implement local robust mutex.
	* pthread_mutex_timedlock.c: Likewise.
	* pthread_mutex_trylock.c: Likewise.
	* pthread_mutex_unlock.c: Likewise.
	* pthread_create.c (start_thread): Mark robust mutexes which remained
	locked as dead.
	* tst-robust1.c: New file.
	* tst-robust2.c: New file.
	* tst-robust3.c: New file.
	* tst-robust4.c: New file.
	* tst-robust5.c: New file.
	* tst-robust6.c: New file.
	* tst-robust7.c: New file.
	* Makefile (libpthread-routines): Add pthread_mutexattr_getrobust,
	pthread_mutexattr_setrobust, and pthread_mutex_consistent.
	(tests): Add tst-robust1, tst-robust2, tst-robust3, tst-robust4,
	tst-robust5, tst-robust6, and tst-robust7.

	* tst-typesizes.c: New file.
	* Makefile (tests): Add tst-typesizes.

	* tst-once3.c: More debug output.

2005-12-24  Ulrich Drepper  <drepper@redhat.com>

	* pthread_mutex_trylock.c (__pthread_mutex_trylock): Add break
	missing after last change.

	* version.c: Update copyright year.

2005-12-23  Ulrich Drepper  <drepper@redhat.com>

	* pthread_mutex_destroy.c: Set mutex type to an invalid value.
	* pthread_mutex_lock.c: Return EINVAL for invalid mutex type.
	* pthread_mutex_trylock.c: Likewise.
	* pthread_mutex_timedlock.c: Likewise.
	* pthread_mutex_unlock.c: Likewise.

2005-12-22  Roland McGrath  <roland@redhat.com>

	* sysdeps/pthread/sigaction.c: Use "" instead of <> to include self,
	so that #include_next's search location is not reset to the -I..
	directory where <nptl/...> can be found.

2005-12-22  Ulrich Drepper  <drepper@redhat.com>

	[BZ #1913]
	* sysdeps/unix/sysv/linux/i386/i486/sem_wait.S (__new_sem_wait):
	Fix unwind info.  Remove useless branch prediction prefix.
	* tst-cancel24.cc: New file.
	* Makefile: Add rules to build and run tst-cancel24.

2005-12-21  Roland McGrath  <roland@redhat.com>

	* libc-cancellation.c: Use <> rather than "" #includes.
	* pt-cleanup.c: Likewise.
	* pthread_create.c: Likewise.
	* pthread_join.c: Likewise.
	* pthread_timedjoin.c: Likewise.
	* pthread_tryjoin.c: Likewise.
	* sysdeps/unix/sysv/linux/libc_pthread_init.c: Likewise.
	* sysdeps/unix/sysv/linux/register-atfork.c: Likewise.
	* sysdeps/unix/sysv/linux/unregister-atfork.c: Likewise.
	* unwind.c: Likewise.

2005-12-19  Kaz Kojima  <kkojima@rr.iij4u.or.jp>

	* sysdeps/sh/tcb-offsets.sym: Add POINTER_GUARD.
	* sysdeps/sh/tls.h (tcbhead_t): Remove private and add pointer_guard.
	(THREAD_GET_POINTER_GUARD, THREAD_SET_POINTER_GUARD,
	THREAD_COPY_POINTER_GUARD): Define.

2005-12-19  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/ia64/tls.h (TLS_PRE_TCB_SIZE): Make room for 2 uintptr_t's
	rather than one.
	(THREAD_GET_POINTER_GUARD, THREAD_SET_POINTER_GUARD,
	THREAD_COPY_POINTER_GUARD): Define.
	* sysdeps/powerpc/tcb-offsets.sym (POINTER_GUARD): Add.
	* sysdeps/powerpc/tls.h (tcbhead_t): Add pointer_guard field.
	(THREAD_GET_POINTER_GUARD, THREAD_SET_POINTER_GUARD,
	THREAD_COPY_POINTER_GUARD): Define.
	* sysdeps/s390/tcb-offsets.sym (STACK_GUARD): Add.
	* sysdeps/s390/tls.h (THREAD_GET_POINTER_GUARD,
	THREAD_SET_POINTER_GUARD, THREAD_COPY_POINTER_GUARD): Define.
	* sysdeps/unix/sysv/linux/ia64/__ia64_longjmp.S (__ia64_longjmp):
	Use PTR_DEMANGLE for B0 if defined.

2005-12-17  Ulrich Drepper  <drepper@redhat.com>

	* pthread_create.c (__pthread_create_2_1): Use
	THREAD_COPY_POINTER_GUARD if available.
	* sysdeps/i386/tcb-offsets.sym: Add POINTER_GUARD.
	* sysdeps/x86_64/tcb-offsets.sym: Likewise.
	* sysdeps/i386/tls.h (tcbhead_t): Add pointer_guard.
	Define THREAD_SET_POINTER_GUARD and THREAD_COPY_POINTER_GUARD.
	* sysdeps/x86_64/tls.h: Likewise.

2005-12-15  Roland McGrath  <roland@redhat.com>

	* sysdeps/unix/sysv/linux/mq_notify.c: Don't use sysdeps/generic.

2005-12-13  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/pthread/sigfillset.c: Adjust for files moved out of
	sysdeps/generic.
	* errno-loc.c: New file.

2005-12-12  Roland McGrath  <roland@redhat.com>

	* init.c (__pthread_initialize_minimal_internal): Do __static_tls_size
	adjustments before choosing stack size.  Update minimum stack size
	calculation to match allocate_stack change.

2005-12-12  Ulrich Drepper  <drepper@redhat.com>

	* allocatestack.c (allocate_stack): Don't demand that there is an
	additional full page available on the stack beside guard, TLS, the
	minimum stack.

2005-11-24  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/i386/bits/pthreadtypes.h
	(__cleanup_fct_attribute): Use __regparm__ not regparm.

	* sysdeps/unix/sysv/linux/x86_64/bits/pthreadtypes.h: When
	compiling 32-bit code we must define __cleanup_fct_attribute.

005-11-24  Jakub Jelinek  <jakub@redhat.com>

	[BZ #1920]
	* sysdeps/pthread/pthread.h (__pthread_unwind_next): Use
	__attribute__ instead of __attribute.
	* sysdeps/unix/sysv/linux/i386/bits/pthreadtypes.h
	(__cleanup_fct_attribute): Likewise.

2005-11-17  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/pthread/unwind-forcedunwind.c (pthread_cancel_init): Put
	a write barrier before writing libgcc_s_getcfa.

2005-11-06  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/configure: Removed.

2005-11-05  Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/ia64/pt-initfini.c: Remove trace of
	optional init_array/fini_array support.

2005-10-24  Roland McGrath  <roland@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/sem_trywait.S: Remove unnecessary
	versioned_symbol use.

2005-10-16  Roland McGrath  <roland@redhat.com>

	* init.c (__pthread_initialize_minimal_internal): Even when using a
	compile-time default stack size, apply the minimum that allocate_stack
	will require, and round up to page size.

2005-10-10  Daniel Jacobowitz  <dan@codesourcery.com>

	* Makefile ($(test-modules)): Remove static pattern rule.

2005-10-14  Jakub Jelinek  <jakub@redhat.com>
	    Ulrich Drepper  <drepper@redhat.com>

	* sysdeps/unix/sysv/linux/x86_64/pthread_once.S: Fix stack
	alignment in callback function.
	* Makefile: Add rules to build and run tst-align3.
	* tst-align3.c: New file.

2005-10-03  Jakub Jelinek  <jakub@redhat.com>

	* allocatestack.c (setxid_signal_thread): Add
	INTERNAL_SYSCALL_DECL (err).

2005-10-02  Jakub Jelinek  <jakub@redhat.com>

	* allocatestack.c (setxid_signal_thread): Need to use
	atomic_compare_and_exchange_bool_acq.

2005-10-01  Ulrich Drepper  <drepper@redhat.com>
	    Jakub Jelinek  <jakub@redhat.com>

	* descr.h: Define SETXID_BIT and SETXID_BITMASK.  Adjust
	CANCEL_RESTMASK.
	(struct pthread): Move specific_used field to avoid padding.
	Add setxid_futex field.
	* init.c (sighandler_setxid): Reset setxid flag and release the
	setxid futex.
	* allocatestack.c (setxid_signal_thread): New function.  Broken
	out of the bodies of the two loops in __nptl_setxid.  For undetached
	threads check whether they are exiting and if yes, don't send a signal.
	(__nptl_setxid): Simplify loops by using setxid_signal_thread.
	* pthread_create.c (start_thread): For undetached threads, check
	whether setxid bit is set.  If yes, wait until signal has been
	processed.

	* allocatestack.c (STACK_VARIABLES): Initialize them.
	* pthread_create.c (__pthread_create_2_1): Initialize pd.

2004-09-02  Jakub Jelinek  <jakub@redhat.com>

	* pthread_cond_destroy.c (__pthread_cond_destroy): If there are
	waiters, awake all waiters on the associated mutex.

2005-09-22  Roland McGrath  <roland@redhat.com>

	* perf.c [__x86_64__] (HP_TIMING_NOW): New macro (copied from
	../sysdeps/x86_64/hp-timing.h).

2005-08-29  Jakub Jelinek  <jakub@redhat.com>

	* sysdeps/unix/sysv/linux/powerpc/lowlevellock.h (FUTEX_WAKE_OP,
	FUTEX_OP_CLEAR_WAKE_IF_GT_ONE): Define.
	(lll_futex_wake_unlock): Define.
	* sysdeps/unix/sysv/linux/alpha/lowlevellock.h (FUTEX_WAKE_OP,
	FUTEX_OP_CLEAR_WAKE_IF_GT_ONE): Define.
	(lll_futex_wake_unlock): Define.
	* sysdeps/unix/sysv/linux/ia64/lowlevellock.h (FUTEX_WAKE_OP,
	FUTEX_OP_CLEAR_WAKE_IF_GT_ONE): Define.
	(lll_futex_wake_unlock): Define.
